--ACT/DAT/MAT EXPORTER UTIL BY HARMALARM
--build date may 21, 2011

exportname = GetSaveFileName caption:"Choose an exportname" types:"Sdf(*.Sdf)"
if exportname != undefined do
(
	sdf_name = getfilenamefile exportname +  ".Sdf"
	if sdf_name != undefined then
	(
		sdf_file = createfile sdf_name
		close sdf_file
	)
	act_name = getfilenamefile exportname + ".ACT"
	if act_name != undefined then 
	(
		act_file = createfile act_name
		close act_file
		global actorname = "undefined"
		global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
		global actorbboxmax = [1,1,1]
		global actorbboxmin	= [1,1,1]
		global modelname = "undefined"
		global actortype = 8
		global actormode = 1
	)
	dat_name = getfilenamefile exportname +".DAT"
	if dat_name != undefined then 
	(
		dat_file = createfile dat_name
		close dat_file
	)
	mat_name = getfilenamefile exportname +".MAT"
	if mat_name != undefined then 
	(
		mat_file = createfile mat_name
		close mat_file
		global matmaterial = standard()
		global matdiffuse = (color 255 255 255)
		global matambient = 0.175
		global matdirect = 1.0
		global matspecular = 0
		global matspecularlevel = 20
		global flags = 37 --standard flag value for smooth, lit and texture correct
		global identifier = "undefined.mat"
		global texture = undefined
	)

	-- first we define functions for the byteswapping needed to get a big endian byte order
	-- the following functions do this for floats, long and short bytes.
	fn floatSwap2 f = 
	(
			i = bit.floatAsInt f
			h = bit.intashex i
			while h.count < 8 do h = "0" + h
			
			s = (substring h 7 2) + (substring h 5 2) + (substring h 3 2) + (substring h 1 2)
			bit.intAsFloat (bit.hexasint s)
	)   
	fn SwapLong f = 
	(
		a = bit.swapBytes f 1 4
		b = bit.swapBytes a 2 3
		b
	)
	fn swapshort f = bit.swapBytes f 1 2
	fn writeactorbase f =
	(
		
		f=fopen act_name "ab"
		
		WriteLong f (swaplong 35) --actor name and attributes
		WriteLong f (swaplong 0)
		writebyte f (actortype)
		writebyte f (actormode)
		WriteString f (actorname as String)
		WriteLong f (swaplong 43)	 --start of the transformation matrix settings.
		WriteLong f (swaplong 48)
		actortm = matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0] * actortm * inverse(matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0])
		WriteFloat f (Floatswap2 actortm.row1.x) -- transformation matrix of the parent
		WriteFloat f (Floatswap2 actortm.row1.y)
		WriteFloat f (Floatswap2 actortm.row1.z)
		WriteFloat f (Floatswap2 actortm.row2.x)
		WriteFloat f (Floatswap2 actortm.row2.y)
		WriteFloat f (Floatswap2 actortm.row2.z)
		WriteFloat f (Floatswap2 actortm.row3.x)
		WriteFloat f (Floatswap2 actortm.row3.y)
		WriteFloat f (Floatswap2 actortm.row3.z)
		WriteFloat f (Floatswap2 actortm.row4.x)
		WriteFloat f (Floatswap2 actortm.row4.y)
		WriteFloat f (Floatswap2 actortm.row4.z)
		
		WriteLong f (swaplong 37) --unknown... no data FIGURE THIS OUT!
		Writelong f (swaplong 0)
		fclose f
		
		if actorbbox == undefined then
		(
		)
		else
		(
		f=fopen act_name "ab"	
		WriteLong f (swaplong 50) --start of bounding box
		Writelong f (swaplong 0) --lenght byte, unused

		WriteFloat f (Floatswap2 actorbboxmin.x)
		WriteFloat f (Floatswap2 actorbboxmin.y)
		WriteFloat f (Floatswap2 actorbboxmin.z)
		WriteFloat f (Floatswap2 actorbboxmax.x)
		WriteFloat f (Floatswap2 actorbboxmax.y)
		WriteFloat f (Floatswap2 actorbboxmax.z)
		fclose f
		)
		
		if modelname == undefined then -- check whether there is a model or not
		(
		)
		else
		(
			f=fopen act_name "ab"	
			Writelong f (swaplong 36)
			Writelong f (swaplong 0)
			Writestring f (modelname as String)
			fclose f
		)
		
	)
	fn writehierarchyend f =
	(
		f=fopen act_name "ab"
		Writelong f (swaplong 42) --end of group heirarchy level
		Writelong f (swaplong 0)
		fclose f
	)
	fn Writeactorhierarchystart f =
	(
		f=fopen act_name "ab"
		Writelong f (swaplong 41) --start of group hierarchy level
		Writelong f (swaplong 0)
		fclose f
	)
	fn writematerialbase f =
	(
		f=fopen mat_name "ab"
		
		WriteLong f (swaplong 60) --start of material name and attributes
		WriteLong f (swaplong 80) --lenght byte unused
		Writebyte f (matdiffuse.r) --diffuse colour
		Writebyte f (matdiffuse.g)
		Writebyte f (matdiffuse.b)
		writebyte f (255)
		Writefloat f (floatswap2 matambient) --aimbient lighting
		Writefloat f (floatswap2 matdirect) --directional lighting
		Writefloat f (floatswap2 matspecular) --specular lighting
		Writefloat f (floatswap2 matspecularlevel) --SPECUALR LEVEL DEFAULT 20

		writelong f (swaplong flags) -- flags
		WriteFloat f (floatswap2 1) --flags for mat type
		WriteFloat f (floatswap2 0)
		WriteFloat f (floatswap2 0)
		WriteFloat f (floatswap2 1)
		WriteFloat f (floatswap2 0)
		WriteFloat f (floatswap2 0)
		Writebyte f 10 --unknown 
		Writebyte f 31
		Writeshort f (swapshort 0)
		Writelong f (swaplong 0)
		Writelong f (swaplong 0)
		Writelong f (swaplong 0)
		Writebyte f 0
		WriteString f identifier
		if texture != undefinded do
		(
			Writelong f (swaplong 28)
			Writelong f (swaplong 10)
			WriteString f texture
		)
		Writelong f 0
		Writelong f 0
		fclose f
	)
	
	global hiddenmodels = #()--start of object indexing
	global exportmodels = #()
	
	global materials = #()
	for object in objects do
	(
		if classof object == line do append hiddenmodels object
		if object == rootnode.car_general_attributes.bshape1 do append hiddenmodels object
		if object.ishidden == true do append hiddenmodels object
		
		if (finditem hiddenmodels object) == 0 do 
		(
			if classof object == editable_poly do numverts = polyop.getnumverts object
			if classof object == editable_mesh do numverts = getnumverts object
			if numverts != undefined and numverts<3 then
			(
				append hiddenmodels object
			)
			else append exportmodels object
		)
	)
	
	global exportactors = exportmodels
	
	f=fopen sdf_name "wb"--empty sdf file creation.
	WriteString f ("// Stainless Data File")
	WriteString f ("// Generated by PlayThing2.")
	Writestring f ("//Created: ")
	
	Writestring f ("blabla")
	Writestring f ("NONE")
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writestring f ("File Type Identifier.")
	fclose f
	
	f=fopen act_name "wb"	--write the actor header
	WriteLong f (swaplong 18)
	WriteLong f (swaplong 8)
	WriteLong f (swaplong 1)
	WriteLong f (swaplong 2)
	fclose f
	
	--write object actors for all objects
	--find out if it is a single object or a group
	--if it is a group, it will be noncar instances.
	--if it is NOT a group, it will be a single track element.
	
	for object in exportactors do
	(
		if finditem hiddenmodels object == 0 do
		(
			if not(isgroupmember object) and not(isgrouphead object) and not(object.ishidden) do
			(
				global actorname = object.name
				--global actortm = object.transform
				global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
				global modelname = object.name
				global actorbbox = undefined
				global actortype = 1
				global actormode = 0
				writeactorbase f
				
				if object.children.count > 0 do
				(
					for i=1 to object.children.count do
					(
						child1 = object.children[i]
						if finditem hiddenmodels child1 == 0 do
						(
							global actorname = child1.name
							--global actortm = child1.transform * (inverse object.transform)
							global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
							if classof child1 == Dummy then
							(
								global modelname = undefined
								global actortype = 0
								global actormodel = 0
							)
							else
							(
								global modelname = child1.name
								global actortype = 1
								global actormode = 0
							)
							global actorbbox = undefined
							writeactorbase f
							if child1.children.count > 0 do
							(
								for j=1 to child1.children.count do
								(
									child2= child1.children [j]
									if finditem hiddenmodels child2 == 0 do
									(
										global actorname = child2.name
										global actortm = child2.transform * (inverse child1.transform)
										global modelname = child2.name
										global actorbbox = undefined
										global actortype = 1
										global actormode = 0							
										writeactorbase f
										if child2.children.count > 0 do
										(
											for k=1 to child2.children.count do
											(
												child3= child2.children [k]
												if finditem hiddenmodels child3 == 0 do
												(
													global actorname = child3.name
													global actortm = child3.transform * (inverse child2.transform)
													global modelname = child3.name
													global actorbbox = undefined
													global actortype = 1
													global actormode = 0							
													writeactorbase f
													writehierarchyend f
													append hiddenmodels child3
												)
											)
										)
										writehierarchyend f
										append hiddenmodels child2
									)
								)
							)
							writehierarchyend f
							append hiddenmodels child1
						)
					)
				)
				append hiddenmodels object
			)
		)
	)
	f=fopen act_name "ab"
	Writelong f (swaplong 0) --end of actor!
	Writelong f (swaplong 0)
	fclose f

	--DATA MODEL EXPORTER
	
	f=fopen dat_name "wb"
	WriteLong f (swaplong 18) --header of the dat file
	WriteLong f (swaplong 8)
	Writeshort f 0
	Writebyte f 250
	writebyte f 206
	WriteLong f (swaplong 2)
	fclose f
	
	for object in exportmodels do
	(
		if not(isGrouphead object) and not(object.ishidden) and not(classof object == Dummy) do
		(
			f=fopen dat_name "ab"
			
			WriteLong f (swaplong 54) --start of modelname and attributes
			Writelong f (swaplong 12)
			WriteByte f 1
			WriteByte f 21
			
			modelname = object.name
			WriteString f modelname
			
			WriteLong f (swaplong 23) --start of vertice index
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2			
			
			objecttmbackup = object.transform
			object.transform = objecttmbackup
			
			actor = snapshotasmesh object
			--actor.transform = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
			
			tvcount = getnumTverts actor
			
			if tvcount == 0 then
			(
			modelvertices = getnumverts actor
			writelong f (swaplong actor.numverts)
			for j=1 to modelvertices do
				(
					vertice = getvert actor j
					writefloat f (floatswap2 vertice.x)
					writefloat f (floatswap2 vertice.z)
					writefloat f (floatswap2 -vertice.y)
				)
			)
			
			else
			(
				verts = #()
				
				nbfaces = getNumFaces actor
				
				for i=1 to nbfaces do 
				(
					vertindices = getFace actor i
					texindices = getTVFace actor i
		
					verts[texindices.x] = getVert actor (vertindices.x)
					verts[texindices.y] = getVert actor (vertindices.y)
					verts[texindices.z] = getVert actor (vertindices.z)
				)
				nbTverts = getnumTverts actor
				Writelong f (swaplong verts.count)
				for j=1 to nbTverts do 
				(
					WriteFloat f (floatswap2 verts[j].x)
					WriteFloat f (floatswap2 verts[j].z)
					WriteFloat f (floatswap2 -verts[j].y)
				)
			)	

			Writelong f (swaplong 24) --start of texture coordinates
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
			
			tvcount = getnumTverts actor
			
			if tvcount > 0 then
			(
			WriteLong f (swaplong tvcount)
			for v=1 to tvcount do 
				(
					tvert = getTVert actor v
					WriteFloat f (floatswap2 (tvert.x))
					WriteFloat f (floatswap2 (-tvert.y))
				)
			)
			
			else
			(
				Writelong f (swaplong modelvertices)
				for v = 1 to modelvertices do
				(
					tvert  = getvert actor v
					Writefloat f (floatswap2 1)
					Writefloat f (floatswap2 1)
				)
			)
	
			Writelong f (swaplong 53) --start of faces index
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
			
			if tvcount > 0 then
			(
				nbfaces = getNumfaces actor
				writelong f (swaplong nbfaces)
				for i = 1 to nbfaces do
				(
					face = getTVFace actor i
					Writeshort f (swapshort ((face.x)-1))
					Writeshort f (swapshort ((face.y)-1))
					Writeshort f (swapshort ((face.z)-1))
					
					
					sgroup = getFaceSmoothGroup actor i
					writeshort f (swapshort(sgroup))
					-- here we define the number of edges within a polygon... lets see if it works...
					
					edgevis1 = getedgevis actor i 1
					edgevis2 = getedgevis actor i 2
					edgevis3 = getedgevis actor i 3
					
					invisibleedges = 0
					if edgevis1 == false do invisibleedges = 1
					if edgevis2 == false do invisibleedges = 2
					if edgevis1 == false and edgevis2 == false do invisibleedges = 3
					if edgevis3 == false do invisibleedges = 4
					if edgevis3 == false and edgevis1 == false do invisibleedges = 5
					if edgevis3 == false and edgevis2 == false do invisibleedges = 6
					if edgevis3 == false and edgevis2 == false and edgevis1 == false do invisibleedges = 7
					
					Writebyte f invisibleedges --quad group! how to do this!?
				)
			)
			
			else
			(
				nbfaces = getNumfaces actor
				writelong f (swaplong nbfaces)
				for i = 1 to nbfaces do
				(
					face = getFace actor i
					Writeshort f (swapshort ((face.x)-1))
					Writeshort f (swapshort ((face.y)-1))
					Writeshort f (swapshort ((face.z)-1))
					
					
					sgroup = getFaceSmoothGroup actor i
					writeshort f (swapshort(sgroup))
					-- here we define the number of edges within a polygon... lets see if it works...
					
					edgevis1 = getedgevis actor i 1
					edgevis2 = getedgevis actor i 2
					edgevis3 = getedgevis actor i 3
					
					invisibleedges = 0
					if edgevis1 == false do invisibleedges = 1
					if edgevis2 == false do invisibleedges = 2
					if edgevis1 == false and edgevis2 == false do invisibleedges = 3
					if edgevis3 == false do invisibleedges = 4
					if edgevis3 == false and edgevis1 == false do invisibleedges = 5
					if edgevis3 == false and edgevis2 == false do invisibleedges = 6
					if edgevis3 == false and edgevis2 == false and edgevis1 == false do invisibleedges = 7
					
					Writebyte f invisibleedges --quad group! how to do this!?
				)
			)
			
			matname = object.material
			
			-- from here we define what kind of material the objec thas, multi, standard or no material (for which we will make a defaultmat)
			
			if classof matname == multimaterial do
			(
				nrmultisubs = matname.numsubs
				Writelong f (swaplong 22) --start of material names
				Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
				Writelong f (swaplong nrmultisubs) --number of material names
				
				for i = 1 to nrmultisubs do
				(
					subname = matname[i].name
					WriteString f subname
				)
			)
			
			if classof matname == standardmaterial do
			(
				Writelong f (swaplong 22) --start of material names
				Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
				Writelong f (swaplong 1)
				Writestring f matname.name
			)
			
			if classof matname == undefinedclass do
			(
				writelong f (swaplong 22)
				writelong f (swaplong 0)
				writelong f (swaplong 1)
				Writestring f ((object.name + ".mat"))
			)
			
			Writelong f (swaplong 26) --start of face materials
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
			nbfaces = getNumFaces actor
			Writelong f (swaplong nbfaces)
			Writelong f (swaplong 2)
			
			for i = 1 to nbfaces do
			(
				matname = object.material
				if classof matname == multimaterial then
				(
				facematid = getfacematid actor i --get the face id
				Writeshort f (swapshort facematid)
				)
				else
				(
				writeshort f (swapshort 1)
				)
			)
			Writelong f 0 --8 null bytes after every model entry
			Writelong f 0
			fclose f
			object.transform = objecttmbackup
		)
	)

	--MATERIAL EXPORT SCRIPT PART BELOW. 

	f=fopen mat_name "wb"
	WriteLong f (swaplong 18) --header of the dat file
	WriteLong f (swaplong 8)
	WriteLong f (swaplong 5)
	WriteLong f (swaplong 2)
	fclose f
	
	for object in exportmodels do
	(
		if (isgrouphead object) do
		(
		for j = 1 to object.children.count do
			( 
				if (isgroupmember object.children[j]) do
				(
				hide object.children[j]
				)
			)
		hide object
		)

		if not(isGrouphead object) and not(object.ishidden) do
		(
			matname = object.material
			
			if classof matname == multimaterial do
			(
				nrmultisubs = matname.numsubs
				for i = 1 to nrmultisubs do
				(
					global matmaterial = getsubmtl object.material i
					
					global matdiffuse = matmaterial.diffuse
					if matmaterial.ambientmapenable == true then
					(
						global matambient = (matmaterial.ambientmapamount / 100)
					)
					else
					(
						global matambient = 0.175
					)
					global matdirect = 1.0
					if matmaterial.specularmapenable == true then
					(
						global matspecular = (matmaterial.specularmapamount /100)
					)
					else
					(
						global matspecular = 0
					)
					global matspecularlevel = 20
					global flags = 37 --standard flag value for smooth, lit and texture correct
					if matmaterial.twosided == true then 
					(
						flags = flags + 4096
					)
					global identifier = matname[i].name
					if matmaterial.diffusemap == undefined then
					(
						global texture = undefined
					)
					else
					(
						global texture = getfilenamefile matmaterial.diffusemap.filename
					)				
					writematerialbase f
				)
			)
			
			if classof matname == standardmaterial do
			(
				global matmaterial = object.material
				
				global matdiffuse = matname.diffuse
				if matname.ambientmapenable == true then
				(
					global matambient = (matname.ambientmapamount / 100)
				)
				else
				(
					global matambient = 0.175
				)
				global matdirect = 1.0
				
				if matname.specularmapenable == true then
				(
					global matspecular = (matname.specularmapamount /100)
				)
				else
				(
					global matspecular = 0
				)
				global matspecularlevel = 20
				global flags = 37 --standard flag value for smooth, lit and texture correct
				if matmaterial.twosided == true then 
					(
						flags = flags + 4096
					)
				global identifier = matname.name
				
				if matname.diffusemap == undefined then
				(
					global texture = undefined
				)
				else
				(
					global texture = getfilenamefile matname.diffusemap.filename
				)
				writematerialbase f
			)	
			
			if classof matname == undefinedclass do
			(
				global matmaterial = standard()
				
				global matdiffuse = object.wirecolor
				global matambient = 0.175
				global matdirect = 1.0
				global matspecular = 0
				global matspecularlevel = 20
				global flags = 37 --standard flag value for smooth, lit and texture correct
				if matmaterial.twosided == true then 
					(
						flags = flags + 4096
					)
				global identifier = object.name +".mat"
				global texture = undefined
				
				writematerialbase f
			)
		)
	)
)