if groove_data_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_groove_attributes.ms") quiet:true
if wam_data_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_wam_attributes.ms") quiet:true

rollout car_setup "CARMATOOLS - Car Setup"
(
	subrollout car_setup_sub "Properties" offset:[-9,0] width:352 
	button exp_txt "Export TXT" offset:[-10,645] across:3 width:100
	button exp_act "Export ACT/DAT/MAT"  offset:[0,645]dth:130
	button exp_wam "Export WAM" offset:[10,645] width:100
	on exp_act pressed do
	(
		try ( fileIn (scriptspath+"\\Carmatools\\car_exporter.ms") quiet:true   )
		catch (messagebox "Uh oh! Please re-install the script" title:"Can't run Car Export script")
	)
	on exp_txt pressed do
	(
		try ( fileIn (scriptspath+"\\Carmatools\\car_txt.ms") quiet:true   )
		catch (messagebox "Uh oh! Please re-install the script" title:"Can't run Car Export script")
	)
	on exp_wam pressed do
	(
		try ( fileIn (scriptspath+"\\Carmatools\\car_wam.ms") quiet:true   )
		catch (messagebox "Uh oh! Please re-install the script" title:"Can't run Car wam script")
	)
	
)

car_general_CA = attributes car_general_attributes 
attribID:#(0x32d94bce, 0x2d79cf98)
(
	parameters car_general_parameters 
	(
		softness_factor type:#float default:0.7
		driver_head_pos type:#point3 default:[0,0.2,0]
		driver_head_angles type:#floattab tabSize:2 tabSizeVariable:false
		mirror_pos type:#point3 default:[0,0.175,0.2]
		mirror_angle type:#float default:30
		engine_sound type:#point3 default:[5300,5301,5302]
		stealworthyness type:#integer default:1
		
		bumper_cam type:#point3 default:[0,0,0]
		cockpit_cam type:#point3 default:[0,0,0]
		
		shrapnel1 type:#color default:[255,255,255]
		shrapnel2 type:#color default:[255,255,255]
		shrapnel3 type:#color default:[255,255,255]
		
		bshape1 type:#node
		bshape1_type type:#integer default:1
		bshape2 type:#node
		bshape2_type type:#integer default:1
		bshape3 type:#node
		bshape3_type type:#integer default:1
		
		firepoint_engine type:#integer
		firepoint_transmission type:#integer
		firepoint_driver type:#integer
		firepoint_steering type:#integer
		firepoint_flbrake type:#integer
		firepoint_frbrake type:#integer
		firepoint_rlbrake type:#integer
		firepoint_rrbrake type:#integer
		firepoint_flwheel type:#integer
		firepoint_frwheel type:#integer
		firepoint_rlwheel type:#integer 
		firepoint_rrwheel type:#integer
		
		steering_wheels type:#nodetab tabSize:1 tabSizeVariable:true
		driven_wheels type:#nodetab tabSize:1 tabSizeVariable:true
		driven_wheels_diameter type:#float default:0.14
		nondriven_wheels type:#nodetab tabSize:1 tabSizeVariable:true 
		nondriven_wheels_diameter type:#float default:0.14
		
		suspensions type:#nodetab tabSize:1 tabSizeVariable:true
		suspension_types type:#inttab tabSize:1 tabSizeVariable:true
		
		minimum_turning_circle type:#float default:0.5
		brake_multiplier type:#float default:1.0
		brake_strength_multiplier type:#float default:1.0
		number_of_gears type:#integer default:6
		top_speed type:#integer default:200
		top_acceleration type:#float default:5
		
		mainbody_model type:#node
		mainbody_center type:#point3 default:[0,0,0]
		mainbody_momentum type:#point3 default:[0,0,0]
		mainbody_mass type:#float default:1.8
		mainbody_downforce type:#integer default:50
		
		flwheel_model type:#node
		fldriven type:#integer default:1
		flsuspgive type:#float default:0.01
		fldamping type:#float default:1.0
		flredux type:#float default:1.0
		flangle1 type:#float default:80.0
		flangle2 type:#float default:80.5
		fltrmultip type:#float default:2.0
		flrrest type:#float default:0.05
		
		frwheel_model type:#node
		frdriven type:#integer default:1
		frsuspgive type:#float default:0.01
		frdamping type:#float default:1.0
		frredux type:#float default:1.0
		frangle1 type:#float default:80.0
		frangle2 type:#float default:80.5
		frtrmultip type:#float default:2.0
		frrrest type:#float default:0.05
		
		rlwheel_model type:#node
		rldriven type:#integer default:2
		rlsuspgive type:#float default:0.01
		rldamping type:#float default:1.0
		rlredux type:#float default:1.0
		rlangle1 type:#float default:79.5
		rlangle2 type:#float default:80.5
		rltrmultip type:#float default:2.0
		rlrrest type:#float default:0.05
		
		rrwheel_model type:#node
		rrdriven type:#integer default:2
		rrsuspgive type:#float default:0.01
		rrdamping type:#float default:1.0
		rrredux type:#float default:1.0
		rrangle1 type:#float default:79.5
		rrangle2 type:#float default:80.5
		rrtrmultip type:#float default:2.0
		rrrrest type:#float default:0.05
		
		
		
		wam_x_min1 type:#float default:0
		wam_x_min2 type:#float default:0
		wam_x_max1 type:#float default:0
		wam_x_max2 type:#float default:0
		wam_y_min1 type:#float default:0
		wam_y_min2 type:#float default:0
		wam_y_max1 type:#float default:0
		wam_y_max2 type:#float default:0
		wam_z_min1 type:#float default:0
		wam_z_min2 type:#float default:0
		wam_z_max1 type:#float default:0
		wam_z_max2 type:#float default:0
		
		bendabillity_factor type:#float default:1
		bend_point_zmin type:#float default:-0.05
		bend_point_zmax type:#float default:0.1
		snappabillity_factor type:#float default:1
		y_split_position type:#float default:0
		driver_pos_x type:#float default:0.05
		driver_pos_y type:#float default:0.0
		driver_pos_z type:#float default:0.1
		
		temp_mainbody type:#node
		temp_flwheel type:#node
		temp_frwheel type:#node
		temp_rlwheel type:#node
		temp_rrwheel type:#node
	)
)
custattributes.add rootnode car_general_CA

rollout car_general_setup "General car setup"
(
	group "Globals"
	(
		spinner car_softness_factor "Softness factor:" fieldwidth:100
		on car_softness_factor changed val do rootnode.car_general_attributes.softness_factor = val
		spinner normal_engine_noise "Normal engine noise:" fieldwidth:100 align:#right scale:1 type:#integer
		spinner tunnel_engine_noise "Tunnel engine noise:" fieldwidth:100 align:#right scale:1 type:#integer
		spinner underwater_engine_noise "Underwater engine noise:" fieldwidth:100 align:#right scale:1 type:#integer
		on normal_engine_noise changed val do rootnode.car_general_attributes.engine_sound.x = val
		on tunnel_engine_noise changed val do rootnode.car_general_attributes.engine_sound.y = val
		on underwater_engine_noise changed val do rootnode.car_general_attributes.engine_sound.z = val
		dropdownlist car_stealworthyness items:#("stealworthy","unstealable")
		on car_stealworthyness selected i do rootnode.car_general_attributes.stealworthyness = i
	)
	
	group "Drivable Stuff"
	(
		label drive_head_pos_label "Driver head position:" across:4 offset:[65,0]
		spinner driver_head_pos_x "" offset:[44,0] width:50
		spinner driver_head_pos_y "" offset:[20,0] width:50
		spinner driver_head_pos_z "" offset:[28,0] width:50 align:#left 
		on driver_head_pos_x changed val do rootnode.car_general_attributes.driver_head_pos.x = val
		on driver_head_pos_y changed val do rootnode.car_general_attributes.driver_head_pos.y = val
		on driver_head_pos_z changed val do rootnode.car_general_attributes.driver_head_pos.z = val
		label driver_head_angles_label "Driver head angles:" across:3 offset:[55,0]
		spinner driver_head_angles_x offset:[12,0] width:76
		spinner driver_head_angles_y offset:[28,0] width:76 align:#left
		on driver_head_angles_x changed val do rootnode.car_general_attributes.driver_head_angles[1] = val
		on driver_head_angles_y changed val do rootnode.car_general_attributes.driver_head_angles[2] = val
		label mirror_pos_label "Mirror position:" across:4 offset:[65,0]
		spinner mirror_pos_x "" offset:[44,0] width:50
		spinner mirror_pos_y "" offset:[20,0] width:50
		spinner mirror_pos_z "" offset:[28,0] width:50 align:#left 
		on mirror_pos_x changed val do rootnode.car_general_attributes.mirror_pos.x = val
		on mirror_pos_y changed val do rootnode.car_general_attributes.mirror_pos.y = val
		on mirror_pos_z changed val do rootnode.car_general_attributes.mirror_pos.z = val
		spinner car_mirror_angle "Mirror angle:"
		on car_mirror_angle changed val do rootnode.car_general_attributes.mirror_angle = val
	)
	group "Damage info"
	(
		label damage_info_1 "Under construction"
	)
	group "Camera positions"
	(
		label bumper_cam_label "Bumper Camera X,Y,Z:" across:4 offset:[55,0]
		spinner bumper_camera_x "" range:[-999999,999999,0] offset:[44,0] width:50
		spinner bumper_camera_y "" range:[-999999,999999,0] offset:[20,0] width:50
		spinner bumper_camera_z "" range:[-999999,999999,0] offset:[28,0] align:#left width:50
		
		on bumper_camera_x changed val do rootnode.car_general_attributes.bumper_cam.x = val
		on bumper_camera_y changed val do rootnode.car_general_attributes.bumper_cam.y = val
		on bumper_camera_z changed val do rootnode.car_general_attributes.bumper_cam.z = val
		 
		label cockpit_cam_label "Cockpit Camera X,Y,Z:" across:4 offset:[55,0]
		spinner cockpit_camera_x "" range:[-999999,999999,0] offset:[44,0] width:50
		spinner cockpit_camera_y "" range:[-999999,999999,0] offset:[20,0] width:50
		spinner cockpit_camera_z "" range:[-999999,999999,0] offset:[28,0] align:#left width:50
		
		on cockpit_camera_x changed val do rootnode.car_general_attributes.cockpit_cam.x = val
		on cockpit_camera_y changed val do rootnode.car_general_attributes.cockpit_cam.y = val
		on cockpit_camera_z changed val do rootnode.car_general_attributes.cockpit_cam.z = val
	)
	group "Shrapnels"
	(
		colorpicker shrapnel1 "Shrapnel 1:" color:[255,255,255] modal:false align:#right autodisplay:true enabled:true across:3
		colorpicker shrapnel2 "Shrapnel 2:" color:[255,255,255] modal:false align:#right autodisplay:true enabled:true across:3
		colorpicker shrapnel3 "Shrapnel 3:" color:[255,255,255] modal:false align:#right autodisplay:true enabled:true across:3
		on shrapnel1 changed new_col do rootnode.car_general_attributes.shrapnel1 = new_col
		on shrapnel2 changed new_col do rootnode.car_general_attributes.shrapnel2 = new_col
		on shrapnel3 changed new_col do rootnode.car_general_attributes.shrapnel3 = new_col
	)
	group "Bounding shapes"
	(
		pickbutton b_shape_1 "Pick Shape 1" across:3 width:130 align:#left
		label b_shape_1_label "Use as:" offset:[0,4]
		dropdownlist b_shape_1_type "" items:#("Polyhedron","Sphere","wireframe") width:130 align:#right enabled:false
		pickbutton b_shape_2 "Pick Shape 2" across:3 width:130 align:#left
		label b_shape_2_label "Use as:" offset:[0,4]
		dropdownlist b_shape_2_type "" items:#("Polyhedron","Sphere","wireframe") width:130 align:#right enabled:false
		pickbutton b_shape_3 "Pick Shape 3" across:3 width:130 align:#left
		label b_shape_3_label "Use as:" offset:[0,4]
		dropdownlist b_shape_3_type "" items:#("Polyhedron","Sphere","wireframe") width:130 align:#right enabled:false
		
		on b_shape_1 picked obj do 
		(
			rootnode.car_general_attributes.bshape1 = obj
			b_shape_1.text = obj.name
			b_shape_1_type.enabled = true
		)
		on b_shape_1 rightclick do 
		(
			rootnode.car_general_attributes.bshape1 = undefined
			b_shape_1.text = "Pick Shape 1"
			b_shape_1_type.enabled = false
		)
		on b_shape_1_type selected i do rootnode.car_general_attributes.bshape1_type = i
		on b_shape_2 picked obj do 
		(
			rootnode.car_general_attributes.bshape2 = obj
			b_shape_2.text = obj.name
			b_shape_2_type.enabled = true
		)
		on b_shape_2 rightclick do 
		(
			rootnode.car_general_attributes.bshape2 = undefined
			b_shape_2.text = "Pick Shape 2"
			b_shape_2_type.enabled = false
		)
		on b_shape_2_type selected i do rootnode.car_general_attributes.bshape2_type = i
		on b_shape_3 picked obj do 
		(
			rootnode.car_general_attributes.bshape3 = obj
			b_shape_3.text = obj.name
			b_shape_3_type.enabled = true
		)
		on b_shape_3 rightclick do 
		(
			rootnode.car_general_attributes.bshape3 = undefined
			b_shape_3.text = "Pick Shape 3"
			b_shape_3_type.enabled = false
		)
		on b_shape_3_type selected i do rootnode.car_general_attributes.bshape3_type = i
	)
	group "Fire Points"
	(
		edittext firepoint_engine "Engine:" across:4 fieldwidth:30 align:#right
		edittext firepoint_transmission "Transm.:"  fieldwidth:30 align:#right
		edittext firepoint_driver "Driver:"  fieldwidth:30 align:#right
		edittext firepoint_steering "Steering:"  fieldwidth:30 align:#right
		edittext firepoint_flbrake "FL br.:" across:4 fieldwidth:30 align:#right
		edittext firepoint_frbrake "FR br.:" fieldwidth:30 align:#right
		edittext firepoint_rlbrake "RL br.:" fieldwidth:30 align:#right
		edittext firepoint_rrbrake "RR br.:" fieldwidth:30 align:#right
		edittext firepoint_flwheel"FL whl:" across:4 fieldwidth:30 align:#right
		edittext firepoint_frwheel "FR whl:" fieldwidth:30 align:#right
		edittext firepoint_rlwheel "RL whl:" fieldwidth:30 align:#right 
		edittext firepoint_rrwheel "RR whl:" fieldwidth:30 align:#right
		
		on firepoint_engine entered txt do rootnode.car_general_attributes.firepoint_engine = txt as integer
		on firepoint_transmission entered txt do rootnode.car_general_attributes.firepoint_transmission = txt as integer
		on firepoint_driver entered txt do rootnode.car_general_attributes.firepoint_driver = txt as integer
		on firepoint_steering entered txt do rootnode.car_general_attributes.firepoint_steering = txt as integer
		on firepoint_flbrake entered txt do rootnode.car_general_attributes.firepoint_flbrake = txt as integer
		on firepoint_frbrake entered txt do rootnode.car_general_attributes.firepoint_frbrake = txt as integer
		on firepoint_rlbrake entered txt do rootnode.car_general_attributes.firepoint_rlbrake = txt as integer
		on firepoint_rrbrake entered txt do rootnode.car_general_attributes.firepoint_rrbrake = txt as integer
		on firepoint_flwheel entered txt do rootnode.car_general_attributes.firepoint_flwheel = txt as integer
		on firepoint_frwheel entered txt do rootnode.car_general_attributes.firepoint_frwheel = txt as integer
		on firepoint_rlwheel entered txt do rootnode.car_general_attributes.firepoint_rlwheel = txt as integer
		on firepoint_rrwheel entered txt do rootnode.car_general_attributes.firepoint_rrwheel = txt as integer
		
	)
	
	on car_general_setup open do
	(
		car_softness_factor.range = [0,2,rootnode.car_general_attributes.softness_factor as float]
		normal_engine_noise.range = [0,9999,rootnode.car_general_attributes.engine_sound.x as integer]
		tunnel_engine_noise.range = [0,9999,rootnode.car_general_attributes.engine_sound.y as integer]
		underwater_engine_noise.range = [0,9999,rootnode.car_general_attributes.engine_sound.z as integer]
		car_stealworthyness.selection =  rootnode.car_general_attributes.stealworthyness as integer
		
		driver_head_pos_x.range = [-999999,999999,rootnode.car_general_attributes.driver_head_pos.x as float]
		driver_head_pos_y.range = [-999999,999999,rootnode.car_general_attributes.driver_head_pos.y as float]
		driver_head_pos_z.range = [-999999,999999,rootnode.car_general_attributes.driver_head_pos.z as float]
		driver_head_angles_x.range = [-90,90,rootnode.car_general_attributes.driver_head_angles[1] as float]
		driver_head_angles_y.range = [-90,90,rootnode.car_general_attributes.driver_head_angles[2] as float]
		mirror_pos_x.range = [-999999,999999,rootnode.car_general_attributes.mirror_pos.x as float]
		mirror_pos_y.range = [-999999,999999,rootnode.car_general_attributes.mirror_pos.y as float]
		mirror_pos_z.range = [-999999,999999,rootnode.car_general_attributes.mirror_pos.z as float]
		car_mirror_angle.range = [-90,90,rootnode.car_general_attributes.mirror_angle as float]
		
		bumper_camera_x.range = [-999999,999999,rootnode.car_general_attributes.bumper_cam.x as float]
		bumper_camera_y.range = [-999999,999999,rootnode.car_general_attributes.bumper_cam.y as float]
		bumper_camera_z.range = [-999999,999999,rootnode.car_general_attributes.bumper_cam.z as float]
		
		cockpit_camera_x.range = [-999999,999999,rootnode.car_general_attributes.cockpit_cam.x as float]
		cockpit_camera_y.range = [-999999,999999,rootnode.car_general_attributes.cockpit_cam.y as float]
		cockpit_camera_z.range = [-999999,999999,rootnode.car_general_attributes.cockpit_cam.z as float]
		
		shrapnel1.color = rootnode.car_general_attributes.shrapnel1
		shrapnel2.color = rootnode.car_general_attributes.shrapnel2
		shrapnel3.color = rootnode.car_general_attributes.shrapnel3
		
		firepoint_engine.text = rootnode.car_general_attributes.firepoint_engine as string
		firepoint_transmission.text = rootnode.car_general_attributes.firepoint_transmission as string
		firepoint_driver.text = rootnode.car_general_attributes.firepoint_driver as string
		firepoint_steering.text = rootnode.car_general_attributes.firepoint_steering as string
		firepoint_flbrake.text =  rootnode.car_general_attributes.firepoint_flbrake  as string
		firepoint_frbrake.text =  rootnode.car_general_attributes.firepoint_frbrake  as string
		firepoint_rlbrake.text =  rootnode.car_general_attributes.firepoint_rlbrake  as string
		firepoint_rrbrake.text =  rootnode.car_general_attributes.firepoint_rrbrake  as string
		firepoint_flwheel.text =  rootnode.car_general_attributes.firepoint_flwheel as string
		firepoint_frwheel.text = rootnode.car_general_attributes.firepoint_frwheel  as string
		firepoint_rlwheel.text =  rootnode.car_general_attributes.firepoint_rlwheel  as string
		firepoint_rrwheel.text =  rootnode.car_general_attributes.firepoint_rrwheel  as string
		
		
		bshape1 = rootnode.car_general_attributes.bshape1
		if bshape1 != undefined do
		(
			b_shape_1.text = bshape1.name
			b_shape_1_type.enabled = true
			b_shape_1_type.selection = rootnode.car_general_attributes.bshape1_type
		)
		bshape2 = rootnode.car_general_attributes.bshape2
		if bshape2 != undefined do
		(
			b_shape_2.text = bshape2.name
			b_shape_2_type.enabled = true
			b_shape_2_type.selection = rootnode.car_general_attributes.bshape2_type
		)
		bshape3 = rootnode.car_general_attributes.bshape3
		if bshape3 != undefined do
		(
			b_shape_3.text = bshape3.name
			b_shape_3_type.enabled = true
			b_shape_3_type.selection = rootnode.car_general_attributes.bshape3_type
		)
	)
)

rollout groovyfunkref "GroovyFunkRef"
(
	group "About"
	(
		label groovyfunkref1 "This section is designed for making references to controlled" align:#left
		label groovyfunkref2 "grooves and Funks. Use it wisely ;)" align:#left
	)
	
	group "Steerable grooves reference:"
	(
		listbox steerable_list "Objects:" fieldwidth:50 height:4 across:2 items:#("new wheel")
		pickbutton steerable_add "Add new object" across:2 width:150 align:#right offset:[0,15]
		button steerable_remove "Remove current object" width:150 align:#right offset:[-1,-38]
		label groovyfunkrefspace1 ""
		label groovyfunkrefspace1b ""
	)
	
	group "Driven/non-Driven grooves reference"
	(
		listbox driveable_list "Driven:" height:4 fieldwidth:50 across:2 items:#("new wheel")
		listbox nondriveable_list "non-Driven:" height:4 fieldwidth:50 items:#("new wheel")
		pickbutton driveable_add "Add" across:2 width:150 align:#left
		pickbutton nondriveable_add "Add" width:150 align:#right
		button driveable_remove "Remove" width:150 align:#left across:2
		button nondriveable_remove "Remove" width:150 align:#right
		spinner driveable_diameter "Diameter:" range:[0,999999,0.14] scale:0.01 across:2
		on driveable_diameter changed val do rootnode.car_general_attributes.driven_wheels_diameter = val
		spinner nondriveable_diameter "Diameter:" range:[0,999999,0.14] scale:0.01
		on nondriveable_diameter changed val do rootnode.car_general_attributes.nondriven_wheels_diameter = val
	)
	
	group "Suspension parts GroovyFunk refs."
	(
		listbox suspension_list "Suspensions:" height:6 fieldwidth:50 across:2 items:#("new suspension")
		dropdownlist suspension_types "Group type" width:150 align:#right items:#("Front/Left","Front/Right","Rear/Left","Rear/Right")
		pickbutton suspension_add "Add part" align:#right width:150 offset:[0,-60]
		button suspension_remove "Remove part" width:150 align:#right
		label spg_label1 ""
	)
	
	on steerable_list selected i do 
	(
		try steerable_pick.text = rootnode.car_general_attributes.steering_wheels[i].name
		catch()
	)
	
	on steerable_add picked obj do
	(
		if obj != undefined do
		(
			custAttributes.add obj groove_data_CA
			obj.groove_data.groove_lollipop_param = 1
			obj.groove_data.groove_distance_param = 2
			
			obj.groove_data.groove_animation_type_param = 3
			obj.groove_data.groove_animation_mode_param = 5
			obj.groove_data.groove_animation_centre_x_param = obj.center.x
			obj.groove_data.groove_animation_centre_y_param = obj.center.y
			obj.groove_data.groove_animation_centre_z_param = obj.center.z
			obj.groove_data.groove_animation_axis_param = 2
			
			if (finditem rootnode.car_general_attributes.steering_wheels obj) == 0 do
			(
				if rootnode.car_general_attributes.steering_wheels.count == 1 then
				(
					if rootnode.car_general_attributes.steering_wheels[1] == undefined then
					(
						rootnode.car_general_attributes.steering_wheels[1] = obj
					)
					else append rootnode.car_general_attributes.steering_wheels obj
				)
				else
				(
					append rootnode.car_general_attributes.steering_wheels obj
				)
				steering_wheels = #()
				for i=1 to rootnode.car_general_attributes.steering_wheels.count do
				(
					steering_wheels[i] = rootnode.car_general_attributes.steering_wheels[i].name
					
				)
				steerable_list.items = steering_wheels
				steerable_list.selection = steering_wheels.count
			)
		)
	)
	
	on steerable_remove pressed do
	(
		selected_wheel = steerable_list.selection
		try deleteitem rootnode.car_general_attributes.steering_wheels selected_wheel
		catch ()
		
		steering_wheels = #()
		for i=1 to rootnode.car_general_attributes.steering_wheels.count do
		(
			steering_wheels[i] = rootnode.car_general_attributes.steering_wheels[i].name
		)
		steerable_list.items = steering_wheels
		steerable_list.selection = steering_wheels.count
	)
	
	
	on driveable_list selected i do 
	(
		try driveable_pick.text = rootnode.car_general_attributes.driven_wheels[i].name
		catch()
	)
	on driveable_add picked obj do
	(
		if obj != undefined do
		(
			custAttributes.add obj groove_data_CA
			obj.groove_data.groove_lollipop_param = 1
			obj.groove_data.groove_distance_param = 2
			
			obj.groove_data.groove_animation_type_param = 2
			obj.groove_data.groove_animation_mode_param = 6
			obj.groove_data.groove_animation_centre_x_param = obj.center.x
			obj.groove_data.groove_animation_centre_y_param = obj.center.y
			obj.groove_data.groove_animation_centre_z_param = obj.center.z
			obj.groove_data.groove_animation_axis_param = 1
			
			if (finditem rootnode.car_general_attributes.nondriven_wheels obj) != 0 do
			(
				if yesnocancelbox "Convert nonDriven wheel to Driven wheel?" title:"Wheel already nonDriven!" beep:false == #yes then
				(
					deleteitem rootnode.car_general_attributes.nondriven_wheels (finditem rootnode.car_general_attributes.nondriven_wheels obj)
					nondriven_wheels = #()
					for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
					(
						nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
					)
					nondriveable_list.items = nondriven_wheels
					nondriveable_list.selection = nondriven_wheels.count
				)
			)
			
			if (finditem rootnode.car_general_attributes.driven_wheels obj) == 0 do
			(
				if rootnode.car_general_attributes.driven_wheels[1] != undefined then
				(
					append rootnode.car_general_attributes.driven_wheels obj
				)
				else
				(
					rootnode.car_general_attributes.driven_wheels[1] = obj
				)
				driven_wheels = #()
				for i=1 to rootnode.car_general_attributes.driven_wheels.count do
				(
					driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
				)
				driveable_list.items = driven_wheels
				driveable_list.selection = driven_wheels.count
			)
		)
	)
	
	on driveable_remove pressed do
	(
		selected_wheel = driveable_list.selection
		try deleteitem rootnode.car_general_attributes.driven_wheels selected_wheel
		catch ()
		driven_wheels = #()
		for i=1 to rootnode.car_general_attributes.driven_wheels.count do
		(
			driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
		)
		driveable_list.items = driven_wheels
		driveable_list.selection = driven_wheels.count
	)
	
	on drivable_diameter changed val do rootnode.car_general_attributes.driven_wheels_diameter = val
	
	
	on nondriveable_list selected i do 
	(
		try nondriveable_pick.text = rootnode.car_general_attributes.nondriven_wheels[i].name
		catch()
	)
		
	on nondriveable_add picked obj do
	(
		if obj != undefined do
		(
			custAttributes.add obj groove_data_CA
			obj.groove_data.groove_lollipop_param = 1
			obj.groove_data.groove_distance_param = 2
			
			obj.groove_data.groove_animation_type_param = 2
			obj.groove_data.groove_animation_mode_param = 6
			obj.groove_data.groove_animation_centre_x_param = obj.center.x
			obj.groove_data.groove_animation_centre_y_param = obj.center.y
			obj.groove_data.groove_animation_centre_z_param = obj.center.z
			obj.groove_data.groove_animation_axis_param = 1
			
			if (finditem rootnode.car_general_attributes.driven_wheels obj) != 0 do
			(
				if yesnocancelbox "Convert Driven wheel to nonDriven wheel?" title:"Wheel already Driven!" beep:false == #yes then
				(
					deleteitem rootnode.car_general_attributes.driven_wheels (finditem rootnode.car_general_attributes.driven_wheels obj)
					driven_wheels = #()
					for i=1 to rootnode.car_general_attributes.driven_wheels.count do
					(
						driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
					)
					driveable_list.items = driven_wheels
					driveable_list.selection = driven_wheels.count
				)
			)
			
			if (finditem rootnode.car_general_attributes.nondriven_wheels obj) == 0 do
			(
				if rootnode.car_general_attributes.nondriven_wheels[1] != undefined then
				(
					append rootnode.car_general_attributes.nondriven_wheels obj
				)
				else
				(
					rootnode.car_general_attributes.nondriven_wheels[1] = obj
				)
				nondriven_wheels = #()
				for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
				(
					nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
				)
				nondriveable_list.items = nondriven_wheels
				nondriveable_list.selection = nondriven_wheels.count
			)
		)
	)
	
	on nondriveable_remove pressed do
	(
		selected_wheel = nondriveable_list.selection
		try deleteitem rootnode.car_general_attributes.nondriven_wheels selected_wheel
		catch ()
		nondriven_wheels = #()
		for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
		(
			nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
		)
		nondriveable_list.items = nondriven_wheels
		nondriveable_list.selection = nondriven_wheels.count
	)
	
	on nondriveable_diameter changed val do rootnode.car_general_attributes.nondriven_wheels_diameter = val

	on suspension_list selected i do 
	(
		try suspension_pick.text = rootnode.car_general_attributes.suspensions[i].name
		catch()
		cst = rootnode.car_general_attributes.suspension_types[i]
		suspension_types.selection = cst
	)
	
	on suspension_add picked obj do
	(
		if obj != undefined do
		(
			custAttributes.add obj groove_data_CA
			obj.groove_data.groove_lollipop_param = 1
			obj.groove_data.groove_distance_param = 2
			
			obj.groove_data.groove_path_type_param = 2
			obj.groove_data.groove_path_mode_param = 4
			obj.groove_data.groove_path_center_X_param = 0.0
			obj.groove_data.groove_path_center_Y_param = 0.0
			obj.groove_data.groove_path_center_Z_param = 0.0
			obj.groove_data.groove_path_extent_X_param = 0.0
			obj.groove_data.groove_path_extent_Y_param = 1
			obj.groove_data.groove_path_extent_Z_param = 0.0

	
			if (finditem rootnode.car_general_attributes.suspensions obj) == 0 do
			(
				if rootnode.car_general_attributes.suspensions[1] != undefined then
				(
					append rootnode.car_general_attributes.suspensions obj
					append rootnode.car_general_attributes.suspension_types 1
				)
				else
				(
					rootnode.car_general_attributes.suspensions[1] = obj
					rootnode.car_general_attributes.suspension_types[1] = 1
				)
				suspensions = #()
				for i=1 to rootnode.car_general_attributes.suspensions.count do
				(
					if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
					else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
				)
				suspension_list.items = suspensions
				suspension_list.selection = suspensions.count
				suspension_types.selection = 0
			)
		)
	)
	
	on suspension_remove pressed do
	(
		selected_suspension = suspension_list.selection
		try deleteitem rootnode.car_general_attributes.suspensions selected_suspension catch()
		try deleteitem rootnode.car_general_attributes.suspension_types selected_suspension catch()
		suspensions = #()
		for i=1 to rootnode.car_general_attributes.suspensions.count do
		(
			if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
			else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
		)
		suspension_list.items = suspensions
		suspension_list.selection = suspensions.count
		try 
		(
			cst = rootnode.car_general_attributes.suspension_types[suspensions.count] 
			suspension_types.selection = cst
		)
		catch()
	)
	
	on suspension_types selected item do 
	(
		current_suspension = suspension_list.selection
		rootnode.car_general_attributes.suspension_types[current_suspension] = item
	)
	
	
	on car_general_setup open do
	(
		car_softness_factor.range = [0,2,(rootnode.car_general_attributes.softness_factor)]
		driver_head_pos_x.range = [-999999,999999,rootnode.car_general_attributes.driver_head_pos.x]
		driver_head_pos_y.range = [-999999,999999,rootnode.car_general_attributes.driver_head_pos.y]
		driver_head_pos_z.range = [-999999,999999,rootnode.car_general_attributes.driver_head_pos.z]
		driver_head_angles_x.range = [-999999,999999,rootnode.car_general_attributes.driver_head_angles[1]]
		driver_head_angles_y.range = [-999999,999999,rootnode.car_general_attributes.driver_head_angles[2]]
		mirror_pos_x.range = [-999999,999999,rootnode.car_general_attributes.mirror_pos.x]
		mirror_pos_y.range = [-999999,999999,rootnode.car_general_attributes.mirror_pos.y]
		mirror_pos_z.range = [-999999,999999,rootnode.car_general_attributes.mirror_pos.z]
		car_mirror_angle.range = [0,360,(rootnode.car_general_attributes.mirror_angle)]
		normal_engine_noise.range = [0,9999,rootnode.car_general_attributes.engine_sound.x]
		tunnel_engine_noise.range = [0,9999,rootnode.car_general_attributes.engine_sound.y]
		underwater_engine_noise.range = [0,9999,rootnode.car_general_attributes.engine_sound.z]
	)
	on groovyfunkref open do
	(
		steering_wheels = #()
		for i=1 to rootnode.car_general_attributes.steering_wheels.count do
		(
			if rootnode.car_general_attributes.steering_wheels[i] == undefined then steering_wheels[1] = "No steering wheels set"
			else steering_wheels[i] = rootnode.car_general_attributes.steering_wheels[i].name
		)
		steerable_list.items = steering_wheels
		
		driven_wheels = #()
		for i=1 to rootnode.car_general_attributes.driven_wheels.count do
		(
			if rootnode.car_general_attributes.driven_wheels[i] == undefined then driven_wheels[1] = "No Driven wheels set"
			else driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
		)
		driveable_list.items = driven_wheels
		driveable_diameter.range = [0,999999,(rootnode.car_general_attributes.driven_wheels_diameter as float)]
		
		nondriven_wheels = #()
		for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
		(
			if rootnode.car_general_attributes.nondriven_wheels[i] == undefined then nondriven_wheels[1] = "No nonDriven wheels set"
			else nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
		)
		nondriveable_list.items = nondriven_wheels
		nondriveable_diameter.range = [0,999999,(rootnode.car_general_attributes.nondriven_wheels_diameter as float)]
		
		suspensions = #()
		for i=1 to rootnode.car_general_attributes.suspensions.count do
		(
			if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
			else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
		)
		suspension_list.items = suspensions
	)
)

rollout Mechanics_stuff "Mechanics Stuff"
(
	group "about"
	(
		label mechanics1 "The objects below are only used for position referencing" align:#left
		label mechanics2 "There always need to be 2 steerable and 2 drivable wheels" align:#left
	)
	group "Body"
	(
		spinner minimum_turning_circle "Minimum turning circle:" range:[0,999999,0.5] fieldwidth:50 align:#right offset:[-60,0]
		spinner	brake_multiplier "Brake multiplier:" range:[0,999999,1.0] fieldwidth:50 align:#right offset:[-60,0]
		spinner	brake_strength_multiplier "Brake strength multiplier:" range:[0,999999,1.0] fieldwidth:50 align:#right offset:[-60,0]
		spinner	number_of_gears "Number of gears:" range:[0,10,5]  fieldwidth:50 align:#right offset:[-60,0]
		spinner	top_speed "Top speed:" range:[0,999999,200] fieldwidth:50 align:#right offset:[-60,0]
		spinner	top_acceleration "Top gear acceleration" range:[0,999999,5] fieldwidth:50 align:#right offset:[-60,0]
		
		pickbutton Body_pick "Pick Body" width:200 offset:[0,20]
		label body_mass_centre "Centre X,Y,Z:"
		spinner Body_centre_x "" range:[-999999,999999,0] scale:0.01 fieldwidth:50 offset:[12,0] across:3
		spinner Body_centre_y "" range:[-999999,999999,0.07] scale:0.01 fieldwidth:50 offset:[-20,0] 
		spinner Body_centre_z "" range:[-999999,999999,0] scale:0.01 fieldwidth:50 offset:[-55,0] 
		spinner Body_mass "Mass:" range:[0,999999,1.8] scale:0.1 fieldwidth:50 offset:[-55,0]
		label body_momentum "Momentum X,Y,Z:"
		spinner Body_momentum_x "" range:[-999999,999999,0.32] scale:0.01 fieldwidth:50 offset:[12,0] across:3
		spinner Body_momentum_y "" range:[-999999,999999,0.27] scale:0.01 fieldwidth:50 offset:[-20,0] 
		spinner Body_momentum_z "" range:[-999999,999999,0.8] scale:0.01 fieldwidth:50 offset:[-55,0] 
		spinner Body_Downforce "Downforce:" range:[0,999999,120] scale:1 fieldwidth:50 offset:[-55,0]

		on Body_mass changed val do rootnode.car_general_attributes.mainbody_mass = val
		on Body_Downforce changed val do rootnode.car_general_attributes.mainbody_downforce = val
		
		on minimum_turning_circle changed val do rootnode.car_general_attributes.minimum_turning_circle = val
		on brake_multiplier changed val do rootnode.car_general_attributes.brake_multiplier = val
		on brake_strength_multiplier changed val do rootnode.car_general_attributes.brake_strength_multiplier = val
		on number_of_gears changed val do rootnode.car_general_attributes.number_of_gears = val
		on top_speed changed val do rootnode.car_general_attributes.top_speed = val
		on top_acceleration changed val do rootnode.car_general_attributes.top_acceleration = val
	)

	pickbutton FL_wheel "Pick FL" width:142 offset:[-10,20] across:2
	pickbutton FR_wheel "Pick FR" width:142 offset:[10,20]
	dropdownlist FL_steerdrive "" items:#("Steerable","Driveable") width:142 across:2 offset:[-2,0]
	dropdownlist FR_steerdrive "" items:#("Steerable","Driveable") width:142 offset:[17,0]
	spinner FL_suspgive "Suspension give:" range:[0,1,0.0085] scale:0.0001 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner FR_suspgive "Suspension give:" range:[0,1,0.0085] scale:0.0001 fieldwidth:50 align:#right offset:[2,0]
	spinner FL_damping "Damping factor:" range:[0,5,1.15] scale:0.01 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner FR_damping "Damping factor:" range:[0,5,1.15] scale:0.01 fieldwidth:50 align:#right offset:[2,0]
	spinner FL_redux "Slipping friction:" range:[0,1,1] scale:0.01 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner FR_redux "Slipping friction:" range:[0,1,1] scale:0.01 fieldwidth:50 align:#right offset:[2,0]
	label FL_angles "Friction angles:"  align:#right offset:[-16,0] across:2
	label FR_angles "Slipping friction:" align:#right offset:[2,0]
	spinner FL_angle1 "" range:[0,90,80] scale:0.5 fieldwidth:50 across:4 align:#right offset:[-16,0]
	spinner FL_angle2 "" range:[0,90,80.5] scale:0.5 fieldwidth:50 align:#right offset:[-16,0]
	spinner FR_angle1 "" range:[0,90,80] scale:0.5 fieldwidth:50 align:#right offset:[2,0]
	spinner FR_angle2 "" range:[0,90,80.5] scale:0.5 fieldwidth:50 align:#right offset:[2,0]
	spinner FL_trmultip "Traction mult.:" range:[0,10,2] scale:0.1 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner FR_trmultip "Traction mult.:" range:[0,10,2] scale:0.1 fieldwidth:50 align:#right offset:[2,0]
	spinner FL_rrest "Rolling resist.:" range:[0,10,0.025] scale:0.005 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner FR_rrest "Rolling resist.:" range:[0,10,0.025] scale:0.005 fieldwidth:50 align:#right offset:[2,0]
	
	on FL_steerdrive selected i do rootnode.car_general_attributes.fldriven = i
	on FL_suspgive changed val do rootnode.car_general_attributes.flsuspgive = val
	on FL_damping changed val do rootnode.car_general_attributes.fldamping = val
	on FL_redux changed val do rootnode.car_general_attributes.flredux = val
	on FL_angle1 changed val do rootnode.car_general_attributes.flangle1 = val
	on FL_angle2 changed val do rootnode.car_general_attributes.flangle2 = val
	on FL_trmultip changed val do rootnode.car_general_attributes.fltrmultip = val
	on FL_rrest changed val do rootnode.car_general_attributes.flrrest = val
	
	on FR_steerdrive selected i do rootnode.car_general_attributes.frdriven = i
	on FR_suspgive changed val do rootnode.car_general_attributes.frsuspgive = val
	on FR_damping changed val do rootnode.car_general_attributes.frdamping = val
	on FR_redux changed val do rootnode.car_general_attributes.frredux = val
	on FR_angle1 changed val do rootnode.car_general_attributes.frangle1 = val
	on FR_angle2 changed val do rootnode.car_general_attributes.frangle2 = val
	on FR_trmultip changed val do rootnode.car_general_attributes.frtrmultip = val
	on FR_rrest changed val do rootnode.car_general_attributes.frrrest = val
	
	groupbox wheel_entry_1 "Front Left"  pos:[6,385] width:150 height:230 across:2 
	groupbox wheel_entry_2 "Front Right" pos:[181,385]width:150 height:230
	
	pickbutton RL_wheel "Pick RL" width:142 offset:[-10,20] across:2
	pickbutton RR_wheel "Pick RR" width:142 offset:[10,20]
	dropdownlist RL_steerdrive "" items:#("Steerable","Driveable") selection:2 width:142 across:2 offset:[-2,0]
	dropdownlist RR_steerdrive "" items:#("Steerable","Driveable") selection:2 width:142 offset:[17,0]
	spinner RL_suspgive "Suspension give:" range:[0,1,0.0085] scale:0.0001 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner RR_suspgive "Suspension give:" range:[0,1,0.0085] scale:0.0001 fieldwidth:50 align:#right offset:[2,0]
	spinner RL_damping "Damping factor:" range:[0,5,1.2] scale:0.01 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner RR_damping "Damping factor:" range:[0,5,1.2] scale:0.01 fieldwidth:50 align:#right offset:[2,0]
	spinner RL_redux "Slipping friction:" range:[0,1,1] scale:0.01 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner RR_redux "Slipping friction:" range:[0,1,1] scale:0.01 fieldwidth:50 align:#right offset:[2,0]
	label RL_angles "Friction angles:"  align:#right offset:[-16,0] across:2
	label RR_angles "Slipping friction:" align:#right offset:[2,0]
	spinner RL_angle1 "" range:[0,90,79.5] scale:0.5 fieldwidth:50 across:4 align:#right offset:[-16,0]
	spinner RL_angle2 "" range:[0,90,80.5] scale:0.5 fieldwidth:50 align:#right offset:[-16,0]
	spinner RR_angle1 "" range:[0,90,79.5] scale:0.5 fieldwidth:50 align:#right offset:[2,0]
	spinner RR_angle2 "" range:[0,90,80.5] scale:0.5 fieldwidth:50 align:#right offset:[2,0]
	spinner RL_trmultip "Traction mult.:" range:[0,10,2] scale:0.1 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner RR_trmultip "Traction mult.:" range:[0,10,2] scale:0.1 fieldwidth:50 align:#right offset:[2,0]
	spinner RL_rrest "Rolling resist.:" range:[0,10,0.025] scale:0.005 fieldwidth:50 across:2 align:#right offset:[-16,0]
	spinner RR_rrest "Rolling resist.:" range:[0,10,0.025] scale:0.005 fieldwidth:50 align:#right offset:[2,0]
	
	on RL_steerdrive selected i do rootnode.car_general_attributes.rldriven = i
	on RL_suspgive changed val do rootnode.car_general_attributes.rsuspgive = val
	on RL_damping changed val do rootnode.car_general_attributes.rldamping = val
	on RL_redux changed val do rootnode.car_general_attributes.rlredux = val
	on RL_angle1 changed val do rootnode.car_general_attributes.rlangle1 = val
	on RL_angle2 changed val do rootnode.car_general_attributes.rlangle2 = val
	on RL_trmultip changed val do rootnode.car_general_attributes.rltrmultip = val
	on RL_rrest changed val do rootnode.car_general_attributes.rlrrest = val
	
	on RR_steerdrive selected i do rootnode.car_general_attributes.rrdriven = i	
	on RR_suspgive changed val do rootnode.car_general_attributes.rrsuspgive = val
	on RR_damping changed val do rootnode.car_general_attributes.rrdamping = val
	on RR_redux changed val do rootnode.car_general_attributes.rrredux = val
	on RR_angle1 changed val do rootnode.car_general_attributes.rrangle1 = val
	on RR_angle2 changed val do rootnode.car_general_attributes.rrangle2 = val
	on RR_trmultip changed val do rootnode.car_general_attributes.rrtrmultip = val
	on RR_rrest changed val do rootnode.car_general_attributes.rrrrest = val
	
	groupbox wheel_entry_3 "Rear Left"  pos:[6,620] width:150 height:230 across:2 
	groupbox wheel_entry_4 "Rear Right" pos:[181,620]width:150 height:230
	
	on FL_wheel picked obj do
	(
		FL_wheel.text = obj.name
		rootnode.car_general_attributes.flwheel_model = obj
	)
	on FL_wheel rightclick do
	(
		FL_wheel.text = "Pick FL"
		rootnode.car_general_attributes.flwheel_model = undefined
	)
	on FR_wheel picked obj do
	(
		FR_wheel.text = obj.name
		rootnode.car_general_attributes.frwheel_model = obj
	)
	on FR_wheel rightclick do
	(
		FR_wheel.text = "Pick FR"
		rootnode.car_general_attributes.frwheel_model = undefined
	)
	on RL_wheel picked obj do
	(
		RL_wheel.text = obj.name
		rootnode.car_general_attributes.rlwheel_model = obj
	)
	on RL_wheel rightclick do
	(
		RL_wheel.text = "Pick RL"
		rootnode.car_general_attributes.rlwheel_model = undefined
	)
	on RR_wheel picked obj do
	(
		RR_wheel.text = obj.name
		rootnode.car_general_attributes.rrwheel_model = obj
	)
	on RR_wheel rightclick do
	(
		RR_wheel.text = "Pick RR"
		rootnode.car_general_attributes.rrwheel_model = undefined
	)
	on Body_pick picked obj do
	(
		Body_pick.text = obj.name
		rootnode.car_general_attributes.mainbody_model = obj
		Body_centre_x.range = [0,999999,obj.pos.x as float]
		Body_centre_y.range = [0,999999,obj.pos.y as float]
		Body_centre_z.range = [0,999999,obj.pos.z as float]
		
		body_width = obj.max.x - obj.min.x
		body_length = obj.max.y - obj.min.y
		body_height = obj.max.z - obj.min.z
		
		Body_momentum_x.range = [-999999,999999,body_width as float]
		Body_momentum_y.range = [-999999,999999,body_length as float]
		Body_momentum_z.range = [-999999,999999,body_height as float]
		
		rootnode.car_general_attributes.mainbody_center = obj.pos
		rootnode.car_general_attributes.mainbody_momentum = [body_width ,body_length,body_height]
	)
	on Body_pick rightclick do
	(
		Body_pick.text = "Pick Body"
		rootnode.car_general_attributes.mainbody_model = undefined
		Body_centre_x.range = [-999999,999999,0]
		Body_centre_y.range = [-999999,999999,0]
		Body_centre_z.range = [-999999,999999,0]
		Body_momentum_x.range = [-999999,999999,0]
		Body_momentum_y.range = [-999999,999999,0]
		Body_momentum_z.range = [-999999,999999,0]
		
		rootnode.car_general_attributes.mainbody_center = [0,0,0]
		rootnode.car_general_attributes.mainbody_momentum = [0,0,0]
	)
	on Body_centre_x changed val do rootnode.car_general_attributes.mainbody_center.x = val
	on Body_centre_y changed val do rootnode.car_general_attributes.mainbody_center.y = val
	on Body_centre_z changed val do rootnode.car_general_attributes.mainbody_center.z = val
	on Body_momentum_x changed val do rootnode.car_general_attributes.mainbody_momentum.x = val
	on Body_momentum_y changed val do rootnode.car_general_attributes.mainbody_momentum.y = val
	on Body_momentum_z changed val do rootnode.car_general_attributes.mainbody_momentum.z = val
		
	on RR_wheel richtclick do
	(
		RR_wheel.text = "Pick RR"
		rootnode.car_general_attributes.rrwheel_model = undefined
	)
	on Mechanics_stuff open do
	(
		mainbody = rootnode.car_general_attributes.mainbody_model
		if mainbody != undefined do 
		(
			Body_pick.text = mainbody.name
			Body_centre_x.range = [-999999,999999,mainbody.pos.x]
			Body_centre_y.range = [-999999,999999,mainbody.pos.y]
			Body_centre_z.range = [-999999,999999,mainbody.pos.z]
			
			body_width = mainbody.max.x - mainbody.min.x
			body_length = mainbody.max.y - mainbody.min.y
			body_height = mainbody.max.z - mainbody.min.z
			
			Body_momentum_x.range = [0,999999,body_width]
			Body_momentum_y.range = [0,999999,body_length]
			Body_momentum_z.range = [0,999999,body_height]
		)
		
		minimum_turning_circle.range = [0,999999,rootnode.car_general_attributes.minimum_turning_circle as float]
		brake_multiplier.range = [0,999999,rootnode.car_general_attributes.brake_multiplier as float]
		brake_strength_multiplier.range = [0,99999,rootnode.car_general_attributes.brake_strength_multiplier as float]
		number_of_gears.range = [0,10,rootnode.car_general_attributes.number_of_gears as integer]
		top_speed.range = [0,999999,rootnode.car_general_attributes.top_speed as integer]
		top_acceleration.range = [0,999999, rootnode.car_general_attributes.top_acceleration as float]
		
		flwheel = rootnode.car_general_attributes.flwheel_model
		if flwheel != undefined do FL_WHEEL.text = flwheel.name
		FL_steerdrive.selection = rootnode.car_general_attributes.fldriven as integer
		FL_suspgive.range = [0,1,rootnode.car_general_attributes.flsuspgive as float]
		FL_damping.range = [0,5,rootnode.car_general_attributes.fldamping as float]
		FL_redux.range = [0,1,rootnode.car_general_attributes.flredux as float]
		FL_angle1.range = [0,90,rootnode.car_general_attributes.flangle1 as float]
		FL_angle2.range = [0,90,rootnode.car_general_attributes.flangle2 as float]
		FL_trmultip.range = [0,10,rootnode.car_general_attributes.fltrmultip as float]
		FL_rrest.range = [0,10,rootnode.car_general_attributes.flrrest as float]
		
		frwheel = rootnode.car_general_attributes.frwheel_model
		if frwheel != undefined do FR_WHEEL.text = frwheel.name
		FR_steerdrive.selection = rootnode.car_general_attributes.frdriven as integer
		FR_suspgive.range = [0,1,rootnode.car_general_attributes.frsuspgive as float]
		FR_damping.range = [0,5,rootnode.car_general_attributes.frdamping as float]
		FR_redux.range = [0,1,rootnode.car_general_attributes.frredux as float]
		FR_angle1.range = [0,90,rootnode.car_general_attributes.frangle1 as float]
		FR_angle2.range = [0,90,rootnode.car_general_attributes.frangle2 as float]
		FR_trmultip.range = [0,10,rootnode.car_general_attributes.frtrmultip as float]
		FR_rrest.range = [0,10,rootnode.car_general_attributes.frrrest as float]	
		
		rlwheel = rootnode.car_general_attributes.rlwheel_model
		if rlwheel != undefined do RL_WHEEL.text = rlwheel.name
		RL_steerdrive.selection = rootnode.car_general_attributes.rldriven as integer
		RL_suspgive.range = [0,1,rootnode.car_general_attributes.rlsuspgive as float]
		RL_damping.range = [0,5,rootnode.car_general_attributes.rldamping as float]
		RL_redux.range = [0,1,rootnode.car_general_attributes.rlredux as float]
		RL_angle1.range = [0,90,rootnode.car_general_attributes.rlangle1 as float]
		RL_angle2.range = [0,90,rootnode.car_general_attributes.rlangle2 as float]
		RL_trmultip.range = [0,10,rootnode.car_general_attributes.rltrmultip as float]
		RL_rrest.range = [0,10,rootnode.car_general_attributes.rlrrest as float]
		
		rrwheel = rootnode.car_general_attributes.rrwheel_model
		if rrwheel != undefined do RR_WHEEL.text = rrwheel.name
		RR_steerdrive.selection = rootnode.car_general_attributes.rrdriven as integer
		RR_suspgive.range = [0,1,rootnode.car_general_attributes.rrsuspgive as float]
		RR_damping.range = [0,5,rootnode.car_general_attributes.rrdamping as float]
		RR_redux.range = [0,1,rootnode.car_general_attributes.rrredux as float]
		RR_angle1.range = [0,90,rootnode.car_general_attributes.rrangle1 as float]
		RR_angle2.range = [0,90,rootnode.car_general_attributes.rrangle2 as float]
		RR_trmultip.range = [0,10,rootnode.car_general_attributes.rrtrmultip as float]
		RR_rrest.range = [0,10,rootnode.car_general_attributes.rrrrest as float]
			
		Body_centre_x.range = [-999999,999999,rootnode.car_general_attributes.mainbody_center.x as float]
		Body_centre_y.range = [-999999,999999,rootnode.car_general_attributes.mainbody_center.y as float]
		Body_centre_z.range = [-999999,999999,rootnode.car_general_attributes.mainbody_center.z as float]
		Body_momentum_x.range = [-999999,999999,rootnode.car_general_attributes.mainbody_momentum.x as float]
		Body_momentum_y.range = [-999999,999999,rootnode.car_general_attributes.mainbody_momentum.y as float]
		Body_momentum_z.range = [-999999,999999,rootnode.car_general_attributes.mainbody_momentum.z as float]
		Body_mass.range = [0,999999,rootnode.car_general_attributes.mainbody_mass as float]
		Body_Downforce.range = [0,999999,rootnode.car_general_attributes.mainbody_downforce as integer]
	)
)

rollout Wam_setup "Wam setup"
(
	Group"Crush limits per axis:"
	(
		pickbutton limit_model "Pick model to calculate limits"
		
		spinner wam_x_min1 "X min 1:"  across:2 range:[-999999,999999,0] scale:0.001
		spinner wam_x_min2 "X min 2:" range:[-999999,999999,0] scale:0.001
		on wam_x_min1 changed val do rootnode.car_general_attributes.wam_x_min1 = val
		on wam_x_min2 changed val do rootnode.car_general_attributes.wam_x_min2 = val
		spinner wam_x_max1 "X max 1:"  across:2 range:[-999999,999999,0] scale:0.001
		spinner wam_x_max2 "X max 2:" range:[-999999,999999,0] scale:0.001
		on wam_x_max1 changed val do rootnode.car_general_attributes.wam_x_max1 = val
		on wam_x_max2 changed val do rootnode.car_general_attributes.wam_x_max2 = val
		spinner wam_y_min1 "Y min 1:"  across:2 range:[-999999,999999,0] scale:0.001
		spinner wam_y_min2 "Y min 2:" range:[-999999,999999,0] scale:0.001
		on wam_y_min1 changed val do rootnode.car_general_attributes.wam_y_min1 = val
		on wam_y_min2 changed val do rootnode.car_general_attributes.wam_y_min2 = val
		spinner wam_y_max1 "Y max 1:"  across:2 range:[-999999,999999,0]
		spinner wam_y_max2 "Y max 2:" range:[-999999,999999,0]
		on wam_y_max1 changed val do rootnode.car_general_attributes.wam_y_max1 = val
		on wam_y_max2 changed val do rootnode.car_general_attributes.wam_y_max2 = val
		spinner wam_z_min1 "Z min 1:"  across:2 range:[-999999,999999,0]
		spinner wam_z_min2 "Z min 2:" range:[-999999,999999,0]
		on wam_z_min1 changed val do rootnode.car_general_attributes.wam_z_min1 = val
		on wam_z_min2 changed val do rootnode.car_general_attributes.wam_z_min2 = val
		spinner wam_z_max1 "Z max 1:"  across:2 range:[-999999,999999,0]
		spinner wam_z_max2 "Z max 2:" range:[-999999,999999,0]
		on wam_z_max1 changed val do rootnode.car_general_attributes.wam_z_max1 = val
		on wam_z_max2 changed val do rootnode.car_general_attributes.wam_z_max2 = val
		
		on limit_model picked obj do
		(
			limit_width = obj.max.x - obj.min.x
			limit_length = obj.max.y - obj.min.y
			limit_height = obj.max.z - obj.min.z
			
			wam_x_min1.range = [-999999,999999,(obj.max.x-(0.1*limit_width))]
			wam_x_min2.range = [-999999,999999,(obj.max.x-(0.4*limit_width))]
			wam_x_max1.range = [-999999,999999,(obj.min.x+(0.1*limit_width))]
			wam_x_max2.range = [-999999,999999,(obj.min.x+(0.4*limit_width))]
				
			wam_y_min1.range = [-999999,999999,(obj.max.y-(0.1*limit_length))]
			wam_y_min2.range = [-999999,999999,(obj.max.y-(0.4*limit_length))]
			wam_y_max1.range = [-999999,999999,(obj.min.y+(0.1*limit_length))]
			wam_y_max2.range = [-999999,999999,(obj.min.y+(0.4*limit_length))]
				
			wam_z_min1.range = [-999999,999999,(obj.max.z-(0.1*limit_height))]
			wam_z_min2.range = [-999999,999999,(obj.max.z-(0.4*limit_height))]
			wam_z_max1.range = [-999999,999999,(obj.min.z+(0.1*limit_height))]
			wam_z_max2.range = [-999999,999999,(obj.min.z+(0.4*limit_height))]
				
			rootnode.car_general_attributes.wam_x_min1 = (obj.max.x-(0.1*limit_width))
			rootnode.car_general_attributes.wam_x_min2 = (obj.max.x-(0.4*limit_width))
			rootnode.car_general_attributes.wam_x_max1 = (obj.min.x+(0.1*limit_width))
			rootnode.car_general_attributes.wam_x_max2 = (obj.min.x+(0.4*limit_width))
				
			rootnode.car_general_attributes.wam_y_min1 = obj.max.y-(0.1*limit_length)
			rootnode.car_general_attributes.wam_y_min2 = obj.max.y-(0.4*limit_length)
			rootnode.car_general_attributes.wam_y_max1 = obj.min.y+(0.1*limit_length)
			rootnode.car_general_attributes.wam_y_max2 = obj.min.y+(0.4*limit_length)
				
			rootnode.car_general_attributes.wam_z_min1 = obj.max.z-(0.1*limit_height)
			rootnode.car_general_attributes.wam_z_min2 = obj.max.z-(0.4*limit_height)
			rootnode.car_general_attributes.wam_z_max1 = obj.min.z+(0.1*limit_height)
			rootnode.car_general_attributes.wam_z_max2 = obj.min.z+(0.4*limit_height)
		)
	)
	group "Wam generals"
	(
		spinner bendabillity_factor "Bendabillity factor:" range:[0,1,1] scale:0.01
		spinner bend_point_zmin "Bend point Z min:" range:[-999999,999999,-0.05]
		spinner bend_point_zmax "Bend point Z max:" range:[-999999,999999,-0.05]
		spinner snappabillity_factor "Snappabillity factor:" range:[0,1,1] scale:0.01
		spinner y_split_position "Y split position:" range:[-999999,999999,0] scale:0.01
		label driver_position "Driver position X,Y,Z:" across:4 offset:[55,0]
		spinner driver_pos_x ""  range:[-999999,999999,0.05] offset:[44,0] width:50 scale:0.01
		spinner driver_pos_y ""  range:[-999999,999999,0.0] offset:[20,0] width:50 scale:0.01
		spinner driver_pos_z "" range:[-999999,999999,0.1] offset:[28,0] align:#left width:50 scale:0.01
		on bendabillity_factor changed val do rootnode.car_general_attributes.bendabillity_factor = val
		on bend_point_zmin changed val do rootnode.car_general_attributes.bend_point_zmin = val
		on bend_point_zmax changed val do rootnode.car_general_attributes.bend_point_zmax = val
		on snappabillity_factor changed val do rootnode.car_general_attributes.snappabillity_factor = val
		on y_split_position changed val do rootnode.car_general_attributes.y_split_position = val
		on driver_pos_x changed val do rootnode.car_general_attributes.driver_pos_x = val
		on driver_pos_y changed val do rootnode.car_general_attributes.driver_pos_y = val
		on driver_pos_z changed val do rootnode.car_general_attributes.driver_pos_z = val
	)
	group "Wam and Smash properties"
	(
		label wam_obj_label "Apply WAM properties to selection:" across:2 offset:[0,4]
		button apply_wam "Apply WAM" width:140 align:#right
		on apply_wam pressed do
		(
			for object in selection do
			(
				custattributes.add object wam_data_CA
			)
		)
		on apply_wam rightclick do
		(
			for object in selection do
			(
				if custattributes.get object wam_data_CA != undefined do
				(
					custAttributes.delete object wam_data_CA
				)
			)
		)
		label smash_mat_label "Make selected material smashable:" across:2 offset:[0,4]
		button smash_mat_apply "Apply SMASH" width:140 align:#right
	)
	on wam_setup open do
	(
		wam_x_min1.range = [-999999,999999,rootnode.car_general_attributes.wam_x_min1]
		wam_x_min2.range = [-999999,999999,rootnode.car_general_attributes.wam_x_min2]
		wam_x_max1.range = [-999999,999999,rootnode.car_general_attributes.wam_x_max1]
		wam_x_max2.range = [-999999,999999,rootnode.car_general_attributes.wam_x_max2]
		wam_y_min1.range = [-999999,999999,rootnode.car_general_attributes.wam_y_min1]
		wam_y_min2.range = [-999999,999999,rootnode.car_general_attributes.wam_y_min2]
		wam_y_max1.range = [-999999,999999,rootnode.car_general_attributes.wam_y_max1]
		wam_y_max2.range = [-999999,999999,rootnode.car_general_attributes.wam_y_max2]
		wam_z_min1.range = [-999999,999999,rootnode.car_general_attributes.wam_z_min1]
		wam_z_min2.range = [-999999,999999,rootnode.car_general_attributes.wam_z_min2]
		wam_z_max1.range = [-999999,999999,rootnode.car_general_attributes.wam_z_max1]
		wam_z_max2.range = [-999999,999999,rootnode.car_general_attributes.wam_z_max2]
		
		bendabillity_factor.range = [0,1,rootnode.car_general_attributes.bendabillity_factor]
		bend_point_zmin.range = [-999999,999999,rootnode.car_general_attributes.bend_point_zmin]
		bend_point_zmax.range = [-999999,999999,rootnode.car_general_attributes.bend_point_zmax]
		snappabillity_factor.range = [0,1,rootnode.car_general_attributes.snappabillity_factor]
		y_split_position.range = [-999999,999999,rootnode.car_general_attributes.y_split_position]
		driver_pos_x.range = [-999999,999999,rootnode.car_general_attributes.driver_pos_x]
		driver_pos_y.range = [-999999,999999,rootnode.car_general_attributes.driver_pos_y]
		driver_pos_z.range = [-999999,999999,rootnode.car_general_attributes.driver_pos_z]
	)
)

rollout quick_wheels_setup "Quick car setup"
(	
	group "Help"
	(
		label quick_label_1 "This will automatically set all te basic" align:#left
		label quick_label_2 "wheel and body properties in the " align:#left
		label quick_label_3 "main setup dialog" align:#left
		label quick_label_4 "" align:#left
		label quick_label_5 "It will also add dummy pivots to the" align:#left
		label quick_label_6 "wheels if steerable is checked!!!" align:#left
		label quick_label_7 "" align:#left
	)
	group "Pick parts"
	(
		pickbutton quick_mainbody "Pick main body" width:177
		pickbutton quick_flwheel "Pick flwheel" across:2 width:90
		checkbox quick_fl_steerable "Steerable" offset:[0,3] align:#right
		pickbutton quick_frwheel "Pick frwheel" across:2 width:90
		checkbox quick_fr_steerable "Steerable" offset:[0,3] align:#right
		pickbutton quick_rlwheel "Pick rlwheel" across:2 width:90
		checkbox quick_rl_steerable "Steerable" offset:[0,3] align:#right
		pickbutton quick_rrwheel "Pick rrwheel" across:2 width:90
		checkbox quick_rr_steerable "Steerable" offset:[0,3] align:#right
	)
	label quick_label_8 ""
	button quick_ok "Ok" across:2 width:80
	button quick_cancel "Cancel" width:80
	on quick_mainbody picked obj do
	(
		quick_mainbody.text = obj.name
		rootnode.car_general_attributes.temp_mainbody = obj
	)
	on quick_flwheel picked obj do
	(
		quick_flwheel.text = obj.name
		rootnode.car_general_attributes.temp_flwheel = obj
	)
	on quick_frwheel picked obj do
	(
		quick_frwheel.text = obj.name
		rootnode.car_general_attributes.temp_frwheel = obj
	)
	on quick_rlwheel picked obj do
	(
		quick_rlwheel.text = obj.name
		rootnode.car_general_attributes.temp_rlwheel = obj
	)
	on quick_rrwheel picked obj do
	(
		quick_rrwheel.text = obj.name
		rootnode.car_general_attributes.temp_rrwheel = obj
	)
	on quick_ok pressed do
	(
		if rootnode.car_general_attributes.temp_mainbody != undefined do
		(
			mainbody = rootnode.car_general_attributes.temp_mainbody
			rootnode.car_general_attributes.mainbody_model = mainbody
			Mechanics_stuff.Body_pick.text = mainbody.name
			rootnode.car_general_attributes.mainbody_model = mainbody 
			Mechanics_stuff.Body_centre_x.range = [0,999999,mainbody.pos.x as float]
			Mechanics_stuff.Body_centre_y.range = [0,999999,mainbody.pos.y as float]
			Mechanics_stuff.Body_centre_z.range = [0,999999,mainbody.pos.z as float]
			
			body_width = (((mainbody.min.x*2)+(mainbody.max.x*2))/2)
			body_length= (((mainbody.min.y*2)+(mainbody.max.y*2))/2)
			body_height = (((mainbody.min.z*2)+(mainbody.max.z*2))/2)
			
			Mechanics_stuff.Body_momentum_x.range = [-999999,999999,body_width as float]
			Mechanics_stuff.Body_momentum_y.range = [-999999,999999,body_length as float]
			Mechanics_stuff.Body_momentum_z.range = [-999999,999999,body_height as float]
			
			rootnode.car_general_attributes.mainbody_center = mainbody.center
			rootnode.car_general_attributes.mainbody_momentum = [body_width ,body_length,body_height]
			if rootnode.car_general_attributes.temp_flwheel != undefined do
			(
				rootnode.car_general_attributes.temp_flwheel.parent = mainbody
			)
			if rootnode.car_general_attributes.temp_frwheel != undefined do
			(
				rootnode.car_general_attributes.temp_frwheel.parent = mainbody
			)
			if rootnode.car_general_attributes.temp_rlwheel != undefined do
			(
				rootnode.car_general_attributes.temp_rlwheel.parent = mainbody
			)
			if rootnode.car_general_attributes.temp_rrwheel != undefined do
			(
				rootnode.car_general_attributes.temp_rrwheel.parent = mainbody
			)
			for object in objects do
			(
				if object != mainbody do
				(
					if object.parent != mainbody do
					(
						object.parent = mainbody
					)
				)
			)
		)
		if rootnode.car_general_attributes.temp_flwheel != undefined do
		(
			flwheel = rootnode.car_general_attributes.temp_flwheel
			if quick_fl_steerable.checked == true then
			(
				Mechanics_stuff.FL_wheel.text = flwheel.name
				rootnode.car_general_attributes.fldriven = 1
				rootnode.car_general_attributes.flwheel_model = flwheel
				--make dummy object as parent
				if flwheel.parent == rootnode.car_general_attributes.temp_mainbody do
				(
					flpivot = dummy()
					flpivot.boxsize = [.01,.01,.01]
					flpivot.name = "flpivot.act"
					flpivot.pos = flwheel.pos
					flwheel.parent = flpivot
					flpivot.parent = rootnode.car_General_attributes.temp_mainbody
				)
				--adding the pivot to the steering groovyfunkref list
				custAttributes.add flpivot groove_data_CA 
				flpivot.groove_data.groove_lollipop_param = 1
				flpivot.groove_data.groove_distance_param = 2
				flpivot.groove_data.groove_animation_type_param = 3
				flpivot.groove_data.groove_animation_mode_param = 5
				flpivot.groove_data.groove_animation_centre_x_param = flpivot.center.x
				flpivot.groove_data.groove_animation_centre_y_param = flpivot.center.y
				flpivot.groove_data.groove_animation_centre_z_param = flpivot.center.z
				flpivot.groove_data.groove_animation_axis_param = 2
				if (finditem rootnode.car_general_attributes.steering_wheels flpivot) == 0 do
				(
					if rootnode.car_general_attributes.steering_wheels.count == 1 then
					(
						if rootnode.car_general_attributes.steering_wheels[1] == undefined then
						(
							rootnode.car_general_attributes.steering_wheels[1] = flpivot
						)
						else append rootnode.car_general_attributes.steering_wheels flpivot
					)
					else
					(
						append rootnode.car_general_attributes.steering_wheels flpivot
					)
					steering_wheels = #()
					for i=1 to rootnode.car_general_attributes.steering_wheels.count do
					(
						steering_wheels[i] = rootnode.car_general_attributes.steering_wheels[i].name
						
					)
					groovyfunkref.steerable_list.items = steering_wheels
					groovyfunkref.steerable_list.selection = steering_wheels.count
				)
				rootnode.car_general_attributes.fldriven = 1
				Mechanics_stuff.FL_steerdrive.selection = 1
				
				--add the wheel to the nondriveable groovyfunkref
				custAttributes.add flwheel groove_data_CA
				flwheel.groove_data.groove_lollipop_param = 1
				flwheel.groove_data.groove_distance_param = 2
				flwheel.groove_data.groove_path_type_param = 1
				flwheel.groove_data.groove_animation_type_param = 2
				flwheel.groove_data.groove_animation_mode_param = 6
				flwheel.groove_data.groove_animation_centre_x_param = flwheel.center.x
				flwheel.groove_data.groove_animation_centre_y_param = flwheel.center.y
				flwheel.groove_data.groove_animation_centre_z_param = flwheel.center.z
				flwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.nondriven_wheels flwheel) == 0 do
				(
					if rootnode.car_general_attributes.nondriven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.nondriven_wheels flwheel
					)
					else
					(
						rootnode.car_general_attributes.nondriven_wheels[1] = flwheel
					)
					nondriven_wheels = #()
					for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
					(
						nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
					)
					groovyfunkref.nondriveable_list.items = nondriven_wheels
					groovyfunkref.nondriveable_list.selection = nondriven_wheels.count
				)
				--add the wheel to the suspension groovyfunkref!
				custAttributes.add flpivot groove_data_CA
				flpivot.groove_data.groove_lollipop_param = 1
				flpivot.groove_data.groove_distance_param = 2
				
				flpivot.groove_data.groove_path_type_param = 2
				flpivot.groove_data.groove_path_mode_param = 4
				flpivot.groove_data.groove_path_center_X_param = 0.0
				flpivot.groove_data.groove_path_center_Y_param = 0.0
				flpivot.groove_data.groove_path_center_Z_param = 0.0
				flpivot.groove_data.groove_path_extent_X_param = 0.0
				flpivot.groove_data.groove_path_extent_Y_param = 0.0
				flpivot.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions flpivot) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions flpivot
						append rootnode.car_general_attributes.suspension_types 1
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = flpivot
						rootnode.car_general_attributes.suspension_types[1] = 1
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
			else
			(
				Mechanics_stuff.FL_wheel.text = flwheel.name
				Mechanics_stuff.FL_steerdrive.selection = 2
				rootnode.car_general_attributes.fldriven = 2
				rootnode.car_general_attributes.flwheel_model = flwheel
				--add wheel to driven groovyfunkref
				custAttributes.add flwheel groove_data_CA
				flwheel.groove_data.groove_lollipop_param = 1
				flwheel.groove_data.groove_distance_param = 2
				flwheel.groove_data.groove_animation_type_param = 2
				flwheel.groove_data.groove_animation_mode_param = 6
				flwheel.groove_data.groove_animation_centre_x_param = flwheel.center.x
				flwheel.groove_data.groove_animation_centre_y_param = flwheel.center.y
				flwheel.groove_data.groove_animation_centre_z_param = flwheel.center.z
				flwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.driven_wheels flwheel) == 0 do
				(
					if rootnode.car_general_attributes.driven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.driven_wheels flwheel
					)
					else
					(
						rootnode.car_general_attributes.driven_wheels[1] = flwheel
					)
					driven_wheels = #()
					for i=1 to rootnode.car_general_attributes.driven_wheels.count do
					(
						driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
					)
					groovyfunkref.driveable_list.items = driven_wheels
					groovyfunkref.driveable_list.selection = driven_wheels.count
				)
				--add wheel to suspension groovyfunkref
				custAttributes.add flwheel groove_data_CA
				flwheel.groove_data.groove_lollipop_param = 1
				flwheel.groove_data.groove_distance_param = 2
				flwheel.groove_data.groove_path_type_param = 2
				flwheel.groove_data.groove_path_mode_param = 4
				flwheel.groove_data.groove_path_center_X_param = 0.0
				flwheel.groove_data.groove_path_center_Y_param = 0.0
				flwheel.groove_data.groove_path_center_Z_param = 0.0
				flwheel.groove_data.groove_path_extent_X_param = 0.0
				flwheel.groove_data.groove_path_extent_Y_param = 0.0
				flwheel.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions flwheel) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions flwheel
						append rootnode.car_general_attributes.suspension_types 1
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = flwheel
						rootnode.car_general_attributes.suspension_types[1] = 1
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
		)
		if rootnode.car_general_attributes.temp_frwheel != undefined do
		(
			frwheel = rootnode.car_general_attributes.temp_frwheel
			if quick_fr_steerable.checked == true then
			(
				Mechanics_stuff.FR_wheel.text = frwheel.name
				rootnode.car_general_attributes.frdriven = 1
				rootnode.car_general_attributes.frwheel_model = frwheel
				--make dummy object as parent
				if frwheel.parent == rootnode.car_general_attributes.temp_mainbody do
				(
					frpivot = dummy()
					frpivot.boxsize = [.01,.01,.01]
					frpivot.name = "frpivot.act"
					frpivot.pos = frwheel.pos
					frwheel.parent = frpivot
					frpivot.parent = rootnode.car_General_attributes.temp_mainbody
				)
				--adding the pivot to the steering groovyfunkref list
				custAttributes.add frpivot groove_data_CA 
				frpivot.groove_data.groove_lollipop_param = 1
				frpivot.groove_data.groove_distance_param = 2
				frpivot.groove_data.groove_animation_type_param = 3
				frpivot.groove_data.groove_animation_mode_param = 5
				frpivot.groove_data.groove_animation_centre_x_param = frpivot.center.x
				frpivot.groove_data.groove_animation_centre_y_param = frpivot.center.y
				frpivot.groove_data.groove_animation_centre_z_param = frpivot.center.z
				frpivot.groove_data.groove_animation_axis_param = 2
				if (finditem rootnode.car_general_attributes.steering_wheels frpivot) == 0 do
				(
					if rootnode.car_general_attributes.steering_wheels.count == 1 then
					(
						if rootnode.car_general_attributes.steering_wheels[1] == undefined then
						(
							rootnode.car_general_attributes.steering_wheels[1] = frpivot
						)
						else append rootnode.car_general_attributes.steering_wheels frpivot
					)
					else
					(
						append rootnode.car_general_attributes.steering_wheels frpivot
					)
					steering_wheels = #()
					for i=1 to rootnode.car_general_attributes.steering_wheels.count do
					(
						steering_wheels[i] = rootnode.car_general_attributes.steering_wheels[i].name
						
					)
					groovyfunkref.steerable_list.items = steering_wheels
					groovyfunkref.steerable_list.selection = steering_wheels.count
				)
				rootnode.car_general_attributes.frdriven = 1
				Mechanics_stuff.FR_steerdrive.selection = 1
				
				--add the wheel to the nondriveable groovyfunkref
				custAttributes.add frwheel groove_data_CA
				frwheel.groove_data.groove_lollipop_param = 1
				frwheel.groove_data.groove_distance_param = 2
				frwheel.groove_data.groove_path_type_param = 1
				frwheel.groove_data.groove_animation_type_param = 2
				frwheel.groove_data.groove_animation_mode_param = 6
				frwheel.groove_data.groove_animation_centre_x_param = frwheel.center.x
				frwheel.groove_data.groove_animation_centre_y_param = frwheel.center.y
				frwheel.groove_data.groove_animation_centre_z_param = frwheel.center.z
				frwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.nondriven_wheels frwheel) == 0 do
				(
					if rootnode.car_general_attributes.nondriven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.nondriven_wheels frwheel
					)
					else
					(
						rootnode.car_general_attributes.nondriven_wheels[1] = frwheel
					)
					nondriven_wheels = #()
					for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
					(
						nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
					)
					groovyfunkref.nondriveable_list.items = nondriven_wheels
					groovyfunkref.nondriveable_list.selection = nondriven_wheels.count
				)
				--add the wheel to the suspension groovyfunkref!
				custAttributes.add frpivot groove_data_CA
				frpivot.groove_data.groove_lollipop_param = 1
				frpivot.groove_data.groove_distance_param = 2
				
				frpivot.groove_data.groove_path_type_param = 2
				frpivot.groove_data.groove_path_mode_param = 4
				frpivot.groove_data.groove_path_center_X_param = 0.0
				frpivot.groove_data.groove_path_center_Y_param = 0.0
				frpivot.groove_data.groove_path_center_Z_param = 0.0
				frpivot.groove_data.groove_path_extent_X_param = 0.0
				frpivot.groove_data.groove_path_extent_Y_param = 0.0
				frpivot.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions frpivot) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions frpivot
						append rootnode.car_general_attributes.suspension_types 2
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = frpivot
						rootnode.car_general_attributes.suspension_types[1] = 2
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
			else
			(
				Mechanics_stuff.FR_wheel.text = frwheel.name
				Mechanics_stuff.FR_steerdrive.selection = 2
				rootnode.car_general_attributes.frdriven = 2
				rootnode.car_general_attributes.frwheel_model = frwheel
				--add wheel to driven groovyfunkref
				custAttributes.add frwheel groove_data_CA
				frwheel.groove_data.groove_lollipop_param = 1
				frwheel.groove_data.groove_distance_param = 2
				frwheel.groove_data.groove_animation_type_param = 2
				frwheel.groove_data.groove_animation_mode_param = 6
				frwheel.groove_data.groove_animation_centre_x_param = frwheel.center.x
				frwheel.groove_data.groove_animation_centre_y_param = frwheel.center.y
				frwheel.groove_data.groove_animation_centre_z_param = frwheel.center.z
				frwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.driven_wheels frwheel) == 0 do
				(
					if rootnode.car_general_attributes.driven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.driven_wheels frwheel
					)
					else
					(
						rootnode.car_general_attributes.driven_wheels[1] = frwheel
					)
					driven_wheels = #()
					for i=1 to rootnode.car_general_attributes.driven_wheels.count do
					(
						driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
					)
					groovyfunkref.driveable_list.items = driven_wheels
					groovyfunkref.driveable_list.selection = driven_wheels.count
				)
				--add wheel to suspension groovyfunkref
				custAttributes.add frwheel groove_data_CA
				frwheel.groove_data.groove_lollipop_param = 1
				frwheel.groove_data.groove_distance_param = 2
				frwheel.groove_data.groove_path_type_param = 2
				frwheel.groove_data.groove_path_mode_param = 4
				frwheel.groove_data.groove_path_center_X_param = 0.0
				frwheel.groove_data.groove_path_center_Y_param = 0.0
				frwheel.groove_data.groove_path_center_Z_param = 0.0
				frwheel.groove_data.groove_path_extent_X_param = 0.0
				frwheel.groove_data.groove_path_extent_Y_param = 0.0
				frwheel.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions frwheel) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions frwheel
						append rootnode.car_general_attributes.suspension_types 2
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = frwheel
						rootnode.car_general_attributes.suspension_types[1] = 2
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
		)
		if rootnode.car_general_attributes.temp_rlwheel != undefined do
		(
			rlwheel = rootnode.car_general_attributes.temp_rlwheel
			if quick_rl_steerable.checked == true then
			(
				Mechanics_stuff.RL_wheel.text = rlwheel.name
				rootnode.car_general_attributes.rldriven = 1
				rootnode.car_general_attributes.rlwheel_model = rlwheel
				--make dummy object as parent
				if rlwheel.parent == rootnode.car_general_attributes.temp_mainbody do
				(
					rlpivot = dummy()
					rlpivot.boxsize = [.01,.01,.01]
					rlpivot.name = "rlpivot.act"
					rlpivot.pos = rlwheel.pos
					rlwheel.parent = rlpivot
					rlpivot.parent = rootnode.car_General_attributes.temp_mainbody
				)
				--adding the pivot to the steering groovyfunkref list
				custAttributes.add rlpivot groove_data_CA 
				rlpivot.groove_data.groove_lollipop_param = 1
				rlpivot.groove_data.groove_distance_param = 2
				rlpivot.groove_data.groove_animation_type_param = 3
				rlpivot.groove_data.groove_animation_mode_param = 5
				rlpivot.groove_data.groove_animation_centre_x_param = rlpivot.center.x
				rlpivot.groove_data.groove_animation_centre_y_param = rlpivot.center.y
				rlpivot.groove_data.groove_animation_centre_z_param = rlpivot.center.z
				rlpivot.groove_data.groove_animation_axis_param = 2
				if (finditem rootnode.car_general_attributes.steering_wheels rlpivot) == 0 do
				(
					if rootnode.car_general_attributes.steering_wheels.count == 1 then
					(
						if rootnode.car_general_attributes.steering_wheels[1] == undefined then
						(
							rootnode.car_general_attributes.steering_wheels[1] = rlpivot
						)
						else append rootnode.car_general_attributes.steering_wheels rlpivot
					)
					else
					(
						append rootnode.car_general_attributes.steering_wheels rlpivot
					)
					steering_wheels = #()
					for i=1 to rootnode.car_general_attributes.steering_wheels.count do
					(
						steering_wheels[i] = rootnode.car_general_attributes.steering_wheels[i].name
						
					)
					groovyfunkref.steerable_list.items = steering_wheels
					groovyfunkref.steerable_list.selection = steering_wheels.count
				)
				rootnode.car_general_attributes.rldriven = 1
				Mechanics_stuff.RL_steerdrive.selection = 1
				
				--add the wheel to the nondriveable groovyfunkref
				custAttributes.add rlwheel groove_data_CA
				rlwheel.groove_data.groove_lollipop_param = 1
				rlwheel.groove_data.groove_distance_param = 2
				rlwheel.groove_data.groove_path_type_param = 1
				rlwheel.groove_data.groove_animation_type_param = 2
				rlwheel.groove_data.groove_animation_mode_param = 6
				rlwheel.groove_data.groove_animation_centre_x_param = rlwheel.center.x
				rlwheel.groove_data.groove_animation_centre_y_param = rlwheel.center.y
				rlwheel.groove_data.groove_animation_centre_z_param = rlwheel.center.z
				rlwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.nondriven_wheels rlwheel) == 0 do
				(
					if rootnode.car_general_attributes.nondriven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.nondriven_wheels rlwheel
					)
					else
					(
						rootnode.car_general_attributes.nondriven_wheels[1] = rlwheel
					)
					nondriven_wheels = #()
					for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
					(
						nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
					)
					groovyfunkref.nondriveable_list.items = nondriven_wheels
					groovyfunkref.nondriveable_list.selection = nondriven_wheels.count
				)
				--add the wheel to the suspension groovyfunkref!
				custAttributes.add rlpivot groove_data_CA
				rlpivot.groove_data.groove_lollipop_param = 1
				rlpivot.groove_data.groove_distance_param = 2
				
				rlpivot.groove_data.groove_path_type_param = 2
				rlpivot.groove_data.groove_path_mode_param = 4
				rlpivot.groove_data.groove_path_center_X_param = 0.0
				rlpivot.groove_data.groove_path_center_Y_param = 0.0
				rlpivot.groove_data.groove_path_center_Z_param = 0.0
				rlpivot.groove_data.groove_path_extent_X_param = 0.0
				rlpivot.groove_data.groove_path_extent_Y_param = 0.0
				rlpivot.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions rlpivot) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions rlpivot
						append rootnode.car_general_attributes.suspension_types 3
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = rlpivot
						rootnode.car_general_attributes.suspension_types[1] = 3
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
			else
			(
				Mechanics_stuff.RL_wheel.text = rlwheel.name
				Mechanics_stuff.RL_steerdrive.selection = 2
				rootnode.car_general_attributes.rldriven = 2
				rootnode.car_general_attributes.rlwheel_model = rlwheel
				--add wheel to driven groovyfunkref
				custAttributes.add rlwheel groove_data_CA
				rlwheel.groove_data.groove_lollipop_param = 1
				rlwheel.groove_data.groove_distance_param = 2
				rlwheel.groove_data.groove_animation_type_param = 2
				rlwheel.groove_data.groove_animation_mode_param = 6
				rlwheel.groove_data.groove_animation_centre_x_param = rlwheel.center.x
				rlwheel.groove_data.groove_animation_centre_y_param = rlwheel.center.y
				rlwheel.groove_data.groove_animation_centre_z_param = rlwheel.center.z
				rlwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.driven_wheels rlwheel) == 0 do
				(
					if rootnode.car_general_attributes.driven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.driven_wheels rlwheel
					)
					else
					(
						rootnode.car_general_attributes.driven_wheels[1] = rlwheel
					)
					driven_wheels = #()
					for i=1 to rootnode.car_general_attributes.driven_wheels.count do
					(
						driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
					)
					groovyfunkref.driveable_list.items = driven_wheels
					groovyfunkref.driveable_list.selection = driven_wheels.count
				)
				--add wheel to suspension groovyfunkref
				custAttributes.add rlwheel groove_data_CA
				rlwheel.groove_data.groove_lollipop_param = 1
				rlwheel.groove_data.groove_distance_param = 2
				rlwheel.groove_data.groove_path_type_param = 2
				rlwheel.groove_data.groove_path_mode_param = 4
				rlwheel.groove_data.groove_path_center_X_param = 0.0
				rlwheel.groove_data.groove_path_center_Y_param = 0.0
				rlwheel.groove_data.groove_path_center_Z_param = 0.0
				rlwheel.groove_data.groove_path_extent_X_param = 0.0
				rlwheel.groove_data.groove_path_extent_Y_param = 0.0
				rlwheel.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions rlwheel) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions rlwheel
						append rootnode.car_general_attributes.suspension_types 3
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = rlwheel
						rootnode.car_general_attributes.suspension_types[1] = 3
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
		)
		if rootnode.car_general_attributes.temp_rrwheel != undefined do
		(
			rrwheel = rootnode.car_general_attributes.temp_rrwheel
			if quick_rr_steerable.checked == true then
			(
				Mechanics_stuff.RR_wheel.text = rrwheel.name
				rootnode.car_general_attributes.rrdriven = 1
				rootnode.car_general_attributes.rrwheel_model = rrwheel
				--make dummy object as parent
				if rrwheel.parent == rootnode.car_general_attributes.temp_mainbody do
				(
					rrpivot = dummy()
					rrpivot.boxsize = [.01,.01,.01]
					rrpivot.name = "rrpivot.act"
					rrpivot.pos = rrwheel.pos
					rrwheel.parent = rrpivot
					rrpivot.parent = rootnode.car_General_attributes.temp_mainbody
				)
				--adding the pivot to the steering groovyfunkref list
				custAttributes.add rrpivot groove_data_CA 
				rrpivot.groove_data.groove_lollipop_param = 1
				rrpivot.groove_data.groove_distance_param = 2
				rrpivot.groove_data.groove_animation_type_param = 3
				rrpivot.groove_data.groove_animation_mode_param = 5
				rrpivot.groove_data.groove_animation_centre_x_param = rrpivot.center.x
				rrpivot.groove_data.groove_animation_centre_y_param = rrpivot.center.y
				rrpivot.groove_data.groove_animation_centre_z_param = rrpivot.center.z
				rrpivot.groove_data.groove_animation_axis_param = 2
				if (finditem rootnode.car_general_attributes.steering_wheels rrpivot) == 0 do
				(
					if rootnode.car_general_attributes.steering_wheels.count == 1 then
					(
						if rootnode.car_general_attributes.steering_wheels[1] == undefined then
						(
							rootnode.car_general_attributes.steering_wheels[1] = rrpivot
						)
						else append rootnode.car_general_attributes.steering_wheels rrpivot
					)
					else
					(
						append rootnode.car_general_attributes.steering_wheels rrpivot
					)
					steering_wheels = #()
					for i=1 to rootnode.car_general_attributes.steering_wheels.count do
					(
						steering_wheels[i] = rootnode.car_general_attributes.steering_wheels[i].name
						
					)
					groovyfunkref.steerable_list.items = steering_wheels
					groovyfunkref.steerable_list.selection = steering_wheels.count
				)
				rootnode.car_general_attributes.rrdriven = 1
				Mechanics_stuff.RR_steerdrive.selection = 1
				
				--add the wheel to the nondriveable groovyfunkref
				custAttributes.add rrwheel groove_data_CA
				rrwheel.groove_data.groove_lollipop_param = 1
				rrwheel.groove_data.groove_distance_param = 2
				rrwheel.groove_data.groove_path_type_param = 1
				rrwheel.groove_data.groove_animation_type_param = 2
				rrwheel.groove_data.groove_animation_mode_param = 6
				rrwheel.groove_data.groove_animation_centre_x_param = rrwheel.center.x
				rrwheel.groove_data.groove_animation_centre_y_param = rrwheel.center.y
				rrwheel.groove_data.groove_animation_centre_z_param = rrwheel.center.z
				rrwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.nondriven_wheels rrwheel) == 0 do
				(
					if rootnode.car_general_attributes.nondriven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.nondriven_wheels rrwheel
					)
					else
					(
						rootnode.car_general_attributes.nondriven_wheels[1] = rrwheel
					)
					nondriven_wheels = #()
					for i=1 to rootnode.car_general_attributes.nondriven_wheels.count do
					(
						nondriven_wheels[i] = rootnode.car_general_attributes.nondriven_wheels[i].name
					)
					groovyfunkref.nondriveable_list.items = nondriven_wheels
					groovyfunkref.nondriveable_list.selection = nondriven_wheels.count
				)
				--add the wheel to the suspension groovyfunkref!
				custAttributes.add rrpivot groove_data_CA
				rrpivot.groove_data.groove_lollipop_param = 1
				rrpivot.groove_data.groove_distance_param = 2
				
				rrpivot.groove_data.groove_path_type_param = 2
				rrpivot.groove_data.groove_path_mode_param = 4
				rrpivot.groove_data.groove_path_center_X_param = 0.0
				rrpivot.groove_data.groove_path_center_Y_param = 0.0
				rrpivot.groove_data.groove_path_center_Z_param = 0.0
				rrpivot.groove_data.groove_path_extent_X_param = 0.0
				rrpivot.groove_data.groove_path_extent_Y_param = 0.0
				rrpivot.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions rrpivot) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions rrpivot
						append rootnode.car_general_attributes.suspension_types 4
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = rrpivot
						rootnode.car_general_attributes.suspension_types[1] = 4
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
			else
			(
				Mechanics_stuff.RR_wheel.text = rrwheel.name
				Mechanics_stuff.RR_steerdrive.selection = 2
				rootnode.car_general_attributes.rrdriven = 2
				rootnode.car_general_attributes.rrwheel_model = rrwheel
				--add wheel to driven groovyfunkref
				custAttributes.add rrwheel groove_data_CA
				rrwheel.groove_data.groove_lollipop_param = 1
				rrwheel.groove_data.groove_distance_param = 2
				rrwheel.groove_data.groove_animation_type_param = 2
				rrwheel.groove_data.groove_animation_mode_param = 6
				rrwheel.groove_data.groove_animation_centre_x_param = rrwheel.center.x
				rrwheel.groove_data.groove_animation_centre_y_param = rrwheel.center.y
				rrwheel.groove_data.groove_animation_centre_z_param = rrwheel.center.z
				rrwheel.groove_data.groove_animation_axis_param = 1
				if (finditem rootnode.car_general_attributes.driven_wheels rrwheel) == 0 do
				(
					if rootnode.car_general_attributes.driven_wheels[1] != undefined then
					(
						append rootnode.car_general_attributes.driven_wheels rrwheel
					)
					else
					(
						rootnode.car_general_attributes.driven_wheels[1] = rrwheel
					)
					driven_wheels = #()
					for i=1 to rootnode.car_general_attributes.driven_wheels.count do
					(
						driven_wheels[i] = rootnode.car_general_attributes.driven_wheels[i].name
					)
					groovyfunkref.driveable_list.items = driven_wheels
					groovyfunkref.driveable_list.selection = driven_wheels.count
				)
				--add wheel to suspension groovyfunkref
				custAttributes.add rrwheel groove_data_CA
				rrwheel.groove_data.groove_lollipop_param = 1
				rrwheel.groove_data.groove_distance_param = 2
				rrwheel.groove_data.groove_path_type_param = 2
				rrwheel.groove_data.groove_path_mode_param = 4
				rrwheel.groove_data.groove_path_center_X_param = 0.0
				rrwheel.groove_data.groove_path_center_Y_param = 0.0
				rrwheel.groove_data.groove_path_center_Z_param = 0.0
				rrwheel.groove_data.groove_path_extent_X_param = 0.0
				rrwheel.groove_data.groove_path_extent_Y_param = 0.0
				rrwheel.groove_data.groove_path_extent_Z_param = 1.0
				if (finditem rootnode.car_general_attributes.suspensions rrwheel) == 0 do
				(
					if rootnode.car_general_attributes.suspensions[1] != undefined then
					(
						append rootnode.car_general_attributes.suspensions rrwheel
						append rootnode.car_general_attributes.suspension_types 4
					)
					else
					(
						rootnode.car_general_attributes.suspensions[1] = rrwheel
						rootnode.car_general_attributes.suspension_types[1] = 4
					)
					suspensions = #()
					for i=1 to rootnode.car_general_attributes.suspensions.count do
					(
						if rootnode.car_general_attributes.suspensions[i] == undefined then suspensions[i] = "No suspension set"
						else suspensions[i] = rootnode.car_general_attributes.suspensions[i].name
					)
					groovyfunkref.suspension_list.items = suspensions
					groovyfunkref.suspension_list.selection = suspensions.count
					groovyfunkref.suspension_types.selection = 0
				)
			)
		)
		destroydialog quick_wheels_setup
	)
	on quick_cancel pressed do
	(
		destroydialog quick_wheels_setup
	)
)

rollout quick_setup "Quick Setup"
(
	group "Hierarchy quicktools"
	(
		button quick_car_setup "Quick car setup" across:2 width:150
		on quick_car_setup pressed do
		(
			createdialog quick_wheels_setup 200 360 420 50
		)
		button remove_car_setup "Remove all references" width:150
		on remove_car_setup pressed do
		(
			if querybox "This will reset the hierarchy setup and remove all groovyfunk and mechanics references! Are you sure you want to reset?" beep:false do
			(
				rootnode.car_general_attributes.steering_wheels = #()
				rootnode.car_general_attributes.driven_wheels = #()
				rootnode.car_general_attributes.nondriven_wheels = #()
				rootnode.car_general_attributes.suspensions = #()
				rootnode.car_general_attributes.suspension_types = #()
				rootnode.car_general_attributes.flwheel_model = undefined
				rootnode.car_general_attributes.fldriven = 1
				rootnode.car_general_attributes.frwheel_model = undefined
				rootnode.car_general_attributes.frdriven = 1
				rootnode.car_general_attributes.rlwheel_model = undefined
				rootnode.car_general_attributes.rldriven = 1
				rootnode.car_general_attributes.rrwheel_model = undefined
				rootnode.car_general_attributes.rrdriven = 1
				rootnode.car_general_attributes.mainbody_model = undefined
				rootnode.car_general_attributes.temp_mainbody = undefined
				rootnode.car_general_attributes.temp_flwheel = undefined
				rootnode.car_general_attributes.temp_frwheel = undefined
				rootnode.car_general_attributes.temp_rlwheel = undefined
				rootnode.car_general_attributes.temp_rrwheel = undefined
				
				groovyfunkref.suspension_list.items = #("No suspension set")
				groovyfunkref.nondriveable_list.items = #("No nonDriven wheels set")
				groovyfunkref.driveable_list.items = #("No Driven wheels set")
				groovyfunkref.steerable_list.items = #("No steering wheels set")
				
				mechanics_stuff.FL_wheel.text = "Pick FL"
				mechanics_stuff.FL_steerdrive.selection = 1
				mechanics_stuff.FR_wheel.text = "Pick FR"
				mechanics_stuff.FR_steerdrive.selection = 1
				mechanics_stuff.RL_wheel.text = "Pick RL"
				mechanics_stuff.RL_steerdrive.selection = 2
				mechanics_stuff.RR_wheel.text = "Pick RR"
				mechanics_stuff.RR_steerdrive.selection = 2
				
				for object in objects do
				(
					object.parent = undefined
				)
				for object in objects do
				(
					
				)
			)
		)
		button set_dummy_parent "Set dummy as parent" across:2 width:150
		on set_dummy_parent pressed do
		(
			for object in selection do
			(
				if object.parent != undefined do
				(
					objectparent = object.parent
				)
				dummy_parent = dummy()
				dummy_parent.name = object.name + "_dummy.act"
				dummy_parent.boxsize = [.01,.01,.01]
				dummy_parent.pos = object.pos
				object.parent = dummy_parent
				if objectparent != undefined do dummy_parent.parent = objectparent
			)
		)
		button remove_dummy_parent "Remove dummy parent" width:150
		on remove_dummy_parent pressed do
		(
			for object in selection do
			(
				dummy_parent = object.parent
				if dummy_parent.parent != undefined do
				(
					objectparent = dummy_parent.parent
				)
				object.parent = undefined
				object.parent = objectparent
				delete dummy_parent
			)
		)
	)
	group "Apply properties"
	(
		button apply_groove "Apply groove properties" across:2 width:150
		on apply_groove pressed do
		(
			for object in selection do
			(
				custattributes.add object groove_data_CA
			)
		) 
		on apply_groove rightclick do
		(
			for object in selection do
			(
				if custattributes.get object groove_data_CA != undefined do
				(
					custattributes.delete object groove_data_CA
				)
			)
		)
		button apply_funk "Apply funk properties" width:150
	)
		
)

destroydialog car_setup
createdialog car_setup 360 700

addsubrollout car_setup.car_setup_sub quick_setup rolledUp:false
addsubrollout car_setup.car_setup_sub car_general_setup rolledUp:true
addsubrollout car_setup.car_setup_sub groovyfunkref rolledUp:True
addsubrollout car_setup.car_setup_sub Mechanics_stuff rolledUp:true
addsubrollout car_setup.car_setup_sub Wam_setup rolledUp:false
car_setup.car_setup_sub.height += 640