fn round f = 
(
	(((f * 1000000) as integer) as float / 1000000)
)

fn vert_to_tvert a f =
(
	nbfaces = getNumFaces a
	for i=1 to nbfaces do 
	(
		face = getface a i
		if (face.x as integer) == f do 
		(
			global tvert = (gettvface a i).x
		)
		if (face.y as integer) == f do
		(
			global tvert = (gettvface a i).y
		)
		if (face.z as integer) == f do
		(
			global tvert = (gettvface a i).z
		)		
	)
	tvert = (tvert as integer)-1
)


exportname = GetSaveFileName caption:"Choose an exportname" types:"Txt(*.txt)"
if exportname != undefined do
(
	txt_name = getfilenamefile exportname +  ".txt"
	if txt_name != undefined then
	(
		
		grooves = #()
		for object in objects do
		(
			if custattributes.get object groove_data_CA != undefined do
			(
				append grooves object
			)
		)
		
		txt_file = createfile txt_name
		--txt entries
		format "VERSION 2\n\n" to:txt_file
		format "%.txt\n" (getfilenamefile exportname) to:txt_file
		format "%\n\n" rootnode.car_general_attributes.softness_factor to:txt_file

		--DRIVABLE STUFF
		
		format "START OF DRIVABLE STUFF\n\n" to:txt_file
		driverheadpos = rootnode.car_general_attributes.driver_head_pos
		format "%,%,%\n" driverheadpos.x driverheadpos.z -driverheadpos.y to:txt_file
		format "%,%\n" rootnode.car_general_attributes.driver_head_angles[1] rootnode.car_general_attributes.driver_head_angles[2] to:txt_file
		mirrorpos = rootnode.car_general_attributes.mirror_pos
		mirrorangle = rootnode.car_general_attributes.mirror_angle
		format "%,%,%,%\n" mirrorpos.x mirrorpos.z -mirrorpos.y mirrorangle to:txt_file
		format "none,none,PRATBDRT.PIX,PRATBDHZ.PIX\n\n" to:txt_file
		format "END OF DRIVABLE STUFF\n\n" to:txt_file

		--ENGINE NOISE AND STEALWORTY
		enginenoise = rootnode.car_general_attributes.engine_sound
		format "%,%,%\n\n" (enginenoise.x as integer) (enginenoise.y as integer) (enginenoise.z as integer) to:txt_file
		stealworthyness = rootnode.car_general_attributes.stealworthyness
		if stealworthyness == 1 do format "stealworthy\n\n" to:txt_file
		if stealworthyness == 0 do format "stealunworthy\n\n" to:txt_file
		
		
		--DAMAGE INFO STUFF

		format "// Damage info for top impacts\n1\n" to:txt_file
		format "	always\n	1\n		driver,1.5\n\n" to:txt_file
		
		format "// Damage info for bottom impacts\n5\n" to:txt_file
		format "	always\n	1\n		transmission,0.2\n" to:txt_file
		format "	z<0.25&x<0.25			// Condition\n	3				// Systems count\n		lf_wheel,0.5		// Damage\n		lf_brake,0.5		// Damage\n		steering,0.3		// Damage\n" to:txt_file
		format "	z<0.25&x>0.75			// Condition\n	3				// Systems count\n		rf_wheel,0.5		// Damage\n		rf_brake,0.5		// Damage\n		steering,0.3		// Damage\n" to:txt_file
		format "	z>0.75&x<0.25			// Condition\n	2				// Systems count\n		lr_wheel,0.5		// Damage\n		rr_brake,0.5		// Damage\n" to:txt_file
		format "	z>0.75&x>0.75			// Condition\n	2				// Systems count\n		lf_wheel,0.5		// Damage\n		rf_brake,0.5		// Damage\n\n" to:txt_file

		format "// Damage info for left impacts\n3\n" to:txt_file
		format "	z>0.25&z<0.75			// Condition\n	1				// Systems count\n		driver,1.0		// Damage\n" to:txt_file
		format "	z<0.25				// Condition\n	3				// Systems count\n		lf_wheel,0.5		// Damage\n		lf_brake,0.5		// Damage\n		steering,0.3		// Damage\n" to:txt_file
		format "	z>0.75				// Condition\n	2				// Systems count\n		lr_wheel,0.5		// Damage\n		lr_brake,0.5		// Damage\n\n" to:txt_file

		format "// Damage info for right impacts\n3\n" to:txt_file
		format "	z>0.25&z<0.75			// Condition\n	1				// Systems count\n		driver,1.0		// Damage\n" to:txt_file
		format "	z<0.25				// Condition\n	3				// Systems count\n		rf_wheel,0.5		// Damage\n		rf_brake,0.5		// Damage\n		steering,0.3		// Damage\n" to:txt_file
		format "	z>0.75				// Condition\n	2				// Systems count\n		rr_wheel,0.5		// Damage\n		rr_brake,0.5		// Damage\n\n" to:txt_file

		format "// Damage info for front impacts\n3\n" to:txt_file
		format "	always			// Condition\n	2				// Systems count\n		engine,1.0		// Damage\n	transmission,0.3	//Damage\n" to:txt_file
		format "	x<0.25				// Condition\n	3				// Systems count\n		lf_wheel,0.5		// Damage\n		lf_brake,0.5		// Damage\n		steering,0.5		// Damage\n" to:txt_file
		format "	x>0.75				// Condition\n	3				// Systems count\n		rf_wheel,0.5		// Damage\n		rf_brake,0.5		// Damage\n		steering,0.5		// Damage\n\n" to:txt_file
		
		format "// Damage info for rear impacts\n3\n" to:txt_file
		format "	always			// Condition\n	1				// Systems count\n		transmission,0.5		// Damage\n" to:txt_file
		format "	x<0.25				// Condition\n	2				// Systems count\n		lr_wheel,0.5		// Damage\n		lr_brake,0.5		// Damage\n" to:txt_file
		format "	x>0.75				// Condition\n	2				// Systems count\n		rr_wheel,0.5		// Damage\n		rr_brake,0.5		// Damage\n\n" to:txt_file

		--REFERENCE SETUP

		format "GEAGLEF.PIX,GEAGLEF.PIX,GEAGLEA.PIX	// Grid image (opponent, frank, annie)\n\n" to:txt_file
		
		format "1	// Number of extra levels of detail\n" to:txt_file
		format "8	// min_dist_squared\n\n" to:txt_file
		
		format "%.WAM	// crush data file\n\n" (getfilenamefile exportname) to:txt_file
		
		format "CARWSCRN.PIX	// Name of reflective screen material (or none if non-reflective)\n100				// Percentage transparency of windscreen\n\n" to:txt_file
		
		--groovyfunkref
		
		--driven wheels 1,2,3,4
		--non driven wheels 5,6,7,8
		--fl susp 9,10,11,12
		--fr susp 13,14,15,16
		--lr susp 17,18
		--rr susp 19,20
		--steering 21...
		steeringwheels = rootnode.car_general_attributes.steering_wheels
		if steeringwheels[1] != undefined then
		(
			format "%		//number of steering wheels\n" steeringwheels.count to:txt_file
			for i = 1 to steeringwheels.count do
			(
				format "%		//% reference\n" (20+i) steeringwheels[i].name to:txt_file
			)
			format "\n" to:txt_file
		)
		else format "2\n7\n8\n\n" to:txt_file
		
		suspensions = rootnode.car_general_attributes.suspensions
		suspension_types = rootnode.car_general_attributes.suspension_types
		flsusp = #()
		frsusp = #()
		rlsusp = #()
		rrsusp = #()
		for i=1 to suspensions.count do
		(
			type = suspension_types[i]
			if type != undefined do
			(
				if type == 1 do append flsusp suspensions[i].name
				if type == 2 do append frsusp suspensions[i].name
				if type == 3 do append rlsusp suspensions[i].name
				if type == 4 do append rrsusp suspensions[i].name
			)
		)			
		
		if flsusp[1] != undefined then
		(
			for i = 1 to 4 do
			(
				if flsusp[i] != undefined then
				(
					format "%" (8+i) to:txt_file
				)
				else 
				(
					format "-1" to:txt_file
				)
				if i != 4 do format "," to:txt_file
			)
			format "	//fl suspensions % \n" flsusp to:txt_file
		)
		else format "4,-1,-1,-1\n" to:txt_file
		
		if frsusp[1] != undefined then
		(
			for i = 1 to 4 do
			(
				if frsusp[i] != undefined then
				(
					format "%" (12+i) to:txt_file
				)
				else 
				(
					format "-1" to:txt_file
				)
				if i != 4 do format "," to:txt_file
			)
			format "	//fr suspensions % \n" frsusp to:txt_file
		)
		else format "3,-1,-1,-1\n" to:txt_file
		
		if rlsusp[1] != undefined then
		(
			for i = 1 to 2 do
			(
				if rlsusp[i] != undefined then
				(
					format "%" (16+i) to:txt_file
				)
				else 
				(
					format "-1" to:txt_file
				)
				if i != 2 do format "," to:txt_file
			)
			format "		//rl suspensions % \n" rlsusp to:txt_file
		)
		else format "6,-1\n" to:txt_file
		
		if rrsusp[1] != undefined then
		(
			for i = 1 to 2 do
			(
				if rrsusp[i] != undefined then
				(
					format "%" (18+i) to:txt_file
				)
				else 
				(
					format "-1" to:txt_file
				)
				if i != 2 do format "," to:txt_file
			)
			format "		//rr suspensions % \n" rrsusp to:txt_file
		)
		else format "5,-1\n\n" to:txt_file
		format "\n" to:txt_file
		
		driven_wheels = #()
		for i = 1 to rootnode.car_general_attributes.driven_wheels.count do
		(
			if rootnode.car_general_attributes.driven_wheels[i] != undefined do append driven_wheels rootnode.car_general_attributes.driven_wheels[i].name
		)
		if driven_wheels[1] != undefined then
		(
			driven_array = #(-1,-1,-1,-1)
			for i = 1 to 4 do
			(
				if driven_wheels[i] != undefined do
				(
					if driven_wheels[i] == rootnode.car_general_attributes.flwheel_model.name do driven_array[1] = (0+i)
					if driven_wheels[i] == rootnode.car_general_attributes.frwheel_model.name do driven_array[2] = (0+i)
					if driven_wheels[i] == rootnode.car_general_attributes.rlwheel_model.name do driven_array[3] = (0+i)
					if driven_wheels[i] == rootnode.car_general_attributes.rrwheel_model.name do driven_array[4] = (0+i)
				)
			)
			format "%,%,%,%" driven_array[1] driven_array[2] driven_array[3] driven_array[4] to:txt_file
			format "	//driven wheels %\n" driven_wheels to:txt_file
		)
		else format "-1,-1,2,1\n" to:txt_file
		
		nondriven_wheels = #()
		for i = 1 to rootnode.car_general_attributes.nondriven_wheels.count do
		(
			if rootnode.car_general_attributes.nondriven_wheels[i] != undefined do append nondriven_wheels rootnode.car_general_attributes.nondriven_wheels[i].name
		)
		if nondriven_wheels[1] != undefined then
		(
			nondriven_array = #(-1,-1,-1,-1)
			for i = 1 to 4 do
			(
				if nondriven_wheels[i] != undefined do
				(
					if nondriven_wheels[i] == rootnode.car_general_attributes.flwheel_model.name do nondriven_array[1] = (4+i)
					if nondriven_wheels[i] == rootnode.car_general_attributes.frwheel_model.name do nondriven_array[2] = (4+i)
					if nondriven_wheels[i] == rootnode.car_general_attributes.rlwheel_model.name do nondriven_array[3] = (4+i)
					if nondriven_wheels[i] == rootnode.car_general_attributes.rrwheel_model.name do nondriven_array[4] = (4+i)
				)
			)
			format "%,%,%,%" nondriven_array[1] nondriven_array[2] nondriven_array[3] nondriven_array[4] to:txt_file
			format "	//nondriven wheels %\n\n" nondriven_wheels to:txt_file
		)
		else format "10,9,-1,-1\n\n" to:txt_file
			
		format "%	// Driven wheels diameter\n" rootnode.car_general_attributes.driven_wheels_diameter to:txt_file
		format "%	// Non-driven wheels diameter\n\n" rootnode.car_general_attributes.nondriven_wheels_diameter to:txt_file
		
		--START OF FUNK

		format "START OF FUNK\n\nEND OF FUNK\n\n" to:txt_file
		
		--START OF GROOVE
		
		format "START OF GROOVE\n\n" to:txt_file
		
		for i= 1 to grooves.count do
		(
			if custattributes.get grooves[i] groove_data_CA != undefined do
			(
				format "%\n" (grooves[i].name) to:txt_file
				if grooves[i].groove_data.groove_lollipop_param == 1 do format  "None\n" to:txt_file
				if grooves[i].groove_data.groove_lollipop_param == 2 do format  "Xlollipop\n" to:txt_file
				if grooves[i].groove_data.groove_lollipop_param == 3 do format  "Ylollipop\n" to:txt_file
				if grooves[i].groove_data.groove_lollipop_param == 4 do format  "Zlollipop\n" to:txt_file
				
				if grooves[i].groove_data.groove_distance_param == 1 do format "Distance\n" to:txt_file
				if grooves[i].groove_data.groove_distance_param == 2 do format "Constant\n" to:txt_file
					
				if grooves[i].groove_data.groove_path_type_param == 1 do format  "No path\n" to:txt_file
				if grooves[i].groove_data.groove_path_type_param == 2 do
				(
					format "Straight\n" to:txt_file
					path_modes = #("Linear", "Harmonic", "Flash","Absolute")
					path_mode = grooves[i].groove_data.groove_path_mode_param
					format "%\n" path_modes[path_mode] to:txt_file
					format "%,%,%\n" grooves[i].groove_data.groove_path_center_X_param grooves[i].groove_data.groove_path_center_Z_param -grooves[i].groove_data.groove_path_center_Y_param to:txt_file
					if path_mode == 4 then
					(
						flfound = finditem flsusp grooves[i].name
						frfound = finditem frsusp grooves[i].name
						rlfound = finditem rlsusp grooves[i].name
						rrfound = finditem rrsusp grooves[i].name
						if flfound != 0 do format "%\n" (flfound+8) to:txt_file
						if frfound != 0 do format "%\n" (frfound+12) to:txt_file
						if rlfound != 0 do format "%\n" (rlfound+16) to:txt_file
						if rrfound != 0 do format "%\n" (rrfound+18) to:txt_file
					)
					else 
					(
						format "%\n" grooves[i].groove_data.groove_path_speed_param to:txt_file
					)
					format "%,%,%\n" grooves[i].groove_data.groove_path_extent_X_param grooves[i].groove_data.groove_path_extent_Z_param -grooves[i].groove_data.groove_path_extent_Y_param to:txt_file
				)
				if grooves[i].groove_data.groove_path_type_param == 3 do
				(
					format "Circular\n" to:txt_file
					path_modes = #("Linear", "Harmonic", "Flash","Continuous","Absolute","Controlled")
					path_mode = grooves[i].groove_data.groove_path_mode_param
					if path_mode == 5 or path_mode == 6 then format "%\n" "Linear"to:txt_file
					else 	format "%\n" path_mode to:txt_file
					format "%,%,%\n" grooves[i].groove_data.groove_path_center_X_param grooves[i].groove_data.groove_path_center_Z_param -grooves[i].groove_data.groove_path_center_Y_param to:txt_file
					format "%\n" grooves[i].groove_data.groove_path_speed_param to:txt_file
					format "%\n" grooves[i].groove_data.groove_path_radius_param to:txt_file
					format "%\n" grooves[i].groove_data.groove_path_axis_param to:txt_file
				)
				animation_types = #("None","Spin","Rock","Shear","Throb")
				animation_modes = #("Linear","Harmonic","Flash","Continuous","Absolute","Controlled")
				if grooves[i].groove_data.groove_animation_type_param == 1 do 
				(
					format "None\n" to:txt_file
				)
				if grooves[i].groove_data.groove_animation_type_param == 2 do 
				(
					format "Spin\n" to:txt_file
					animation_mode = grooves[i].groove_data.groove_animation_mode_param
					
					format  "%\n" animation_modes[grooves[i].groove_data.groove_animation_mode_param] to:txt_file
					if animation_mode == 6 then
					(
						driven_wheels = rootnode.car_general_attributes.driven_wheels
						nondriven_wheels = rootnode.car_general_attributes.nondriven_wheels
						driven_found = finditem driven_wheels grooves[i]
						nondriven_found = finditem nondriven_wheels grooves[i]
						if driven_found != 0 do format "%\n" (driven_found) to:txt_file
						if nondriven_found != 0 do format "%\n" (nondriven_found+4) to:txt_file
						--format "%,%,%\n" grooves[i].center.x grooves[i].center.z -grooves[i].center.y to:txt_file
						format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
					)
					else
					(
						format  "%\n" grooves[i].groove_data.groove_animation_speed_param to:txt_file
						format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
					)
					groove_axis = grooves[i].groove_data.groove_animation_axis_param
					if groove_axis == 1 do format  "x\n" to:txt_file
					if groove_axis == 2 do format  "y\n" to:txt_file
					if groove_axis == 3 do format  "z\n" to:txt_file
				)
				if grooves[i].groove_data.groove_animation_type_param == 3 do 
				(
					format "Rock\n" to:txt_file
					
					animation_mode = grooves[i].groove_data.groove_animation_mode_param
					format  "%\n" animation_modes[animation_mode] to:txt_file
					if animation_mode == 5 or animation_mode == 6 then
					(
						steeringwheels = rootnode.car_general_attributes.steering_wheels
						steeringfound = finditem steeringwheels grooves[i]
						if steeringfound != 0 do format "%\n" (steeringfound + 20) to:txt_file
					)
					else format  "%\n" grooves[i].groove_data.groove_animation_speed_param to:txt_file
					format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
					groove_axis = grooves[i].groove_data.groove_animation_axis_param
					if groove_axis == 1 do format  "x\n" to:txt_file
					if groove_axis == 2 do format  "y\n" to:txt_file
					if groove_axis == 3 do format  "z\n" to:txt_file
					format  "%\n" grooves[i].groove_data.groove_animation_angle_param to:txt_file
				)
				if grooves[i].groove_data.groove_animation_type_param == 4 do 
				(
					format "Shear\n" to:txt_file
					format  "%\n" animation_modes[grooves[i].groove_data.groove_animation_mode_param] to:txt_file
					format  "%,%,%\n" grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param to:txt_file
					format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
					format "%,%,%\n" grooves[i].groove_data.groove_animation_extent_x_param grooves[i].groove_data.groove_animation_extent_z_param -grooves[i].groove_data.groove_animation_extent_y_param to:txt_file
				)
				if grooves[i].groove_data.groove_animation_type_param == 5 do 
				(
					format "Throb\n" to:txt_file
					format  "%\n" animation_modes[grooves[i].groove_data.groove_animation_mode_param] to:txt_file
					format  "%,%,%\n" grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param to:txt_file
					format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
					format "%,%,%\n" grooves[i].groove_data.groove_animation_extent_x_param grooves[i].groove_data.groove_animation_extent_z_param -grooves[i].groove_data.groove_animation_extent_y_param to:txt_file
				)
				if i != grooves.count do
				(
					format "\nNEXT GROOVE\n\n" to:txt_file
				)
			)
		)
		
		format "\nEND OF GROOVE\n\n" to:txt_file
		
		--MECHANICS STUFF
		
		format "START OF MECHANICS STUFF version 1\n\n" to:txt_file
		
		format "%	//minimum turning circle\n" rootnode.car_general_attributes.minimum_turning_circle to:txt_file
		format "%	//brake multiplier\n" rootnode.car_general_attributes.brake_multiplier to:txt_file
		format "%	//brake strength multiplier\n" rootnode.car_general_attributes.brake_strength_multiplier to:txt_file
		format "%	//number of gears\n" rootnode.car_general_attributes.number_of_gears to:txt_file
		format "%	//top speed\n" rootnode.car_general_attributes.top_speed to:txt_file
		format "%	//top gear acceleration\n\n" rootnode.car_general_attributes.top_acceleration to:txt_file
		format "// Sub member: Root part\n" to:txt_file
		format "normal			//type\n" to:txt_file
		format "none			//identifier\n" to:txt_file
		if rootnode.car_general_attributes.mainbody_model != undefined then format "%			//Actor\n" rootnode.car_general_attributes.mainbody_model.name to:txt_file
		else format "Eagle3.act	//Actor\n" to:txt_file
		format "// Sub member: Joint data\n" to:txt_file
		format "none			//identifier\n" to:txt_file
		format "%,%,%	//centre of gravity\n" rootnode.car_general_attributes.mainbody_center.x rootnode.car_general_attributes.mainbody_center.z -rootnode.car_general_attributes.mainbody_center.y to:txt_file
		format "%			//Mass\n" rootnode.car_general_attributes.mainbody_mass to:txt_file
		format "%,%,%	//Angular momentum proportions\n" rootnode.car_general_attributes.mainbody_momentum.x rootnode.car_general_attributes.mainbody_momentum.z rootnode.car_general_attributes.mainbody_momentum.y to:txt_file
		format "%			//Downforce\n" rootnode.car_general_attributes.mainbody_downforce to:txt_file
		format "4			//Number of wheels\n" to:txt_file
		format "// Sub member: FL wheel\n" to:txt_file
		format "0				//type\n" to:txt_file
		format "left front			//identifier\n" to:txt_file
		flwheel = rootnode.car_general_attributes.flwheel_model
		if flwheel != undefine then 
		(
			format "%				//Actor\n" flwheel.name to:txt_file
			format "%,%,%	//Position\n" flwheel.center.x flwheel.center.z -flwheel.center.y to:txt_file
		)
		else 
		(
			format "flwheel.act				//Actor\n" to:txt_file
			format "-0.16,0.06,-0.24	//Position\n" to:txt_file
		)
		drivenflag = rootnode.car_general_attributes.fldriven
		if drivenflag == 1 do
		(
			format "1				//steerable_flags\n0				//driven flags\n" to:txt_file
		)
		if drivenflag == 2 do
		(
			format "0				//steerable_flags\n1				//driven flags\n" to:txt_file
		)
		format "%				//Suspension give\n" rootnode.car_general_attributes.flsuspgive to:txt_file
		format "%				//Damping factor\n" rootnode.car_general_attributes.fldamping to:txt_file
		format "%				//Fractional reduction in friction when slipping\n" rootnode.car_general_attributes.flredux to:txt_file
		format "%,%			//Friction angles\n" rootnode.car_general_attributes.flangle1 rootnode.car_general_attributes.flangle2 to:txt_file
		format "%				//Traction fractional multiplier\n" rootnode.car_general_attributes.fltrmultip to:txt_file
		format "%				//Rolling resistance\n" rootnode.car_general_attributes.flrrest to:txt_file
		
		format "// Sub member: FR wheel\n" to:txt_file
		format "0				//type\n" to:txt_file
		format "right front			//identifier\n" to:txt_file
		frwheel = rootnode.car_general_attributes.frwheel_model
		if frwheel != undefine then 
		(
			format "%				//Actor\n" frwheel.name to:txt_file
			format "%,%,%	//Position\n" frwheel.center.x frwheel.center.z -frwheel.center.y to:txt_file
		)
		else 
		(
			format "frwheel.act				//Actor\n" to:txt_file
			format "-0.16,0.06,-0.24	//Position\n" to:txt_file
		)
		drivenflag = rootnode.car_general_attributes.frdriven
		if drivenflag == 1 do
		(
			format "1				//steerable_flags\n0				//driven flags\n" to:txt_file
		)
		if drivenflag == 2 do
		(
			format "0				//steerable_flags\n1				//driven flags\n" to:txt_file
		)

		format "%				//Suspension give\n" rootnode.car_general_attributes.frsuspgive to:txt_file
		format "%				//Damping factor\n" rootnode.car_general_attributes.frdamping to:txt_file
		format "%				//Fractional reduction in friction when slipping\n" rootnode.car_general_attributes.frredux to:txt_file
		format "%,%			//Friction angles\n" rootnode.car_general_attributes.frangle1 rootnode.car_general_attributes.frangle2 to:txt_file
		format "%				//Traction fractional multiplier\n" rootnode.car_general_attributes.frtrmultip to:txt_file
		format "%				//Rolling resistance\n" rootnode.car_general_attributes.frrrest to:txt_file
		
		format "// Sub member: RL wheel\n" to:txt_file
		format "0				//type\n" to:txt_file
		format "left rear			//identifier\n" to:txt_file
		rlwheel = rootnode.car_general_attributes.rlwheel_model
		if rlwheel != undefine then 
		(
			format "%				//Actor\n" rlwheel.name to:txt_file
			format "%,%,%	//Position\n" rlwheel.center.x rlwheel.center.z -rlwheel.center.y to:txt_file
		)
		else 
		(
			format "rlwheel.act				//Actor\n" to:txt_file
			format "-0.16,0.06,-0.24	//Position\n" to:txt_file
		)
		drivenflag = rootnode.car_general_attributes.rldriven

		if drivenflag == 1 do
		(
			format "1				//steerable_flags\n0				//driven flags\n" to:txt_file
		)
		if drivenflag == 2 do
		(
			format "0				//steerable_flags\n1				//driven flags\n" to:txt_file
		)

		format "%				//Suspension give\n" rootnode.car_general_attributes.rlsuspgive to:txt_file
		format "%				//Damping factor\n" rootnode.car_general_attributes.rldamping to:txt_file
		format "%				//Fractional reduction in friction when slipping\n" rootnode.car_general_attributes.rlredux to:txt_file
		format "%,%			//Friction angles\n" rootnode.car_general_attributes.rlangle1 rootnode.car_general_attributes.rlangle2 to:txt_file
		format "%				//Traction fractional multiplier\n" rootnode.car_general_attributes.rltrmultip to:txt_file
		format "%				//Rolling resistance\n" rootnode.car_general_attributes.rlrrest to:txt_file
		
		format "// Sub member: RR wheel\n" to:txt_file
		format "0				//type\n" to:txt_file
		format "right rear			//identifier\n" to:txt_file
		rrwheel = rootnode.car_general_attributes.rrwheel_model
		if rrwheel != undefine then 
		(
			format "%				//Actor\n" rrwheel.name to:txt_file
			format "%,%,%	//Position\n" rrwheel.center.x rrwheel.center.z -rrwheel.center.y to:txt_file
		)
		else 
		(
			format "rrwheel.act				//Actor\n" to:txt_file
			format "-0.16,0.06,-0.24	//Position\n" to:txt_file
		)
		drivenflag = rootnode.car_general_attributes.rrdriven
		if drivenflag == 1 do
		(
			format "1				//steerable_flags\n0				//driven flags\n" to:txt_file
		)
		if drivenflag == 2 do
		(
			format "0				//steerable_flags\n1				//driven flags\n" to:txt_file
		)

		format "%				//Suspension give\n" rootnode.car_general_attributes.rrsuspgive to:txt_file
		format "%				//Damping factor\n" rootnode.car_general_attributes.rrdamping to:txt_file
		format "%				//Fractional reduction in friction when slipping\n" rootnode.car_general_attributes.rrredux to:txt_file
		format "%,%			//Friction angles\n" rootnode.car_general_attributes.rrangle1 rootnode.car_general_attributes.rrangle2 to:txt_file
		format "%				//Traction fractional multiplier\n" rootnode.car_general_attributes.rrtrmultip to:txt_file
		format "%				//Rolling resistance\n" rootnode.car_general_attributes.rrrrest to:txt_file
		
		format "\n" to:txt_file
		
		bounding_shapes = #()
		bounding_shapes_types = #()
		bshape1 = rootnode.car_general_attributes.bshape1
		bshape1_type = rootnode.car_general_attributes.bshape1_type
		bshape2 = rootnode.car_general_attributes.bshape2
		bshape2_type = rootnode.car_general_attributes.bshape2_type
		bshape3 = rootnode.car_general_attributes.bshape3
		bshape3_type = rootnode.car_general_attributes.bshape3_type
		if bshape1 != undefined do 
		(
			append bounding_shapes bshape1 
			append bounding_shapes_types bshape1_type
		)
		if bshape2 != undefined do 
		(
			append bounding_shapes bshape2
			append bounding_shapes_types bshape2_type
		)
		if bshape3 != undefined do 
		(
			append bounding_shapes bshape3
			append bounding_shapes_types bshape3_type
		)
		
		if bounding_shapes.count != 0 then
		(
			format "%	//number of bounding shapes\n\n" bounding_shapes.count to:txt_file
			for i=1 to bounding_shapes.count do
			(
				bshape = bounding_shapes[i]
				bshape_type = bounding_shapes_types[i]
				if bshape_type == 1 do
				(
					polyhedron = snapshotasmesh bounding_shapes[i]
					pointcount = getnumverts polyhedron
					if pointcount != undefined and pointcount != 0 and pointcount < 32 then
					(
						format "Polyhedron\n" to:txt_file
						format "% \n \n" pointcount to:txt_file
						for j=1 to pointcount do
						(
							pointindex = getvert polyhedron j
							format "% ,% ,% \n"  (round pointindex.x) (round pointindex.z) (round -pointindex.y) to:txt_file
						)
						format "\n" to:txt_file
					)
					else format "Polyhedron	//type\n1\n\n0,0,0	//sorry but the shape cannot have more than 32 points\n\n" to:txt_file
				)
				--if bshape_type == 2 do
				--(
				--	format "box\n%,%,%\n" (round bounding_shapes[i].min.x) (round bounding_shapes[i].min.z) (round -bounding_shapes[i].min.y) to:txt_file
				--	format "%,%,%\n" (round bounding_shapes[i].max.x) (round bounding_shapes[i].max.z) (round -bounding_shapes[i].max.y) to:txt_file
				--)
				if bshape_type == 2 do
				(
					radius = (bounding_shapes[i].max).x - (bounding_shapes[i].center).x
					format "sphere\n"
					format "% \n" (round radius) to:txt_file
					format "%,%,% \n \n" (round (bounding_shapes[i].center).x) (round (bounding_shapes[i].center).z) (round -(bounding_shapes[i].center).y) to:txt_file
				)
				if bshape_type == 3 do
				(
					if (classof bounding_shapes[i]) == line then
					(
						format "Wire frame \n \n" to:txt_file
						numberofnodes = numknots object
						format "%				//number of points \n" numberofnodes to:txt_file
						for k = 1 to (numknots object) do
						(
							pointCoord = getKnotPoint object 1 k
							format "% ,% ,% \n" (round pointCoord.x) (round pointCoord.z) (round -pointCoord.y) to:txt_file
						)
						format "%				//number of segments \n" (numsegments object 1) to:txt_file
						knotnr = 0
						for k = 1 to (numsegments object 1) do
						(
							format "%,%  \n" knotnr (knotnr + 1) to:txt_file
							knotnr = (knotnr + 1)
						)
						format "\n" to:txt_file
					)
					else
					(
						format "Wire frame //this object is not a line shape! a dummy will be used\n" to:txt_file
						format "2	//number of points\n" to:txt_file
						format "0,0,0\n0.1,0.1,0.1\n" to:txt_file
						format "1	//number of segments\n" to:txt_file
						format "0,1\n" to:txt_file
					)
				)
			)
		)
		else
		(
			mainbody = rootnode.car_general_attributes.mainbody_model
			format "1	//number of bounding shapes\n\n" to:txt_file
			format "box\n%,%,%\n" (round mainbody.min.x) (round mainbody.min.z) (round -mainbody.min.y) to:txt_file
			format "%,%,%\n\n" (round mainbody.max.x) (round mainbody.max.z) (round -mainbody.max.y) to:txt_file
		)
		format "0\n\nEND OF MECHANICS STUFF\n\n" to:txt_file
		
		shrapnels = #()
		shrapnel1 = rootnode.car_general_attributes.shrapnel1
		shrapnel2 = rootnode.car_general_attributes.shrapnel2
		shrapnel3 = rootnode.car_general_attributes.shrapnel3
		if shrapnel1 != (color 255 255 255) do append shrapnels shrapnel1
		if shrapnel2 != (color 255 255 255) do append shrapnels shrapnel2
		if shrapnel3 != (color 255 255 255) do append shrapnels shrapnel3
		if shrapnels.count != 0 then
		(
			format "\n%\n" shrapnels.count to:txt_file
			for i=1 to shrapnels.count do
			(
				format "%,%,%\n" shrapnels[i].r shrapnels[i].g shrapnels[i].b to:txt_file
			)
			format "\n" to:txt_file
		)
		else
		(
			format "1\n1,1,1\n\n" to:txt_file
		)
		
		format "//damage points\n" to:txt_file
		mainbody = snapshotasmesh rootnode.car_general_attributes.mainbody_model
		if mainbody != undefined do
		(
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_engine) to:txt_file			
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_transmission) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_driver) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_steering) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_flbrake) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_frbrake) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_rlbrake) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_rrbrake) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_flwheel) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_frwheel) to:txt_file
			format "%\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_rlwheel) to:txt_file 
			format "%\n\n" (vert_to_tvert mainbody rootnode.car_general_attributes.firepoint_rrwheel) to:txt_file
		)
		if mainbody == undefined do
		(
			format "0\n0\n0\n0\n0\n0\n0\n0\n0\n0\n0\n0\n\n" to:txt_file
		)
		
		format "//start of keyword stuff\n" to:txt_file
		format "CAMERA_POSITIONS\n" to:txt_file
		bumper_cam = rootnode.car_general_attributes.bumper_cam
		cockpit_cam = rootnode.car_general_attributes.cockpit_cam
		format "%,%,%\n" bumper_cam.x bumper_cam.z -bumper_cam.y to:txt_file 
		format "%,%,%\n\n" cockpit_cam.x cockpit_cam.z -cockpit_cam.y to:txt_file 

		
		format "END" to:txt_file

		close txt_file
		--close txt_name
	)
)
