fn round f = 
(
	(((f * 1000000) as integer) as float / 1000000)
)

fn vert_to_tvert a f =
(
	nbfaces = getNumFaces a
	for i=1 to nbfaces do 
	(
		face = getface a i
		if (face.x as integer) == f do 
		(
			global tvert = (gettvface a i).x
		)
		if (face.y as integer) == f do
		(
			global tvert = (gettvface a i).y
		)
		if (face.z as integer) == f do
		(
			global tvert = (gettvface a i).z
		)		
	)
	tvert = (tvert as integer)-1
)

exportname = GetSaveFileName caption:"Choose an exportname" types:"Wam(*.wam)"
if exportname != undefined do
(
	wam_name = getfilenamefile exportname +  ".wam"
	if wam_name != undefined then
	(
		
		wams = #()
		for object in objects do
		(
			if custattributes.get object wam_data_CA != undefined do
			(
				append wams object
			)
		)
		
		wam_file = createfile wam_name
		
		format "VERSION 4\n\n" to:wam_file
		mainbody = rootnode.car_general_attributes.mainbody_model
		if mainbody != undefined then
		(
			format "2\n%\n%\n" rootnode.car_general_attributes.wam_x_min1 rootnode.car_general_attributes.wam_x_min2 to:wam_file
			format "2\n%\n%\n" rootnode.car_general_attributes.wam_x_max1 rootnode.car_general_attributes.wam_x_max2 to:wam_file
			format "2\n%\n%\n" rootnode.car_general_attributes.wam_z_min1 rootnode.car_general_attributes.wam_z_min2 to:wam_file
			format "2\n%\n%\n" rootnode.car_general_attributes.wam_z_max1 rootnode.car_general_attributes.wam_z_max2 to:wam_file
			format "2\n%\n%\n" -rootnode.car_general_attributes.wam_y_min1 -rootnode.car_general_attributes.wam_y_min2 to:wam_file
			format "2\n%\n%\n" -rootnode.car_general_attributes.wam_y_max1 -rootnode.car_general_attributes.wam_y_max2 to:wam_file
			format "%\n%\n%\n" rootnode.car_general_attributes.bendabillity_factor rootnode.car_general_attributes.bend_point_zmin rootnode.car_general_attributes.bend_point_zmax to:wam_file
			format "%\n%\n" rootnode.car_general_attributes.snappabillity_factor rootnode.car_general_attributes.y_split_position to:wam_file
			format "%,%,%\n\n" rootnode.car_general_attributes.driver_pos_x rootnode.car_general_attributes.driver_pos_z -rootnode.car_general_attributes.driver_pos_y to:wam_file
		)
		else
		(
		)
		
		format "%\n\n" wams.count to:wam_file
		
		for i=1 to wams.count do
		(
			wam = wams[i]
			format "%\n" wam.name to:wam_file
			softness = wam.wam_data.softness
			softness_options = #("soft", "normal", "hard", "uncrushable")
			format "%\n" softness_options[softness] to:wam_file
			crush_type = wam.wam_data.crush_type
			if crush_type == 1 do
			(
				format "boring\n" to:wam_file
			)
			if crush_type ==2 do
			(
				format "flap\n" to:wam_file
				flap = snapshotasmesh wam
				format "%\n" (vert_to_tvert flap wam.wam_data.flap_point1_param) to:wam_file
				format "%\n" (vert_to_tvert flap wam.wam_data.flap_point2_param) to:wam_file
				format "%\n" (vert_to_tvert flap wam.wam_data.flap_point3_param) to:wam_file
				format "%\n" wam.wam_data.flap_openable to:wam_file
				ease_options = #("very_easy","easy","normal","difficult","very_difficult")
				format "%\n" ease_options[wam.wam_data.flap_ease] to:wam_file
				box_options = #("box","sphere")
				format "%\n" box_options[wam.wam_data.flap_box] to:wam_file
			)
			if crush_type ==3 do
			(
				format "detach\n" to:wam_file
				ease_options = #("very_easy","easy","normal","difficult","very_difficult")
				format "%\n" ease_options[wam.wam_data.detach_ease] to:wam_file
				type_options = #("normal","stubborn","fully_detach")
				format "%\n" type_options[wam.wam_data.detach_type] to:wam_file
				box_options = #("box","sphere")
				format "%\n" box_options[wam.wam_data.detach_box] to:wam_file
			)
			smash_data = wam.wam_data.smash_data
			if smash_data == 0 do 
			(
				format "0\n\n" to:wam_file
			)
			if smash_data != 0 do
			(
				format "0\n\n" to:wam_file
			)
		)
		close wam_file
	)
)
