SEV_data_CA = attributes SEV_data
attribID:#(0x74cbc30e, 0x660a07ba)
(
parameters SEV_data_params rollout:SEV_data_rollout
	(
		SEV_gravity ui:SEV_gravity type:#float default:1
		SEV_viscosity ui:SEV_viscosity type:#float default:1
		SEV_cameffect ui:SEV_cameffect type:#integer default:1
		SEV_skycolor ui:SEV_skycolor type:#integer default:1
		SEV_entersnd ui:SEV_entersnd type:#integer default:1600
		SEV_exitsnd ui:SEV_exitsnd type:#integer default:1600
		SEV_engsnd ui:SEV_engsnd type:#integer default:1
		SEV_materialindex ui:SEV_materialindex type:#integer default:1
		SEV_Soundtype_param ui:SEV_Soundtype type:#integer default:1
		SEV_Sounddelay_param ui:SEV_Sounddelay type:#integer default:1
		SEV_minimumint ui:SEV_minimumint type:#integer default:1
		SEV_maximumint ui:SEV_maximumint type:#integer default:5
		SEV_sounds_param ui:SEV_sounds type:#stringtab tabSize:1 tabsizevariable:true default:("None")
	)

	rollout SEV_data_rollout "Env Box Properties"
	(
		group "Properties"
		(
		spinner SEV_gravity "Gravity Multiplier:" type:#float range:[-100,100,1] scale: 0.1 fieldWidth:40
		spinner SEV_viscosity "Viscosity Multiplier:" type:#float range:[-100,100,1] scale: 0.1 fieldWidth:40 value:1
		spinner SEV_cameffect "Camera effect:" type:#integer range:[0,1,1] fieldWidth:40
		spinner SEV_skycolor "Sky colour:" type:#integer range:[-1,100,-1] scale: 1 fieldWidth:40
		spinner SEV_entersnd "Enter Sound ID:" type:#integer range:[0,9999,1600] scale: 1 fieldWidth:40
		spinner SEV_exitsnd "Exit Sound ID:" type:#integer range:[0,9999,1600] scale: 1 fieldWidth:40
		spinner SEV_engsnd "Engine Sound:" type:#integer range:[1,2,1] fieldWidth:40
		spinner SEV_materialindex "Material Index:" type:#integer range:[0,99,0] fieldWidth:40
		dropdownlist SEV_Soundtype "Sound Type" items:#("NONE", "SATURATED", "SCATTERED") selection:1
		dropdownlist SEV_Sounddelay "Sound Delay" items:#("RANDOM", "CONTINUOUS") selection:1 enabled:(SEV_soundtype_param !=1)
		spinner SEV_minimumint "Minimum Interval:" type:#integer range:[0,99,1] fieldWidth:40 enabled:(SEV_soundtype_param !=1) enabled:(SEV_sounddelay !=2)
		spinner SEV_maximumint "Maximum Interval:" type:#integer range:[0,99,5] fieldWidth:40 enabled:(SEV_soundtype_param !=1) enabled:(SEV_sounddelay !=2)
		label SEV_soundnumber "Type sound id's below" align:#left enabled:(SEV_soundtype_param !=1)
		combobox SEV_sounds "Sounds" items:#("None") offset:[-4,0]width:140 enabled:(SEV_soundtype_param !=1) height:5
		button SEV_add_sound "Add" across:2
		button SEV_remove_sound "Remove"
		)
		on SEV_sounds entered id do 
		(
			SEV_sounds.selected = id 
			SEV_sounds_param = SEV_sounds.items
		)
		
		on SEV_add_sound pressed do
		(
			sounds = SEV_sounds.items
			append sounds "0000"
			SEV_sounds.items = sounds
		)
		on SEV_remove_sound pressed do 
		(
			
			sounds = SEV_sounds.items
			if sounds.count != 1 do
			(
				deleteitem sounds SEV_sounds.selection
				SEV_sounds.items = sounds
				SEV_sounds_param = SEV_sounds.items
			)
			if sounds.count == 1 do
			(
				sounds[1] = "none"
				SEV_sounds.items = sounds
				SEV_sounds_param = SEV_sounds.items
			)
		)
		
		on SEV_data_rollout open do
		(
			SEV_sounds.items = SEV_sounds_param as array
			if SEV_soundtype.selection == 1 then
			(
				SEV_Sounddelay.enabled = false
				SEV_minimumint.enabled = false
				SEV_maximumint.enabled = false
				SEV_soundnumber.enabled = false
				SEV_sounds.enabled = false
			)
			else
			(
				if SEV_sounddelay.selection == 1 then
				(
					SEV_Sounddelay.enabled = true
					SEV_minimumint.enabled = true
					SEV_maximumint.enabled = true
					SEV_soundnumber.enabled = true
					SEV_sounds.enabled = true
				)
				if SEV_sounddelay.selection == 2 then
				(
					SEV_Sounddelay.enabled = true
					SEV_minimumint.enabled = false
					SEV_maximumint.enabled = false
					SEV_soundnumber.enabled = true
					SEV_sounds.enabled = true
				)
			)
		)
		
		on SEV_soundtype selected i do 
		(
			if i == 1 then
			(
				SEV_Sounddelay.enabled = false
				SEV_minimumint.enabled = false
				SEV_maximumint.enabled = false
				SEV_soundnumber.enabled = false
				SEV_sounds.enabled = false
			)
			if i != 1 do
			(
				if SEV_sounddelay.selection == 1 then
				(
					SEV_Sounddelay.enabled = true
					SEV_minimumint.enabled = true
					SEV_maximumint.enabled = true
					SEV_soundnumber.enabled = true
					SEV_sounds.enabled = true
				)
				if SEV_sounddelay.selection == 2 then
				(
					SEV_Sounddelay.enabled = true
					SEV_minimumint.enabled = false
					SEV_maximumint.enabled = false
					SEV_soundnumber.enabled = true
					SEV_sounds.enabled = true
				)
			)
		)
		on SEV_sounddelay selected i do
		(
			if i == 1 then
			(
				SEV_minimumint.enabled = true
				SEV_maximumint.enabled = true
				SEV_soundnumber.enabled = true
				SEV_sounds.enabled = true
			)
			if i != 1 then
			(
				SEV_minimumint.enabled = false
				SEV_maximumint.enabled = false
				SEV_soundnumber.enabled = true
				SEV_sounds.enabled = true
			)
		)
	)
)
