--ACT/DAT/MAT EXPORTER UTIL BY HARMALARM
--build date april 29 2012

exportname = GetSaveFileName caption:"Choose an exportname" types:"Sdf(*.Sdf)" --create a filename and create appropriate files

if exportname != undefined then
(
	sdf_name = getfilenamefile exportname +  ".Sdf" --create 5 files, SDF, ACT,DAT,MAT and a log txt file
	if sdf_name != undefined then
	(
		sdf_file = createfile sdf_name
		close sdf_file
	)
	act_name = getfilenamefile exportname + ".ACT"
	if act_name != undefined then 
	(
		act_file = createfile act_name
		close act_file
		global actorname = "undefined"
		global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
		global actorbboxmax = [1,1,1]
		global actorbboxmin	= [1,1,1]
		global modelname = "undefined"
		global actortype = 8
		global actormode = 1
	)
	dat_name = getfilenamefile exportname +".DAT"
	if dat_name != undefined then 
	(
		dat_file = createfile dat_name
		close dat_file
	)
	mat_name = getfilenamefile exportname +".MAT"
	if mat_name != undefined then 
	(
		mat_file = createfile mat_name
		close mat_file
		global matmaterial = standard()
					
		global matdiffuse = (color 255 255 255)
		global matambient = 0.175
		global matdirect = 1.0
		global matspecular = 0
		global matspecularlevel = 20
		global flags = 37 --standard flag value for smooth, lit and texture correct
		
		global identifier = "undefined.mat"
		global texture = undefined
	)
	
	log_name = getfilenamefile exportname + "_errors.txt"
	if log_name != undefined then
	(
		log_file = createfile log_name
	)
	
	fn floatSwap2 f = --float swapping function
	(
			i = bit.floatAsInt f
			h = bit.intashex i
			while h.count < 8 do h = "0" + h
			
			s = (substring h 7 2) + (substring h 5 2) + (substring h 3 2) + (substring h 1 2)
			bit.intAsFloat (bit.hexasint s)
	)   
	fn SwapLong f = --long byte swapping function
	(
		a = bit.swapBytes f 1 4
		b = bit.swapBytes a 2 3
		b
	)
	fn swapshort f = bit.swapBytes f 1 2 --short byte swapping function

	fn writeactorbase f = -- the following funtions define the export of the actor properties per object.
	(
		
		f=fopen act_name "ab"
		
		WriteLong f (swaplong 35) --actor name and attributes
		WriteLong f (swaplong 0)
		writebyte f (actortype)
		writebyte f (actormode)
		WriteString f (actorname as String)
		WriteLong f (swaplong 43)	 --start of the transformation matrix settings.
		WriteLong f (swaplong 48)
		actortm = matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0] * actortm * inverse(matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0])
		WriteFloat f (Floatswap2 actortm.row1.x) -- transformation matrix of the parent
		WriteFloat f (Floatswap2 actortm.row1.y)
		WriteFloat f (Floatswap2 actortm.row1.z)
		WriteFloat f (Floatswap2 actortm.row2.x)
		WriteFloat f (Floatswap2 actortm.row2.y)
		WriteFloat f (Floatswap2 actortm.row2.z)
		WriteFloat f (Floatswap2 actortm.row3.x)
		WriteFloat f (Floatswap2 actortm.row3.y)
		WriteFloat f (Floatswap2 actortm.row3.z)
		WriteFloat f (Floatswap2 actortm.row4.x)
		WriteFloat f (Floatswap2 actortm.row4.y)
		WriteFloat f (Floatswap2 actortm.row4.z)
		
		WriteLong f (swaplong 37) --unknown... no data FIGURE THIS OUT!
		Writelong f (swaplong 0)
		fclose f
		
		if actorbbox == undefined then
		(
		)
		else
		(
		f=fopen act_name "ab"	
		WriteLong f (swaplong 50) --start of bounding box
		Writelong f (swaplong 0) --lenght byte, unused

		WriteFloat f (Floatswap2 actorbboxmin.x)
		WriteFloat f (Floatswap2 actorbboxmin.y)
		WriteFloat f (Floatswap2 actorbboxmin.z)
		WriteFloat f (Floatswap2 actorbboxmax.x)
		WriteFloat f (Floatswap2 actorbboxmax.y)
		WriteFloat f (Floatswap2 actorbboxmax.z)
		fclose f
		)
		
		if modelname == undefined then -- check whether there is a model or not
		(
		)
		else
		(
			f=fopen act_name "ab"	
			Writelong f (swaplong 36)
			Writelong f (swaplong 0)
			Writestring f (modelname as String)
			fclose f
		)
		
	)
	fn writehierarchyend f = --actor heirarchy end write function
	(
		f=fopen act_name "ab"
		Writelong f (swaplong 42) --end of group heirarchy level
		Writelong f (swaplong 0)
		fclose f
	)
	fn Writeactorhierarchystart f = --actor hierarchy start write function
	(
		f=fopen act_name "ab"
		Writelong f (swaplong 41) --start of group hierarchy level
		Writelong f (swaplong 0)
		fclose f
	) --end of global funtion definitions
	
	
	f=fopen sdf_name "wb"
	WriteString f ("// Stainless Data File")
	WriteString f ("// Generated by PlayThing2.")
	Writestring f ("//Created: ")

	Writestring f ("blabla")
	Writestring f ("NONE")
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writelong f (swaplong 538976288)
	Writestring f ("File Type Identifier.")
	fclose f
	
	-- first we define functions for the byteswapping needed to get a big endian byte order
	-- the following functions do this for floats, long and short bytes.
	
	global hiddenmodels = #()--start of object indexing
	global exportmodels = #()
	global exportmodelnames = #()
	global exportactors = #()
	global materials = #()
	global diffusematerials = #()
	global diffusecolors = #()
	global exporterrors = #()
	
	deselect objects
	
	for object in objects do --filter hidden models
	(
		--if classof object == line do append hiddenmodels object
		if object.ishidden == true do append hiddenmodels object
		if classof object == dummy do append exportactors object
		if classof object == Particle_View do append hiddenmodels object
		if custAttributes.get object checkpoint_CA != undefined do append hiddenmodels object
		if custAttributes.get object SEV_data_CA != undefined do append hiddenmodels object
		if custAttributes.get object starting_grid_CA != undefined do append hiddenmodels object
		if custAttributes.get object multiplayer_point_CA != undefined do append hiddenmodels object
		if custAttributes.get object noncar_CA != undefined do append hiddenmodels object
		if custAttributes.get object noncar_bboxdata_CA != undefined do append hiddenmodels object
		if object == rootnode.track_general_attributes.opp_path_object do append hiddenmodels object
	)
	
	for object in objects do --filter object instances
	(
		if finditem hiddenmodels object == 0 do
		(
			if classof object == editable_poly or classof object == editable_mesh or classof object == Polymeshobject  or classof object == line or classof object == SplineShape do
			(
				objectprefix=substring object.name 1 1 
				if objectprefix == "&" then
				(
					modelname = trimright (object.name) "1234567890" 
					modelcheck = finditem exportmodelnames modelname --if exsisting skip
					if modelcheck == 0 do
					(
						append exportmodels object
						append exportmodelnames modelname
					)
				)
				else 
				(
					append exportmodels object
					append exportmodelnames object.name
				)
				append exportactors object
			)
		)
	)

	for material in scenematerials do --filter materials on duplicates
	(
		if classof material == standardmaterial do
		(
			materialcheck = finditem materials material
			if materialcheck == 0 do
			(
				append materials material
			)
		)
		if classof material == multimaterial do
		(
			for i=1 to material.numsubs do
			(
				submaterial = getsubmtl material i
				materialcheck = finditem materials submaterial
				if materialcheck == 0 do
				(
					append materials submaterial
				)
			)
		)
	)
	
	global errorbox = box length:0.1 width:0.1 height:0.1 --add an error dummy model to the exportmodelslist
	errorbox.name = "_errorbox"
	convertto errorbox editable_poly
	append exportmodels errorbox

	global exportitems = exportactors.count + exportmodels.count + materials.count

	progressStart "Exporting" --start progressbar
	progresitem = 0

	--ACTORS
	f=fopen act_name "wb"	--write the actor header
	WriteLong f (swaplong 18)
	WriteLong f (swaplong 8)
	WriteLong f (swaplong 1)
	WriteLong f (swaplong 2)
	fclose f
	
	global actorname = getfilenamefile act_name --write empty track actor, as hierarchy parent.
	global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
	global modelname = undefined
	global actortype = 0
	global actormode = 4	
	writeactorbase f

	for object in exportactors do
	(
		if finditem hiddenmodels object == 0 do
		(
			global actorname = object.name
			if (findstring object.name "&") == 1 then --filter instance prefix or not
			(
				global actortm = object.transform
				global modelname = trimright (object.name) "1234567890"
			)
			else
			(
				global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
				global modelname = object.name
			)	
			if (isgrouphead object) then --group support
			(
				global actorname = object.name
				global actorbboxmax = object.max
				global actorbboxmin	= object.min
				global modelname = undefined
				global actortype = 8
				global actormode = 4
			)
			else
			(
				global actorbbox = undefined
				global actortype = 1
				if custAttributes.get object actor_rendermode_CA != undefined then
				(
					global actormode = object.actor_rendermode_attributes.actor_rendermode_param
				)
				else
				(
					if classof object == line or classof object == splineshape then global actormode = 3
					else global actormode = 4
				)
			)
			writeactorbase f

			if object.children.count > 0 do
			(
				for i=1 to object.children.count do
				(
					child1 = object.children[i]
					if finditem hiddenmodels child1 == 0 do
					(
						global actorname = child1.name
						
						if (findstring child1.name "&") == 1 then --filter instance prefix or not
						(
							global modelname =  trimright (child1.name) "1234567890"
							if isgrouphead child1.parent then
							(
								global actortm = child1.transform
							)
							else
							(
								global actortm = child1.transform * (inverse object.transform)
							)
						)
						else
						(
							global modelname = child1.name
							global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
						)
						
						--global actortm = child1.transform * (inverse object.transform)
						if classof child1 == Dummy then
						(
							global modelname = undefined
							global actortype = 0
							global actormodel = 0
						)
						else
						(
							global actortype = 1
							if custAttributes.get child1 actor_rendermode_CA != undefined then
							(
								global actormode = child1.actor_rendermode_attributes.actor_rendermode_param
							)
							else
							(
								if classof child1 == line or classof child1 == splineshape then global actormode = 3
								else global actormode = 4
							)
						)
						global actorbbox = undefined
						writeactorbase f
						if child1.children.count > 0 do
						(
							for j=1 to child1.children.count do
							(
								child2= child1.children [j]
								if finditem hiddenmodels child2 == 0 do
								(
									global actorname = child2.name
									if (findstring child2.name "&") == 1 then --filter instance prefix or not
									(
										global modelname =  trimright (child2.name) "1234567890"
										global actortm = child2.transform * (inverse child1.transform)
									)
									else
									(
										global modelname = child2.name
										global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
									)
									
									global actorbbox = undefined
									global actortype = 1
									if custAttributes.get child2 actor_rendermode_CA != undefined then
									(
										global actormode = child2.actor_rendermode_attributes.actor_rendermode_param
									)
									else
									(
										if classof child2 == line or classof child2 == splineshape then global actormode = 3
										else global actormode = 4
									)							
									writeactorbase f
									if child2.children.count > 0 do
									(
										for k=1 to child2.children.count do
										(
											child3= child2.children [k]
											if finditem hiddenmodels child3 == 0 do
											(
												global actorname = child3.name
												if (findstring child3.name "&") == 1 then --filter instance prefix or not
												(
													global modelname =  trimright (child3.name) "1234567890"
													global actortm = child3.transform * (inverse child2.transform)
												)
												else
												(
													global modelname = child3.name
													global actortm = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
												)
												global actorbbox = undefined
												global actortype = 1
												if custAttributes.get child3 actor_rendermode_CA != undefined then
												(
													global actormode = child3.actor_rendermode_attributes.actor_rendermode_param
												)
												else
												(
													if classof child3 == line or classof child3 == splineshape then global actormode = 3
													else global actormode = 4
												)									
												writeactorbase f
												writehierarchyend f
												append hiddenmodels child3
											)
										)
									)
									writehierarchyend f
									append hiddenmodels child2
								)
							)
						)
						writehierarchyend f
						append hiddenmodels child1
					)
				)
			)
			append hiddenmodels object
			writehierarchyend f
		)
		progresitem+=1 --increase the progress step
		progressUpdate ((100./exportitems*progresitem))--update the progres
	)

	f=fopen act_name "ab" --write the end of the actor file
	Writelong f (swaplong 0)
	Writelong f (swaplong 0)
	fclose f
	
	--MODELS

	fn writemodelentry a = --funtion for dat model entry writing
	(
		objecttmbackup = a.transform
		--k=fopen log_file "ab"
		try
		(
		--fopen log_file "ab"
		f--ormat "%\n" a.name to:log_file
			
			f=fopen dat_name "ab" --write the object creation header
			WriteLong f (swaplong 54)
			Writelong f (swaplong 12)
			WriteByte f 1
			WriteByte f 21
			
			--a = snapshotasmesh a
			
			objectprefix=substring a.name 1 1 --if the object is instanced, the modelname will have to be stripped of incremental numbers
			if objectprefix == "&" then
			(
				modelname =  trimright (a.name) "1234567890"
				a.transform = (matrix3 1)
				writeString f modelname
			)
			else
			(
				modelname = a.name
				WriteString f modelname
			)
			
			WriteLong f (swaplong 23) --start of vertice index
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2			
			actor = snapshotasmesh a
			tvcount = getnumTverts actor
			if tvcount == 0 then
			(
				modelvertices = getnumverts actor
				writelong f (swaplong actor.numverts)
				for j=1 to modelvertices do
				(
					vertice = getvert actor j
					writefloat f (floatswap2 vertice.x)
					writefloat f (floatswap2 vertice.z)
					writefloat f (floatswap2 -vertice.y)
				)
			)
			else
			(
				verts = #()
				nbfaces = getNumFaces actor
				for i=1 to nbfaces do 
				(
					vertindices = getFace actor i
					texindices = getTVFace actor i
					verts[texindices.x] = getVert actor (vertindices.x)
					verts[texindices.y] = getVert actor (vertindices.y)
					verts[texindices.z] = getVert actor (vertindices.z)
				)
				nbTverts = getnumTverts actor
				Writelong f (swaplong verts.count)
				for j=1 to nbTverts do 
				(
					WriteFloat f (floatswap2 verts[j].x)
					WriteFloat f (floatswap2 verts[j].z)
					WriteFloat f (floatswap2 -verts[j].y)
				)
			)	

			Writelong f (swaplong 24) --start of texture coordinates
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
			tvcount = getnumTverts actor
			if tvcount > 0 then
			(
				WriteLong f (swaplong tvcount)
				for v=1 to tvcount do 
				(
					tvert = getTVert actor v
					WriteFloat f (floatswap2 (tvert.x))
					WriteFloat f (floatswap2 (-tvert.y))
				)
			)
			else
			(
				Writelong f (swaplong modelvertices)
				for v = 1 to modelvertices do
				(
					tvert  = getvert actor v
					Writefloat f (floatswap2 1)
					Writefloat f (floatswap2 1)
				)
			)

			Writelong f (swaplong 53) --start of faces index
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
			nbfaces = getNumfaces actor
			writelong f (swaplong nbfaces)
			for i = 1 to nbfaces do
			(
				if tvcount > 0 then face = getTVFace actor i
				else face = getFace actor i
				Writeshort f (swapshort ((face.x)-1))
				Writeshort f (swapshort ((face.y)-1))
				Writeshort f (swapshort ((face.z)-1))
				-- time for the smoothing groups
				sgroup = getFaceSmoothGroup actor i
				writeshort f (swapshort(sgroup))
				-- here we define the number of edges within a polygon... lets see if it works...
				
				edgevis1 = getedgevis actor i 1
				edgevis2 = getedgevis actor i 2
				edgevis3 = getedgevis actor i 3
				
				invisibleedges = 0
				if edgevis1 == false do invisibleedges = 1
				if edgevis2 == false do invisibleedges = 2
				if edgevis1 == false and edgevis2 == false do invisibleedges = 3
				if edgevis3 == false do invisibleedges = 4
				if edgevis3 == false and edgevis1 == false do invisibleedges = 5
				if edgevis3 == false and edgevis2 == false do invisibleedges = 6
				if edgevis3 == false and edgevis2 == false and edgevis1 == false do invisibleedges = 7
				
				Writebyte f invisibleedges --quad group! how to do this!?
			)
			matname = a.material
			
			-- from here we define what kind of material the object has, multi, standard or no material (for which we will make a defaultmat)
			if classof matname == multimaterial do
			(
				nrmultisubs = matname.numsubs
				Writelong f (swaplong 22) --start of material names
				Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
				
				usedmatids = #() --if missing matid is present, skip it
				nbfaces = getNumFaces actor
				for i = 1 to nbfaces do
				(
					facematid = getfacematid actor i --get the face id
					usedmatsubname = matname[facematid]
					if usedmatsubname != undefined do
					(
						if (finditem usedmatids usedmatsubname) == 0 do
						(
							append usedmatids usedmatsubname
						)
					)
				)
				Writelong f (swaplong usedmatids.count) --number of material names
				for i = 1 to usedmatids.count do
				(
					if usedmatids[i] == undefined then
					(
						WriteString f ""
					)
					else
					(
						subname = usedmatids[i].name
						WriteString f subname
					)
				)
			)
			
			if classof matname == standardmaterial do
			(
				Writelong f (swaplong 22) --start of material names
				Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
				Writelong f (swaplong 1)
				Writestring f matname.name
			)
			
			if classof matname == undefinedclass do
			(
				writelong f (swaplong 22)
				writelong f (swaplong 0)
				writelong f (swaplong 1)
				dummy_material = standard()
				dummy_material.diffuse = a.wirecolor
				colorarray = [(a.wirecolor.r as integer),(a.wirecolor.g as integer),(a.wirecolor.b as integer)]
				dummy_material.name = ("default_" + (diffusematerials.count as string))
				if finditem diffusecolors colorarray == 0 then
				(
					dummy_material.name = ("default_" + (diffusematerials.count as string))
					append diffusematerials dummy_material
					append diffusecolors colorarray
				)
				else
				(
					dummy_material.name = diffusematerials[finditem diffusecolors colorarray].name
				)
				Writestring f dummy_material.name
			)
			
			Writelong f (swaplong 26) --start of face materials
			Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
			nbfaces = getNumFaces actor
			Writelong f (swaplong nbfaces)
			Writelong f (swaplong 2)
			
			for i = 1 to nbfaces do
			(
				matname = a.material
				if classof matname == multimaterial then
				(
					facematid = getfacematid actor i --get the face id
					usedmatsubname = matname[facematid]
					foundindex = finditem usedmatids usedmatsubname
					
					Writeshort f (swapshort foundindex)
				)
				else
				(
					writeshort f (swapshort 1)
				)
			)
			Writelong f 0 --8 null bytes after every model entry
			Writelong f 0
			fclose f
			
			if objectprefix == "&" do
			(
				a.transform = objecttmbackup
				--actor.transform = objecttmbackup
			)
		)
		catch 
		(
			objectprefix=substring a.name 1 1
			if objectprefix == "&" do
			(
				a.transform = objecttmbackup
				--actor.transform = objecttmbackup
			)
			format "error exporting model %\n" a.name to:log_file
			errorbox.name = a.name
			errorbox.transform = a.transform
			writemodelentry errorbox
			errorbox.pos = [0,0,0]
		)
	)
	
	fn writesplinemodel a =
	(
		model = a
		model_knots = numknots model
		model_splines = numsplines model
		segment_knots = #()
		model_segments = #()
		for i=1 to model_splines do
		(
			segment_knots[i] = numknots model i
			model_segments[i] = numsegments model i
		)
		knotindex = 0
		spline_knots = #()
		for i=1 to model_splines do
		(
			spline_knots_i = #()
			for j=1 to (numknots model i) do
			(
				append spline_knots_i knotindex
				knotindex = knotindex + 1
			)
			spline_knots[i] = spline_knots_i
		)
		
		f=fopen dat_name "ab" --write a dummy box object
		
		WriteLong f (swaplong 54) --start of modelname
		Writelong f (swaplong 12)
		WriteByte f 1
		WriteByte f 21
		writeString f model.name

		WriteLong f (swaplong 23) --start of vertice index
		Writelong f (swaplong 0)
		writelong f (swaplong model_knots)
		for i=1 to model_splines do
		(
			for j=1 to segment_knots[i] do
			(
				knot = getknotpoint model i j
				writefloat f (floatswap2 knot.x)
				writefloat f (floatswap2 knot.z)
				writefloat f (floatswap2 -knot.y)
			)
		)

		Writelong f (swaplong 24) --start of texture coordinates
		Writelong f (swaplong 0)
		Writelong f (swaplong model_knots)
		for i=1 to model_splines do
		(
			for j=1 to segment_knots[i] do
			(
				Writefloat f (floatswap2 1)
				Writefloat f (floatswap2 1)
			)
		)

		Writelong f (swaplong 53) --start of faces index
		Writelong f (swaplong 0)
		total_segments = 0
		for j=1 to model_splines do
		(
			segments = model_segments[j]
			total_segments =  total_segments + segments 
		)
		writelong f (swaplong total_segments)
		model_splines = numsplines model
		knotindex = 0
		for j=1 to model_splines do
		(
			model_segments = numsegments model j
			for k=1 to model_segments do
			(
				writeshort f (swapshort ((spline_knots[j])[k]))
				if (spline_knots[j])[k+1] == undefined then
				(
					writeshort f (swapshort ((spline_knots[j])[1]))
					writeshort f (swapshort ((spline_knots[j])[1]))
				)
				else 
				(
					writeshort f (swapshort ((spline_knots[j])[k+1]))
					writeshort f (swapshort ((spline_knots[j])[k+1]))
				)
				writeshort f (swapshort(0)) --smoothing groups
				Writebyte f 4 --quad index
			)
		)
		
		matname = a.material
		
		if classof matname == undefinedclass do
		(
			writelong f (swaplong 22)
			writelong f (swaplong 0)
			writelong f (swaplong 1)
			dummy_material = standard()
			dummy_material.diffuse = a.wirecolor
			colorarray = [(a.wirecolor.r as integer),(a.wirecolor.g as integer),(a.wirecolor.b as integer)]
			dummy_material.name = ("default_" + (diffusematerials.count as string))
			if finditem diffusecolors colorarray == 0 then
			(
				dummy_material.name = ("default_" + (diffusematerials.count as string))
				append diffusematerials dummy_material
				append diffusecolors colorarray
			)
			else
			(
				dummy_material.name = diffusematerials[finditem diffusecolors colorarray].name
			)
			Writestring f dummy_material.name
		)
		
		Writelong f (swaplong 26) --start of face materials
		Writelong f (swaplong 0)--actually the lenght byte, but ignored by game and pt2
		
		model_splines = numsplines model
		model_segments = 0
		for j=1 to model_splines do
		(
			model_segments += numsegments model j
		)
		Writelong f (swaplong model_segments)
		Writelong f (swaplong 2)
		for i=1 to model_segments do
		(
			writeshort f (swapshort 1)
		)
		
		Writelong f 0 --8 null bytes after every model entry
		Writelong f 0
		fclose f
	)
	
	f=fopen dat_name "wb" --write dat file header
	WriteLong f (swaplong 18)
	WriteLong f (swaplong 8)
	Writeshort f 0
	Writebyte f 250
	writebyte f 206
	WriteLong f (swaplong 2)
	fclose f --end dat file header
	
	for object in exportmodels do
	(
		if not(isGrouphead object) and not (object.ishidden) do
		(
			if classof object == editable_poly  or classof object == editable_mesh do writemodelentry object
			--if classof object == editable_mesh do writemodelentry objectcopy
			objectcopy = snapshot object
			objectcopy.wirecolor = object.wirecolor
			objectcopy.name = object.name
			--if classof object == editable_poly  do	writemodelentry objectcopy
			--if classof object == editable_mesh do writemodelentry objectcopy
			if classof object == PolyMeshObject do writemodelentry objectcopy
			if classof object == line do writesplinemodel object
			if classof object == SplineShape do writesplinemodel object
			delete objectcopy
		)
		progresitem+=1
		progressUpdate (100./exportitems*progresitem)
		--delete errorbox --delete the errorbox dummy
	)

	--MATERIALS

	fn writematerialbase f = --material export function
	(
		f=fopen mat_name "ab"
		
		WriteLong f (swaplong 60) --start of material name and attributes
		WriteLong f (swaplong 80) --lenght byte unused
		Writebyte f (matdiffuse.r) --diffuse colour
		Writebyte f (matdiffuse.g)
		Writebyte f (matdiffuse.b)
		writebyte f (255)
		Writefloat f (floatswap2 matambient) --aimbient lighting
		Writefloat f (floatswap2 matdirect) --directional lighting
		Writefloat f (floatswap2 matspecular) --specular lighting
		Writefloat f (floatswap2 matspecularlevel) --SPECUALR LEVEL DEFAULT 20
		
		Writelong f (swaplong flags) -- flags
		WriteFloat f (floatswap2 1) --flags for mat type? 1 transformation matrix for materials
		WriteFloat f (floatswap2 0)
		WriteFloat f (floatswap2 0)
		WriteFloat f (floatswap2 1)
		WriteFloat f (floatswap2 0)
		WriteFloat f (floatswap2 0)
		Writebyte f 10 --unknown 
		Writebyte f 31
		Writeshort f (swapshort 0)
		Writelong f (swaplong 0)
		Writelong f (swaplong 0)
		Writelong f (swaplong 0)
		Writebyte f 0
		WriteString f identifier
		if texture != undefinded do
		(
			Writelong f (swaplong 28)
			Writelong f (swaplong 10)
			WriteString f texture
		)
		Writelong f 0
		Writelong f 0
		fclose f
	)

	f=fopen mat_name "wb" --write the mat file header
	WriteLong f (swaplong 18)
	WriteLong f (swaplong 8)
	WriteLong f (swaplong 5)
	WriteLong f (swaplong 2)
	fclose f

	for i=1 to materials.count do --main materials loop
	(
		global matmaterial = materials[i]
		matname = materials[i]
		if matmaterial != undefined do
		(
			global matdiffuse = matname.diffuse
			if matname.ambientmapenable == true then
			(
				global matambient = (matname.ambientmapamount / 100)
			)
			else
			(
				global matambient = 0.175
			)
			global matdirect = 1.0
			
			if matname.specularmapenable == true then
			(
				global matspecular = (matname.specularmapamount /100)
			)
			else
			(
				global matspecular = 0
			)
			global matspecularlevel = matname.specularlevel
			global flags = 37 --standard flag value for smooth, lit and texture correct
			if matmaterial.twosided == true then 
				(
					flags = flags + 4096
				)
			global identifier = matname.name
			
			if matname.diffusemap == undefined then
			(
				global texture = undefined
			)
			else
			(
				global texture = getfilenamefile matname.diffusemap.filename
			)
			writematerialbase f
		)
		progresitem+=1
		progressUpdate (100./exportitems*progresitem)
	)
	for material in diffusematerials do --simple materials loop
	(
		global matdiffuse = material.diffuse
		global matambient = 0.175
		global matdirect = 1.0
		global matspecular = 0
		global matspecularlevel = 20
		global flags = 4096 --standard flag value for smooth, lit and texture correct
		global identifier = material.name
		global texture = undefined
		
		writematerialbase f
	)
	progressEnd()
	close log_file
	try delete errorbox catch()
)

--end