if groove_data_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_groove_attributes.ms") quiet:true
if checkpoint_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_checkpoint_attributes.ms") quiet:true 
if noncar_bboxdata_CA == undefined do	fileIn (scriptspath+"\\Carmatools\\carmatools_bbox_attributes.ms") quiet:true
if actor_rendermode_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_object_properties.ms") quiet:true
if Funk_data_CA  == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_funk_attributes.ms") quiet:true
if SEV_data_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_sevolume_attributes.ms") quiet:true
if Pedsped_data_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_pedspec_attributes.ms") quiet:true
if starting_grid_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_startinggrid_attributes.ms") quiet:true
if multiplayer_point_CA == undefined do fileIn (scriptspath+"\\Carmatools\\carmatools_startinggrid_attributes.ms") quiet:true

fn round f = 
(
	(((f * 1000000) as integer) as float / 1000000)
)

fn pathFilt o = (getuserprop o "CLASS" == "PATHNODE")
fn droneFilt o = (getuserprop o "CLASS" == "DRONENODE")

--the main menu for the track setup with the export button

rollout track_setup "Track Setup"
(
	subrollout track_setup_sub "Properties" offset:[-9,0] width:352 
	button export_tracktxt "Export TXT" pos:[9,670] across:2 width:130
	on export_tracktxt pressed do
	(
		fileIn (scriptspath+"\\Carmatools\\track_txt.ms") quiet:true
	)
	button export_track_models "Export ACT/DAT/MAT" pos:[150,670] widt:130
	on export_track_models pressed do
	(
		fileIn (scriptspath+"\\Carmatools\\Track_exporter.ms") quiet:true
	)
)

track_general_CA = attributes track_general_attributes 
attribID:#(0x6355c32d, 0x76c6fa01)
(
	parameters track_general_parameters 
	(
		main_directional_light_source type:#color default:[255,255,255]
		ambient_ambient_0 type:#float default:0.1
		ambient_diffuse_0 type:#float default:1.0
		ambient_ambient_1 type:#float default:0.1
		ambient_diffuse_1 type:#float default:1.0
		ambient_ambient_2 type:#float default:0.4
		ambient_diffuse_2 type:#float default:0.8
		
		mm_name_tab type:#stringtab tabSize:1 tabSizeVariable:true default:("-- default")
		
		mm_car_wall_friction_tab type:#floattab tabSize:1 tabSizeVariable:true default:(1.0)
		mm_tyre_road_friction_tab type:#floattab tabSize:1 tabSizeVariable:true default:(1.0)
		mm_downforce_tab type:#floattab tabSize:1 tabSizeVariable:true default:(1.0)
		mm_bumpiness_tab type:#floattab tabSize:1 tabSizeVariable:true default:(0.1)
		mm_tyre_sound_index_tab type:#inttab tabSize:1 tabSizeVariable:true default:(0)
		mm_crash_sound_index_tab type:#inttab tabSize:1 tabSizeVariable:true default:(0)
		mm_scrape_sound_index_tab type:#inttab tabSize:1 tabSizeVariable:true default:(0)
		mm_sparkyness_tab type:#inttab tabSize:1 tabSizeVariable:true default:(1)
		mm_expansionroom_tab type:#inttab tabSize:1 tabSizeVariable:true default:(1)
		mm_skidmark_tab type:#inttab tabSize:1 tabSizeVariable:true default:(1)
		
		material_modifiers_names type:#stringtab tabSize:1 tabSizeVariable:true default:("-- default")
		material_modifiers_selection type:#integer default:1
		material_modifiers_editmode type:#integer default:0
		
		tyre_dust_nametab type:#stringtab tabSize:1 tabSizeVariable:true  default:("default grass")
		tyre_dust_colortab type:#colortab tabSize:1 tabSizeVariable:true default:([61,84,33])
		tyre_dust_quarterstrengthtab type:#floattab tabSize:1 tabSizeVariable:true default:(0.25)
		tyre_dust_halfstrengthtab type:#floattab tabSize:1 tabSizeVariable:true default:(0.5)
		tyre_dust_threequarterstrengthtab type:#floattab tabSize:1 tabSizeVariable:true default:(0.75)
		
		horizon_bitmap_file type:#string default:"None"
		horizon_hor_repetitions type:#integer default:4
		horizon_ver_angle type:#integer default:60
		horizon_position type:#integer default:200
		horizon_depth_cue_mode type:#integer default:4
		horizon_depth_cue_color type:#color default:[255,255,255]
		horizon_fognear type:#integer default:4
		horizon_fogfar type:#integer default:0
		
		minimapbitmap type:#string default:"none"
		minimaptm type:#matrix3 default:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])
		
		opp_path_object type:#node
		drone_path_object type:#node
		
		noncar_list_param type:#stringtab tabSizeVariable:true tabSize:1
	) 
)

custattributes.add rootnode track_general_CA

rollout track_general_setup "General Track Setup"
(
	group "Global Lighting Data"
	(
		colorpicker main_directional_light_source "Light color:" color:[255,255,255] modal:false align:#right autodisplay:true enabled:false
		label ambient_ambient_0_label "When Ambient 0 - " across:3 enabled:false
		spinner ambient_ambient_0 "Ambient:" type:#float range:[0,99,0.1] scale: 0.1 fieldWidth:50 autodisplay:true enabled:false
		spinner ambient_diffuse_0 "Diffuse:" type:#float range:[0,99,1.0] scale: 0.1 fieldWidth:50 autodisplay:true enabled:false
		label ambient_ambient_1_label "When Ambient 1 - " across:3 enabled:false
		spinner ambient_ambient_1 "Ambient:" type:#float range:[0,99,0.1] scale: 0.1 fieldWidth:50 autodisplay:true enabled:false
		spinner ambient_diffuse_1 "Diffuse:" type:#float range:[0,99,1.0] scale: 0.1 fieldWidth:50 autodisplay:true enabled:false
		label ambient_ambient_2_label "Ambient / Diffuse - " across:3
		spinner ambient_ambient_2 "Ambient:" type:#float range:[0,99,0.1] scale: 0.1 fieldWidth:50 autodisplay:true
		spinner ambient_diffuse_2 "Diffuse:" type:#float range:[0,99,1.0] scale: 0.1 fieldWidth:50 autodisplay:true
		label ambient_label1 ""
		on main_directional_light_source changed new_col do rootnode.track_general_attributes.main_directional_light_source = new_col
		on ambient_ambient_0 changed val do rootnode.track_general_attributes.ambient_ambient_0 = val
		on ambient_diffuse_0 changed val do rootnode.track_general_attributes.ambient_diffuse_0 = val
		on ambient_ambient_1 changed val do rootnode.track_general_attributes.ambient_ambient_1 = val
		on ambient_diffuse_1 changed val do rootnode.track_general_attributes.ambient_diffuse_1 = val
		on ambient_ambient_2 changed val do 
		(
			rootnode.track_general_attributes.ambient_ambient_2 = val
			ambientcolor = (color (val*255) (val*255) (val*255))
		)
		on ambient_diffuse_2 changed val do 
		(
			rootnode.track_general_attributes.ambient_diffuse_2 = val
			lightTintColor = (color (val*255) (val*255) (val*255))
		)
	)
	group "Horizon settings"
	(
		label horizon_bitmap_label "Horizon texture as background:" across:2 align:#left offset:[0,3] 
		button horizon_bitmap_file "None" autodisplay:true width:155 align:#right tooltip:"Browse for a texture to use as horizon texture. Rightclick to remove"
		spinner horizontal_repetitions "Repetitions:" type:#integer range:[0,99,4] fieldWidth:30 align:#left across:3 autodisplay:true
		spinner vertical_angle "Angle:" type:#integer range:[0,180,60] fieldWidth:30 align:#center
		spinner horizon_position "px. from top:" type:#integer range:[0,256,200] fieldWidth:30 tooltip:"The position of the horizon as in number of pixels from the top of the texture" align:#right
		label horizon_depth_cue_label "Depth cue mode:" across:3 align:#left offset:[0,3]
		dropdownlist horizon_depth_cue items:#("NONE","DARK","FOG","COLOUR") selection:4 width:120 align:#center 
		colorpicker horizon_depth_cue_color "Color:" color:[255,255,255] modal:false align:#right width:92
		label horizon_fog_degree "Degree of fog:" align:#left enabled:true across:3
		spinner horizon_fognear_degree "Near:" type:#integer range:[0,16,4] fieldWidth:30 across:2 align:#center
		spinner horizon_fogfar_degree "Far:" type:#integer range:[0,16,0] fieldWidth:30 align:#right
		label horizon_label_1 ""
		
		on horizontal_repetitions changed val do rootnode.track_general_attributes.horizon_hor_repetitions = val
		on vertical_angle changed val do rootnode.track_general_attributes.horizon_ver_angle = val
		on horizon_position changed val do rootnode.track_general_attributes.horizon_position = val
		on horizon_depth_cue selected item do rootnode.track_general_attributes.horizon_depth_cue_mode = item
		on horizon_depth_cue_color changed new_col do rootnode.track_general_attributes.horizon_depth_cue_color = new_col
		on horizon_fognear_degree changed val do rootnode.track_general_attributes.horizon_fognear = val
		on horizon_fogfar_degree changed val do rootnode.track_general_attributes.horizon_fogfar = val
		
		on horizon_bitmap_file pressed do
		(
			bitmapname = getOpenFileName()
			if bitmapname != undefined do
			(
				bitmapname = getfilenamefile bitmapname
				horizon_bitmap_file.text = bitmapname
				rootnode.track_general_attributes.horizon_bitmap_file = bitmapname
			)
		)
		on horizon_bitmap_file rightclick do
		(
			horizon_bitmap_file.text = "None"
			rootnode.track_general_attributes.horizon_bitmap_file = "None"
		)
	)
	group "Material Modifiers"
	(
		label mm_label "select a modifier below to edit, or add an remove new ones" align:#left
		dropdownlist mm_list "" items:(rootnode.track_general_attributes.mm_name_tab as array) across:3 selection:1 width:150
		button mm_add "Add" offset:[38,0] width:70
		button mm_remove "Remove" offset:[17,0] width:70
		edittext mm_name "Reference name:" text:"default"
		spinner mm_car_wall_friction "Car wall friction:" range:[0,99,1] type:#float fieldwidth:50 across:2
		spinner mm_tyre_road_friction "Tyre road friction:" range:[0,99,1] type:#float fieldwidth:50
		spinner mm_downforce "Downforce:" range:[0,99,1] type:#float fieldwidth:50 across:2
		spinner mm_bumpiness "Bumpiness:" range:[0,99,0] type:#float fieldwidth:50
		spinner mm_tyre_sound_index "Tyre sound index:" range:[0,9999,0] type:#integer fieldwidth:50 across:2
		spinner mm_crash_sound_index "Crash sound index:" range:[0,9999,0] type:#integer fieldwidth:50
		spinner mm_scrape_sound_index "Scrape sound index:" range:[0,9999,0] type:#integer fieldwidth:50 across:2
		spinner mm_sparkyness "Tyre road friction:" range:[0,1,1] type:#integer fieldwidth:50
		spinner mm_expansionroom "Tyre dust type:" range:[0,99,1] type:#integer fieldwidth:50 across:2
		dropdownlist mm_skidmark "" items:#("SKIDMARK.MAT","DESKID.MAT","GIBSMEAR.MAT","MUD1.MAT","OILSMEAR.MAT","SNOWSKID.MAT") selection:1
		
		on mm_list selected i do
		(
			mm_name.text = rootnode.track_general_attributes.mm_name_tab[i]
			mm_car_wall_friction.range = [0,99,rootnode.track_general_attributes.mm_car_wall_friction_tab[i]]
			mm_tyre_road_friction.range = [0,99,rootnode.track_general_attributes.mm_tyre_road_friction_tab[i]]
			mm_downforce.range = [0,99,rootnode.track_general_attributes.mm_downforce_tab[i]]
			mm_bumpiness.range = [0,99,rootnode.track_general_attributes.mm_bumpiness_tab[i]]
			mm_tyre_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_tyre_sound_index_tab[i]]
			mm_crash_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_crash_sound_index_tab[i]]
			mm_scrape_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_scrape_sound_index_tab[i]]
			mm_sparkyness.range = [0,1,rootnode.track_general_attributes.mm_sparkyness_tab[i]]
			mm_expansionroom.range = [0,99,rootnode.track_general_attributes.mm_expansionroom_tab[i]]
			mm_skidmark.selection = rootnode.track_general_attributes.mm_skidmark_tab[i]
		)
		
		on mm_name entered txt do 
		(
			rootnode.track_general_attributes.mm_name_tab[mm_list.selection] = txt
			mm_names = rootnode.track_general_attributes.mm_name_tab
			mm_listnames = #("-- default")
			for i = 2 to mm_names.count do
			(
				if i<10 then
				(
					mmname = "0" + (i-2)as string + " "+ mm_names[i] as string
					append mm_listnames mmname
				)
				else 
				(
					mmname = (i-2)as string + " "+ mm_names[i] as string
					append mm_listnames mmname
				)
			)
			mm_list.items = mm_listnames as array
		)
		on mm_car_wall_friction changed val do rootnode.track_general_attributes.mm_car_wall_friction_tab[mm_list.selection] = val
		on mm_tyre_road_friction changed val do rootnode.track_general_attributes.mm_tyre_road_friction_tab[mm_list.selection] = val
		on mm_downforce changed val do rootnode.track_general_attributes.mm_downforce_tab[mm_list.selection] = val
		on mm_bumpiness changed val do rootnode.track_general_attributes.mm_bumpiness_tab[mm_list.selection] = val
		on mm_tyre_sound_index changed val do rootnode.track_general_attributes.mm_tyre_sound_index_tab[mm_list.selection] = val
		on mm_crash_sound_index changed val do rootnode.track_general_attributes.mm_crash_sound_index_tab[mm_list.selection] = val
		on mm_scrape_sound_index changed val do rootnode.track_general_attributes.mm_scrape_sound_index_tab[mm_list.selection] = val
		on mm_sparkyness changed val do rootnode.track_general_attributes.mm_sparkyness_tab[mm_list.selection] = val
		on mm_expansionroom changed val do rootnode.track_general_attributes.mm_expansionroom_tab[mm_list.selection] = val
		on mm_skidmark selected i do rootnode.track_general_attributes.mm_skidmark_tab[mm_list.selection] = i
		
		on mm_add pressed do
		(
			mm_count = mm_list.items.count
			mmname = "new mat modifier"
			append rootnode.track_general_attributes.mm_name_tab mmname
			append rootnode.track_general_attributes.mm_car_wall_friction_tab 1.0
			append rootnode.track_general_attributes.mm_tyre_road_friction_tab 1.0
			append rootnode.track_general_attributes.mm_downforce_tab 1.0
			append rootnode.track_general_attributes.mm_bumpiness_tab 0.0
			append rootnode.track_general_attributes.mm_tyre_sound_index_tab 0
			append rootnode.track_general_attributes.mm_crash_sound_index_tab 0
			append rootnode.track_general_attributes.mm_scrape_sound_index_tab 0
			append rootnode.track_general_attributes.mm_sparkyness_tab 0
			append rootnode.track_general_attributes.mm_expansionroom_tab 1
			append rootnode.track_general_attributes.mm_skidmark_tab 1
			
			mm_names = rootnode.track_general_attributes.mm_name_tab
			mm_listnames = #("-- default")
			for i = 2 to mm_names.count do
			(
				if i<10 then
				(
					mmname = "0" + (i-2)as string + " "+ mm_names[i] as string
					append mm_listnames mmname
				)
				else 
				(
					mmname = (i-2)as string + " "+ mm_names[i] as string
					append mm_listnames mmname
				)
			)
			
			mm_list.items = mm_listnames as array
			--mm_list.items = (rootnode.track_general_attributes.mm_name_tab as array)
			mm_index = rootnode.track_general_attributes.mm_name_tab.count
			mm_list.selection = mm_index
			
			mm_name.text = rootnode.track_general_attributes.mm_name_tab[mm_index]
			mm_car_wall_friction.range = [0,99,rootnode.track_general_attributes.mm_car_wall_friction_tab[mm_index]]
			mm_tyre_road_friction.range = [0,99,rootnode.track_general_attributes.mm_tyre_road_friction_tab[mm_index]]
			mm_downforce.range = [0,99,rootnode.track_general_attributes.mm_downforce_tab[mm_index]]
			mm_bumpiness.range = [0,99,rootnode.track_general_attributes.mm_bumpiness_tab[mm_index]]
			mm_tyre_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_tyre_sound_index_tab[mm_index]]
			mm_crash_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_crash_sound_index_tab[mm_index]]
			mm_scrape_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_scrape_sound_index_tab[mm_index]]
			mm_sparkyness.range = [0,1,rootnode.track_general_attributes.mm_sparkyness_tab[mm_index]]
			mm_expansionroom.range = [0,99,rootnode.track_general_attributes.mm_expansionroom_tab[mm_index]]
			mm_skidmark.selection = rootnode.track_general_attributes.mm_skidmark_tab[mm_index]
		)
		on mm_remove pressed do
		(
			if mm_list.selection != 1 do
			(
				deleteitem rootnode.track_general_attributes.mm_name_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_car_wall_friction_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_tyre_road_friction_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_downforce_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_bumpiness_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_tyre_sound_index_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_crash_sound_index_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_scrape_sound_index_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_sparkyness_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_expansionroom_tab mm_list.selection
				deleteitem rootnode.track_general_attributes.mm_skidmark_tab mm_list.selection
				
				
				mm_name.text = rootnode.track_general_attributes.mm_name_tab[1]
				mm_car_wall_friction.range = [0,99,rootnode.track_general_attributes.mm_car_wall_friction_tab[1]]
				mm_tyre_road_friction.range = [0,99,rootnode.track_general_attributes.mm_tyre_road_friction_tab[1]]
				mm_downforce.range = [0,99,rootnode.track_general_attributes.mm_downforce_tab[1]]
				mm_bumpiness.range = [0,99,rootnode.track_general_attributes.mm_bumpiness_tab[1]]
				mm_tyre_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_tyre_sound_index_tab[1]]
				mm_crash_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_crash_sound_index_tab[1]]
				mm_scrape_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_scrape_sound_index_tab[1]]
				mm_sparkyness.range = [0,1,rootnode.track_general_attributes.mm_sparkyness_tab[1]]
				mm_expansionroom.range = [0,99,rootnode.track_general_attributes.mm_expansionroom_tab[1]]
				mm_skidmark.selection = rootnode.track_general_attributes.mm_skidmark_tab[1]
				
				mm_names = rootnode.track_general_attributes.mm_name_tab
				mm_listnames = #("-- default")
				for i = 2 to mm_names.count do
				(
					if i<10 then
					(
						mmname = "0" + (i-2)as string + " "+ mm_names[i] as string
						append mm_listnames mmname
					)
					else 
					(
						mmname = (i-2)as string + " "+ mm_names[i] as string
						append mm_listnames mmname
					)
				)
				
				mm_list.items = mm_listnames as array
				--mm_list.items = (rootnode.track_general_attributes.mm_name_tab as array)
				mm_list.selection = 1
			)
		)
	)
	
	group "Tyre dust types"
	(
		listbox tyre_dust_colors items:#() height:4 across:3
		button tyre_dust_add "Add" width:80
		button tyre_dust_remove "Remove" width:80
		edittext tyre_dust_name "Edit description:" width:180 offset:[128,-23]
		label tyre_dust_color_label "Dust color:" align:#left across:2 offset:[0,10]
		label tyre_dust_strengths "Strengh: quarter/half/three quarter" offset:[-20,10]
		colorpicker tyre_dust_color "" across:4 height:15
		spinner tyre_dust_quarterstrength width:50 range:[0,1,0.25]
		spinner tyre_dust_halfstrength width:50 range:[0,1,0.5]
		spinner tyre_dust_threequarterstrength width:50 range:[0,1,0.75]
		label tyre_dust_label_1 ""
		
		on tyre_dust_name entered new_name do 
		(
			if tyre_dust_colors.selection > 3 do
			(
				rootnode.track_general_attributes.tyre_dust_nametab[tyre_dust_colors.selection] = new_name
				td_count = rootnode.track_general_attributes.tyre_dust_nametab.count
				td_names = #()
				for i = 1 to td_count do
				(
					td_name = (i-1)as string + " " + rootnode.track_general_attributes.tyre_dust_nametab[i]
					append td_names td_name
				)
				tyre_dust_colors.items =  td_names as array
			)
		)
		on tyre_dust_color changed new_col do 
		(
			if tyre_dust_colors.selection > 3 do
			(
				rootnode.track_general_attributes.tyre_dust_colortab[tyre_dust_colors.selection] = new_col
			)
		)
		on tyre_dust_quarterstrength changed val do
		(
			if tyre_dust_colors.selection > 3 do
			(
				rootnode.track_general_attributes.tyre_dust_quarterstrengthtab[tyre_dust_colors.selection] = val
			)
		)		
		on tyre_dust_halfstrength changed val do 
		(
			if tyre_dust_colors.selection > 3 do
			(
				rootnode.track_general_attributes.tyre_dust_halfstrengthtab[tyre_dust_colors.selection] = val
			)
		)		
		on tyre_dust_threequarterstrength changed val do 
		(
			if tyre_dust_colors.selection > 3 do
			(
				rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab[tyre_dust_colors.selection] = val
			)
		)		
		on tyre_dust_colors selected i do
		(
			tyre_dust_name.text = rootnode.track_general_attributes.tyre_dust_nametab[i]
			tyre_dust_color.color = rootnode.track_general_attributes.tyre_dust_colortab[i]
			tyre_dust_quarterstrength.range = [0,1,(rootnode.track_general_attributes.tyre_dust_quarterstrengthtab[i] as float)]
			tyre_dust_halfstrength.range = [0,1,(rootnode.track_general_attributes.tyre_dust_halfstrengthtab[i] as float)]
			tyre_dust_threequarterstrength.range = [0,1,(rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab[i] as float)]
		)
		
		on tyre_dust_add pressed do
		(
			
			append rootnode.track_general_attributes.tyre_dust_nametab "new dust type"
			append rootnode.track_general_attributes.tyre_dust_colortab tyre_dust_color.color
			append rootnode.track_general_attributes.tyre_dust_quarterstrengthtab tyre_dust_quarterstrength.value
			append rootnode.track_general_attributes.tyre_dust_halfstrengthtab tyre_dust_halfstrength.value
			append rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab tyre_dust_threequarterstrength.value
			td_count = rootnode.track_general_attributes.tyre_dust_nametab.count
			td_names = #()
			for i = 1 to td_count do
			(
				td_name = (i-1)as string + " " + rootnode.track_general_attributes.tyre_dust_nametab[i]
				append td_names td_name
			)
			tyre_dust_colors.items =  td_names as array
		)
		on tyre_dust_remove pressed do
		(
			if tyre_dust_colors.selection > 3 do
			(
				deleteitem rootnode.track_general_attributes.tyre_dust_nametab tyre_dust_colors.selection
				deleteitem rootnode.track_general_attributes.tyre_dust_colortab tyre_dust_colors.selection
				deleteitem rootnode.track_general_attributes.tyre_dust_quarterstrengthtab tyre_dust_colors.selection
				deleteitem rootnode.track_general_attributes.tyre_dust_halfstrengthtab tyre_dust_colors.selection
				deleteitem rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab tyre_dust_colors.selection
				td_count = rootnode.track_general_attributes.tyre_dust_nametab.count
				td_names = #()
				for i = 1 to td_count do
				(
					td_name = (i-1)as string + " " + rootnode.track_general_attributes.tyre_dust_nametab[i]
					append td_names td_name
				)
				tyre_dust_colors.items =  td_names as array
			)
		)
	)
	group "Splash files"
	(
		label splash_files_label "not integrated yet"
	)
	on track_general_setup open do
	(
		main_directional_light_source.color = rootnode.track_general_attributes.main_directional_light_source
		ambient_ambient_0.range = [0,99,( rootnode.track_general_attributes.ambient_ambient_0)]
		ambient_diffuse_0.range = [0,99,( rootnode.track_general_attributes.ambient_diffuse_0)]
		ambient_ambient_1.range = [0,99,( rootnode.track_general_attributes.ambient_ambient_1)]
		ambient_diffuse_1.range = [0,99,( rootnode.track_general_attributes.ambient_diffuse_1)]
		ambient_ambient_2.range = [0,99,( rootnode.track_general_attributes.ambient_ambient_2)]
		ambient_diffuse_2.range = [0,99,( rootnode.track_general_attributes.ambient_diffuse_2)]
		
		horizon_bitmap_file.text = rootnode.track_general_attributes.horizon_bitmap_file
		horizontal_repetitions.range = [0,99,( rootnode.track_general_attributes.horizon_hor_repetitions)]
		vertical_angle.range = [0,180,(rootnode.track_general_attributes.horizon_ver_angle)]
		horizon_position.range = [0,256, (rootnode.track_general_attributes.horizon_position)]
		horizon_depth_cue.selection = rootnode.track_general_attributes.horizon_depth_cue_mode
		horizon_depth_cue_color.color =  rootnode.track_general_attributes.horizon_depth_cue_color
		horizon_fognear_degree.range = [0,16,(rootnode.track_general_attributes.horizon_fognear)]
		horizon_fogfar_degree.range = [0,16,(rootnode.track_general_attributes.horizon_fogfar)]
		
		mm_name.text = rootnode.track_general_attributes.mm_name_tab[1]
		mm_car_wall_friction.range = [0,99,rootnode.track_general_attributes.mm_car_wall_friction_tab[1]]
		mm_tyre_road_friction.range = [0,99,rootnode.track_general_attributes.mm_tyre_road_friction_tab[1]]
		mm_downforce.range = [0,99,rootnode.track_general_attributes.mm_downforce_tab[1]]
		mm_bumpiness.range = [0,99,rootnode.track_general_attributes.mm_bumpiness_tab[1]]
		mm_tyre_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_tyre_sound_index_tab[1]]
		mm_crash_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_crash_sound_index_tab[1]]
		mm_scrape_sound_index.range = [0,9999,rootnode.track_general_attributes.mm_scrape_sound_index_tab[1]]
		mm_sparkyness.range = [0,1,rootnode.track_general_attributes.mm_sparkyness_tab[1]]
		mm_expansionroom.range = [0,99,rootnode.track_general_attributes.mm_expansionroom_tab[1]]
		mm_skidmark.selection = rootnode.track_general_attributes.mm_skidmark_tab[1]
		mm_names = rootnode.track_general_attributes.mm_name_tab
		mm_listnames = #("-- default")
		for i = 2 to mm_names.count do
		(
			if i<10 then
			(
				mmname = "0" + (i-2)as string + " "+ mm_names[i] as string
				append mm_listnames mmname
			)
			else 
			(
				mmname = (i-2)as string + " "+ mm_names[i] as string
				append mm_listnames mmname
			)
		)
		mm_list.items = mm_listnames as array
		
		rootnode.track_general_attributes.tyre_dust_nametab[2] = "default mud"
		rootnode.track_general_attributes.tyre_dust_colortab[2] = [92,51,34]
		rootnode.track_general_attributes.tyre_dust_quarterstrengthtab[2] = 0.25
		rootnode.track_general_attributes.tyre_dust_halfstrengthtab[2] = 0.5
		rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab[2] = 0.75
		rootnode.track_general_attributes.tyre_dust_nametab[3] = "default sand"
		rootnode.track_general_attributes.tyre_dust_colortab[3] = [227,209,143]
		rootnode.track_general_attributes.tyre_dust_quarterstrengthtab[3] = 0.25
		rootnode.track_general_attributes.tyre_dust_halfstrengthtab[3] = 0.5
		rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab[3] = 0.75
		
		td_count = rootnode.track_general_attributes.tyre_dust_nametab.count
		td_names = #()
		for i = 1 to td_count do
		(
			td_name = (i-1)as string + " " + rootnode.track_general_attributes.tyre_dust_nametab[i]
			append td_names td_name
		)
		tyre_dust_colors.items =  td_names as array
		
		tyre_dust_name.text = rootnode.track_general_attributes.tyre_dust_nametab[1]
		tyre_dust_color.color = rootnode.track_general_attributes.tyre_dust_colortab[1]
		tyre_dust_quarterstrength.range = [0,1,(rootnode.track_general_attributes.tyre_dust_quarterstrengthtab[1])]
		tyre_dust_halfstrength.range = [0,1,(rootnode.track_general_attributes.tyre_dust_halfstrengthtab[1])]
		tyre_dust_threequarterstrength.range = [0,1,(rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab[1])]
		
	)
)

rollout track_noncar_setup "Noncar Setup"
(
	group "Noncar attributes"
	(
		button launch_setup "Noncar Setup tool" align:#left width:153
		on launch_setup pressed do
		(
			try ( fileIn (scriptspath+"\\Carmatools\\carmatools_noncar_setup.ms") quiet:true   )
			catch()
		)
		listbox noncar_list "Included noncar txt files" height:8
		button include_noncar "Include noncar" width:153 align:#left across:2
		button remove_noncar "Remove noncar" width:153 align:#right
		on include_noncar pressed do
		(
			noncarfile = getOpenFileName() 
			if noncarfile != undefined do
			(
				noncarname = getfilenamefile noncarfile
				if rootnode.track_general_attributes.noncar_list_param[1] == undefined then
				(
					rootnode.track_general_attributes.noncar_list_param[1] = noncarname
					noncar_list.items  = rootnode.track_general_attributes.noncar_list_param as array
				)
				else
				(
					append rootnode.track_general_attributes.noncar_list_param noncarname
					noncar_list.items  = rootnode.track_general_attributes.noncar_list_param as array
				)
			)
		)
		on remove_noncar pressed do
		(
			try deleteitem rootnode.track_general_attributes.noncar_list_param noncar_list.selection catch()
			noncar_list.items = rootnode.track_general_attributes.noncar_list_param as array
		)
	)
	on track_noncar_setup open do
	(
		try noncar_list.items = rootnode.track_general_attributes.noncar_list_param as array catch()
	)
)

rollout track_map_details "Map Details"
(
	group "properties"
	(
		button generate_bitmap "Generate bitmap" tooltip:"Generate a bitmap of the current track scene OR the selection" width:140 enabled:true across:3 offset:[28,0]
		label map_rotation_label "Map rotation" offset:[30,3]
		dropdownlist map_rotation  items:#("0","90","180","270") seleciton:1 width:80 align:#right
		label minimap_file_label "map file:" across:2
		label minimap_file_label2 ""
		on generate_bitmap pressed do
		(
			minimap = BitMap 640 480 color:black filename:".tif"
			if selection[1] == undefined then
			(
				renderobjects = objects
			)
			else
			(
				renderobjects = selection
			)
			--create a camera
			orthoCamera = freecamera pos:[renderobjects.center.x,renderobjects.center.y,1] orthoProjection:true 
			orthoCamera.Target_Distance = 1.0f
			if map_rotation.selection == 1 or map_rotation.selection == 3 then
			(
				global horBounds = renderobjects.max.x - renderobjects.min.x
				global vertBounds =  renderobjects.max.y - renderobjects.min.y
			)
			else 
			(
				global vertBounds = renderobjects.max.x - renderobjects.min.x
				global horBounds =  renderobjects.max.y - renderobjects.min.y
			)
			r_aspect=(renderHeight as float)/renderwidth
			global horizontalFov = 2.0 * (atan(horbounds/2))
			global verticalFov = 2.0*atan(tan((2* (atan (vertbounds/2 )))/2.0)/r_aspect)
			
			--taking the vertical bounds as leading
			if horizontalFov < verticalFov or horizontalFov == verticalFov do
			(
				orthoCamera.fovtype = 2
				orthoCamera.fov = verticalFov
				global image_ratio = 480 / (vertBounds)
			)
			--taking the horizontal bounds as leading
			if horizontalFov > verticalFov do
			(
				orthoCamera.fovtype = 1
				orthoCamera.fov = horizontalFov
				global image_ratio = 640 / (horBounds)
			)
			orthocamera.rotation.z_rotation = (map_rotation.selected as integer)
			
			
			--do the actual render
			render camera:orthoCamera to:minimap progressbar:on vfb:off
			global minimapfilename = GetSaveFileName caption:"Choose an exportname" types:"Tif(*.tif)"
			if minimapfilename != undefined do
			(
				minimap.filename = (minimapfilename)
				save minimap
				rootnode.track_general_attributes.minimapbitmap = minimapfilename
				if map_rotation.selection == 1 do
				(
					minimaptm = matrix3 [image_ratio,0,0] [0,0,0] [0,image_ratio,0] [(320 - (renderobjects.center.x * image_ratio)),(240 + (renderobjects.center.y * image_ratio)),0]
				)
				if map_rotation.selection == 2 do
				(
					minimaptm = matrix3 [0,image_ratio,0] [0,0,0] [-image_ratio,0,0] [(320 - (renderobjects.center.y * image_ratio)),(240 - (renderobjects.center.x * image_ratio)),0]
				)
				if map_rotation.selection == 3 do
				(
					minimaptm = matrix3 [-image_ratio,0,0] [0,0,0] [0,-image_ratio,0] [(320 + (renderobjects.center.x * image_ratio)),(240 - (renderobjects.center.y * image_ratio)),0]
				)
				if map_rotation.selection == 4 do
				(
					minimaptm = matrix3 [0,-image_ratio,0] [0,0,0] [image_ratio,0,0] [(320 + (renderobjects.center.y * image_ratio)),(240 + (renderobjects.center.x * image_ratio)),0]
				)
				
				rootnode.track_general_attributes.minimaptm = minimaptm
			)
			delete orthoCamera
		)
		button preview_bitmap "View minimap" across:2 width:140
		on preview_bitmap pressed do
		(
			if rootnode.track_general_attributes.minimapbitmap != "none" then
			(
				rollout minimap_rollout "Minimap"
				(
					bitmap minimap pos:[0,0] width:640 height:480 bitmap:texturemap filename:rootnode.track_general_attributes.minimapbitmap
				)
				createdialog minimap_rollout 640 480
			)
			else
			(
				messageBox "No minimap set"
			)
		)
		button remove_bitmap "Remove minimap" width:140
		on remove_bitmap pressed do
		(
			rootnode.track_general_attributes.minimapbitmap = "none"
			minimap_file_label2 = ""
		)
		on track_map_details open do
		(
			if rootnode.track_general_attributes.minimapbitmap != "none" do
			(
				try minimap_file_label2.text = getfilenamefile rootnode.track_general_attributes.minimapbitmap catch()
			)
		)
	)
)

rollout track_helper_setup "Track Helper properties"
(
	group "Create Helper object"
	(
		button create_Startinggrid "Startinggrid" align:#left width:153 across:2
		on create_Startinggrid pressed do
		(
			Startinggrid = #()
			for object in objects do
			(
				if custAttributes.count object != 0 do
				(
					for j=1 to (custAttributes.count object) do
					(
						if custAttributes.get object starting_grid_CA != undefined  do
						(
							startinggrid[1] = object
						)
					)
				)
			)
			if Startinggrid[1] == undefined do
			(
				tool startinggrid_tool
				(
					local starting_grid_mesh
					local vertsArray = #([-0.125,-0.280637,0],[0.125,-0.280637,0],[-0.125,0.276376,0],[0.125,0.276376,0],[-1.125,-0.221494,0],[-1.125,-0.778506,0],[-0.875,-0.778506,0],[-0.875,-0.221494,0],[-0.125,-1.72362,0],[-0.125,-2.28064,0],[0.125,-2.28064,0],[0.125,-1.72362,0],[-1.125,-2.22149,0],[-1.125,-2.77851,0],[-0.875,-2.77851,0],[-0.875,-2.22149,0],[-0.125,-3.72362,0],[-0.125,-4.28064,0],[0.125,-4.28064,0],[0.125,-3.72362,0],[-1.125,-4.22149,0],[-1.125,-4.77851,0],[-0.875,-4.77851,0],[-0.875,-4.22149,0],[-0.125,-5.72362,0],[-0.125,-6.28064,0],[0.125,-6.28064,0],[0.125,-5.72362,0],[-1.125,-6.22149,0],[-1.125,-6.77851,0],[-0.875,-6.77851,0],[-0.875,-6.22149,0],[-0.548498,0.396723,0],[-0.548498,0.276376,0],[-0.451502,0.276376,0],[-0.451502,0.396723,0],[-0.548498,0.396723,0],[-0.451502,0.396723,0],[-0.351502,0.396723,0],[-0.5,0.558548,0],[-0.648498,0.396723,0])
					local facesArray = #([4,3,1],[1,2,4],[8,5,6],[6,7,8],[12,9,10],[10,11,12],[16,13,14],[14,15,16],[20,17,18],[18,19,20],[24,21,22],[22,23,24],[28,25,26],[26,27,28],[32,29,30],[30,31,32],[34,35,36],[38,39,40],[36,38,40],[40,41,37],[40,37,33],[36,40,33],[34,36,33])
					local edgeVis = #(#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,false,false),#(true,true,false),#(false,true,false),#(false,false,false),#(false,false,true))
					fn createstartinggrid = 
					(
						in coordsys grid starting_grid_mesh = mesh vertices:vertsArray faces:facesArray pos:gridPoint wirecolor:(color 255 0 0)
						for face = 1 to edgeVis.count do
						for i = 1 to 3 do
						setEdgeVis starting_grid_mesh face i edgeVis[face][i]
						custattributes.add starting_grid_mesh starting_grid_CA
						starting_grid_mesh.name = "_starting_grid"
					)
					on mousePoint click do
					(
						if click == 1
						then
						(								
							createstartinggrid()
							select starting_grid_mesh
							#stop
						)
						else if p != undefined do (Startinggrid_helper.pos=worldPoint;Startinggrid_helper=undefined) #stop
					)
				)
				starttool startinggrid_tool
			)
			if Startinggrid[1] != undefined do
			(
				messagebox "Startinggrid helper already present in the scene"
				select Startinggrid[1]
			)
		)
		button create_mutliplayerpoint "Multiplayer startpoint" width:153
		on create_mutliplayerpoint pressed do
		(
			multiplayerpoints = #()
			for object in objects do
			(
				if custAttributes.get object multiplayer_point_CA != undefined  do
				(
					append multiplayerpoints object.name
				)
			)
			tool multiplayerpoint_tool
			(
				local multiplayerpoint
				
				local vertsarray = #([-0.125,-0.25,0],[0.125,-0.25,0],[-0.125,0.25,0],[0.125,0.25,0],[-0.048498,-0.0207384,0],[-0.048498,-0.141085,0],[0.048498,-0.141085,0],[0.048498,-0.0207384,0],[-0.048498,-0.0207384,0],[0.048498,-0.0207384,0],[0.148498,-0.0207384,0],[0,0.141087,0],[-0.148498,-0.0207384,0])
				local facesarray = #([1,2,4],[4,3,1],[6,7,8],[10,11,12],[8,10,12],[12,13,9],[12,9,5],[8,12,5],[6,8,5])
				local edgevis = #(#(true,true,false),#(true,true,false),#(true,true,false),#(true,true,false),#(true,false,false),#(true,true,false),#(false,true,false),#(false,false,false),#(false,false,true))
				fn createmultiplayerpoint =
				(
					in coordsys grid multiplayerpoint=mesh vertices:vertsarray faces:facesarray pos:gridPoint wirecolor:(color 255 0 0)
					for face = 1 to edgevis.count do
					for i = 1 to 3 do
					setEdgeVis multiplayerpoint face i edgeVis[face][i]
				)
				on mousePoint click do
				(
					if click == 1 do 
					(
						createmultiplayerpoint()
						select multiplayerpoint
						#stop
					)
				)
			)
			startTool multiplayerpoint_tool
			for object in selection do
			(
				object.name = ("_multiplayerpoint" + ((multiplayerpoints.count +1)as string))
				custattributes.add object multiplayer_point_CA
			)
		)
		button create_checkpoints "Checkpoints" width:153 align:#left across:2
		on create_checkpoints pressed do
		(
			checkpoints = #()
			for object in objects do
			(
				if custAttributes.count object != 0 do
				(
					for j=1 to (custAttributes.count object) do
					(
						if custAttributes.get object checkpoint_CA != undefined  do
						(
							append checkpoints object.name
						)
					)
				)
			)
			tool checkpoint_tool
			(
				local checkpoint, x, y ,z 
				local edgevis = #(#(true,true,false),#(true,true,false))
				fn createcheckpoint =
				(
					in coordsys grid checkpoint=mesh vertices:#([-0.5,0,-0.5],[0.5,0,-0.5],[-0.5,0,.5],[.5,0,.5]) faces:#([1,2,4],[4,3,1]) pos:gridPoint wirecolor:(color 255 0 0)
					for face = 1 to edgevis.count do
					for i = 1 to 3 do
					setEdgeVis checkpoint face i edgeVis[face][i]
				)
				on mousePoint click do
				(
					if click == 1 do 
					(
						createcheckpoint()
						select checkpoint
						#stop
					)
				)
			)
			startTool checkpoint_tool
			for object in selection do
			(
				custattributes.add object checkpoint_CA
				object.name = "_checkpoint" + ((checkpoints.count + 1)  as string)
			)
			--checkpoint = plane length:1 width:1 lengthsegs:1 widthsegs:1 name:("checkpoint"+ (checkpoints.count) as string)
			--converttopoly checkpoint
			--select checkpoint
			--for object in selection do
			--(
			--	custAttributes.add object checkpoint_CA
			--)
		)
		button create_specialeffectsvolume "Special Effects Volume" align:#right width:153
		on create_specialeffectsvolume pressed do
		(
			env_boxes = #()
			for object in objects do
			(
				if custAttributes.get object checkpoint_CA != undefined  do
				(
					append env_boxes object.name
				)
			)
			tool envboxtool
			(
				local envbox
				fn createenvbox = in coordsys grid envbox=box width:1 length:1 height:1 pos:gridPoint boxmode:true wirecolor:(color 255 0 0)
				on mousePoint click do
					case click of
					(
						1: createenvbox()
						3: (select envbox;#stop)
					)
				on mouseMove click do
					case click of
					(
						2: (envbox.width = gridDist.x; envbox.length = gridDist.y)
						3: envbox.height = gridDist.z
					)
			)
			startTool envboxtool
			for object in selection do
			(
				custattributes.add object SEV_data_CA
				object.name = "_envbox" + ((env_boxes.count + 1)  as string)
				converttopoly object
				object.boxmode = true
				setTransformLockFlags object #{4,5,6}
				
			)
		)
	)
	group "Apply object/material properties"
	(	
		button apply_smashables "Smashable" align:#left width:153 across:2
		button apply_ped_spawn "Ped Spawn" align:#right width:153
		on apply_ped_spawn pressed do
		(
			if medit.GetCurMtl() != undefined do
			(
				pickedmaterial = medit.GetCurMtl()
				custAttributes.add pickedmaterial Pedsped_data_CA
			)
		)
		on apply_ped_spawn rightclick do
		(
			if medit.GetCurMtl() != undefined do
			(
				pickedmaterial = medit.GetCurMtl()
				if custAttributes.count pickedmaterial != 0 do
				(
					for j=1 to (custAttributes.count pickedmaterial) do
					(
						if (custAttributes.get pickedmaterial j).name == "Pedspec_data" do
						(
							custAttributes.delete pickedmaterial Pedsped_data_CA
						)
					)
				)
			)
		)
		button apply_funks "Funk" align:#right width:153 across:2
		on apply_funks pressed do
		(
			if medit.GetCurMtl() != undefined do
			(
				pickedmaterial = medit.GetCurMtl()
				custAttributes.add pickedmaterial FUNK_data_CA
			)
		)
		on apply_funks rightclick do
		(
			if medit.GetCurMtl() != undefined do
			(
				pickedmaterial = medit.GetCurMtl()
				if custAttributes.get pickedmaterial Funk_data_CA != undefined do
				(
					custAttributes.delete pickedmaterial Funk_data_CA
				)
			)
		)
		button apply_groove "Groove" align:#right width:153
		on apply_groove pressed do
		(
			for object in selection do
			(
				custAttributes.add object Groove_data_CA
			)
		)
		on apply_groove rightclick do
		(
			for object in selection do
			(
				if custattributes.get object Groove_data_CA != undefined do
				(
					custAttributes.delete object Groove_data_CA
				)
			)
		)
	)
	group "AI paths"
	(
		label opppath_label "Opponent Paths" align:#center across:2
		label dronepath_label "Drone Paths" align:#center across:2
		pickbutton pick_opppath "Pick Spline" align:#left width:153 across:2
		on pick_opppath picked obj do
		(
			if (classof obj) == line do
			(
				rootnode.track_general_attributes.opp_path_object = obj
				obj.wirecolor = red
				pick_opppath.text = obj.name
			)
		)
		pickbutton pick_dronepath "Pick Spline" align:#right width:153
		on pick_dronepath picked obj do
		(
			if (classof obj) == line do
			(
				rootnode.track_general_attributes.drone_path_object = obj
				obj.wirecolor = yellow
				pick_dronepath.text = obj.name
			)
		)	
	)
	on track_helper_setup open do
	(
		if rootnode.track_general_attributes.opp_path_object != undefined do
		(
			pick_opppath.text = rootnode.track_general_attributes.opp_path_object.name
		)
		if rootnode.track_general_attributes.drone_path_object != undefined do
		(
			pick_dronepath.text = rootnode.track_general_attributes.drone_path_object.name
		)
	)
)

rollout general_object_setup "General object properties"
(
	button actor_rendermode "Actor render mode setup" align:#left width:153 across:2
	on actor_rendermode pressed do
	(
		for object in selection do
		(
			custattributes.add object actor_rendermode_CA
		)
	)
	on actor_rendermode rightclick do
	(
		for object in selection do
		(
			if custattributes.get object actor_rendermode_CA != undefined do
			(
				custAttributes.delete object actor_rendermode_CA
			)
		)
	)
)

destroydialog track_setup
CreateDialog track_setup 360 700

addsubrollout track_setup.track_setup_sub track_general_setup rolledUp:true
addsubrollout track_setup.track_setup_sub track_noncar_setup rolledUp:True
addsubrollout track_setup.track_setup_sub track_map_details rolledUp:false
addsubrollout track_setup.track_setup_sub track_helper_setup rolledUp:true
addsubrollout track_setup.track_setup_sub general_object_setup rolledUp:true

track_setup.track_setup_sub.height += 640

